/* bb_canonical.c: turn a brett name into the canonical form.
    Copyright (C) 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/

#include <ctype.h>

#include "config.h"
#include "libquark.h"
#include "brett_db.h"
#include "brett_int.h"

/*
BB_FUNCTION(Funktion,void,bb_canonical,
	[[(const char *from, char *to)]],[[
	Wandelt einen Gruppennamen in die @code{vergleichbare} Form.
	Alle Sonderzeichen werden in Punkte gewandelt, die Umlaute in
	Langform gewandelt und alle Grobuchstaben in Kleine gewandelt.
]])
)
*/
void
bb_canonical(const char *from, char *to)
{
	char *p;
	char *q;
	while (isspace(*from))
		from++;
	entumlauten(from,to);
	q=strlen(to)-1+to;
	while (q>to && isspace(*q))
		q--;
	q[1]=0;
	p=to;
	while (*p)
	{	
		if (isalpha(*p))
			*p=tolower(*p);
		else if (!isdigit(*p))
			*p='.';
		p++;
	}
}
