/* bb_drive: return the name of the drive the brett data are located on.
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

#include "config.h"
#include "libquark.h"

#include "brett_db.h"
#include "brett_int.h"

/*
BB_FUNCTION(Funktion,const char,brettdrive,(BRETTNR @var{nr}),[[
    Liefert den Buchstaben des Laufwerks zurck, auf dem die Daten des
    Brettes liegen. Unter Systemen, die nicht unter der Verwendung von
    Laufwerksbuchstaben leiden, wird generell Nullzeichen (ASCII-Null,
    Stringende geliefert). Das Nullzeichen wird auch zurckgeliefert
    wenn die Nummer ungltig ist.
]])
*/
const char brettdrive(BRETTNR nr)
{
	CHECK_BRETTNR(nr,return 0);
#ifdef HAVE_DOSDRIVES
	return br_ind[nr].brett->partition;
#else
	return 0;
#endif

} /* brettdrive */
