/* bb_ursprung.c: Ursprungsnetz eines Brettes zurckliefern.
    Copyright (C) 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <stddef.h> /* NULL */


#include "config.h"
#include "libquark.h"


#include "brett_db.h"

/*
BB_FUNCTION(Funktion,const char *,bb_ursprungsnetz,
[[(UWORD @var{ursprungsnetz})]],[[
    Liefert den Namen des Netzes @var{ursprungsnetz} zurck. Zur
    Zeit definiert sind:

@enumerate 0
@item Unbekannt
@item MausNet
@item UseNet
@item FidoNet
@item Z-Netz
@item MailingListe
@end enumerate

   Liefert NULL, wenn (@var{ursprungsnetz} auerhalb des definierten
   Bereichs ist.
]])
*/
const char * 
bb_ursprungsnetz(UWORD ursprungsnetz)
{
	switch(ursprungsnetz)
	{
	case 0: return "Unbekannt"; break;
	case 1: return "MausNet"; break;
	case 2: return "UseNet"; break;
	case 3: return "FidoNet"; break;
	case 4: return "Z-Netz"; break;
	case 5: return "MailingListe"; break;

	default: return NULL;
	}
}
