/* befehle3.c : gesammelte Kleinbefehle
    Copyright (C) 1994-1998 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "config.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <setjmp.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h> /* free */
#include "tomtcl.h"

#include "tomsysdep.h"
#include "prototyp.h"
#include "befehle.h"
#include "user.h"
#include "brett.h"
#include "msg.h"
#include "modem.h"
#include "terminal.h"
#include "tompaths.h"
#include "aktdata.h"
#include "box_conf.h"

extern USER user;
extern BRETTNR brettnrW;
extern BRETTINFO *br_ind;
extern int logout_modus;

extern BRETTART postfach_art;

extern BYTE
batchB,
offlineB;

extern int user_in_fd;


BOOLEAN bef_offline(const char *dummy TOM_ATTRIB_UNUSED)
{
	if (batchB)
	{
		set_status_line("Spezial-Logoff:");
		mbprintf("\r\n tsch, %s and let the BOX work\r\n\n",user.name);
		if (akt_connection.is_modem)
		{
			hangup_modem(user_in_fd);
			sleep(1);
			takeoff_modem(user_in_fd);
		}
		offlineB = TRUE;
		return TRUE;
	}
	mboutput("\r\n Dieser Befehl funktioniert nur im Batchbetrieb\r\n\n");
	return FALSE;

} /* bef_offline */

BOOLEAN bef_passwort(const char *dummy TOM_ATTRIB_UNUSED)
{
	BOOLEAN dummy2;
	if (passwort_aenderung(&user,&dummy2))
	{
		ub_write_user(&user,FALSE);
		return TRUE;
	}
	return FALSE;
} /* bef_passwort */



BOOLEAN bef_postfach(const char *dummy TOM_ATTRIB_UNUSED)
{
#if 0
	if (level()==0)
		return bef_userantrag(dummy);
	else
#endif
	{
		if (brettnrW || postfach_art != TEXT_BRETT)
			set_status_line("Postfach");
		brettnrW = 0;
		/* br_ind[0].name = user.name; ### */
		postfach_art = TEXT_BRETT;
		redraw_status();

		return TRUE;
	}
} /* bef_postfach */



BOOLEAN bef_programmfach(const char *dummy TOM_ATTRIB_UNUSED)
{
#if 0
	if (level()==0)
		return bef_userantrag(dummy);
	else
#endif
	{
		if (brettnrW || postfach_art != BINAER_BRETT)
			set_status_line("Programmfach");
		brettnrW = 0;
		/* br_ind[0].name = user.name; ### */
		postfach_art = BINAER_BRETT;
		redraw_status();

		return TRUE;
	}
} /* bef_programmfach */



/*
	19.01.93 Frank, berarbeitet, sollte jetzt funktionieren
*/
BOOLEAN bef_protokoll(const char *para)
{
	int t,m,j;
	int old_scroll;
	char prot[PATH_MAX];

	if (!zerlege_datum((*para) ? para : dd_mm_yy(),&t,&m,&j))
	{
		parameter_falsch("PROTOKOLL",para);
		return FALSE;
	}

	sprintf(prot,"%s%02d_%02d_%02d.log",box_conf.log_dir,j,m,t);
	if (!fileexist(prot))
		strcat(prot,".gz");
	if (!fileexist(prot))
	{
		mbprintf(" Es ist kein Loginprotokoll fr den %d.%d.%d vorhanden\r\n\n",t,m,j);
		return FALSE;
	}

	set_status_line(tprintf("Loginprotokoll vom: %02d.%02d.%d",t,m,j));

/*	mbprintf(" %sAnruf  Username         Login Logoff  Online   Baud    Sen Les Upload  Downl  %s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF));*/
	mbprintf("  %sAnruf  Username                    Login -off  Online   Baud    %s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF));
	mbprintf(" %s\r\n",trennzeile);
	old_scroll=set_scroll_area(2);
	zeige_datei(prot);
	set_scroll_area(old_scroll);
	mboutput("\r\n");

	return TRUE;

} /* bef_protokoll */



BOOLEAN bef_reset(const char *dummy TOM_ATTRIB_UNUSED)
{
	int wahl;
	mboutput("\r\n Wollen sie die Box wirklich verlassen?\r\n");
	mboutput("  (N)ein\r\n");
	mboutput("  Ja, ohne das (L)ogindatum zu speichern\r\n");
	mboutput("  Ja, ohne die (B)enutzerdaten zu speichern\r\n");
	mboutput(" Ihre Wahl? (NLB): ");
	wahl=mbdecide("NLB", "Nein, blo nicht|Logindatum nicht speichern|"
		"Benutzerdaten nicht speichern");
	mboutput("\r\n\n");
	if (wahl==1)
		return TRUE;
	mbprintf("\r\n tsch, %s\r\n\n",user.name);
	sleep(1);
	if (akt_connection.is_modem)
		hangup_modem(user_in_fd);
	kill(getpid(),SIGHUP);
	logout_modus=1;
	if (wahl==2)
		akt_anruf.did_reset=1;
	else
		akt_anruf.did_reset=2;
	strcpy(akt_anruf.zuletzt,"RES");

	return TRUE;

} /* bef_reset */



#ifdef HAVE_LIBTCL
BOOLEAN bef_tcl(const char *para)
{
	int old_mode;
	char *q;
	char *p=strdup(para);
	BOOLEAN r;
	if (!p)
		return FALSE;
	q=strchr(p,' ');
	if (q) {
		*q++=0;
		strtrim(q);
	}
	old_mode=set_scroll_area(0);
	if (q) {
		char *s=strchr(q,' ');
		if (s) {
			*s++=0;
			strtrim(s);
		}
		r=ttcl_call_func(p,q,s,NULL);
	}
	else
		r=ttcl_script(p,NULL);
	set_scroll_area(old_mode);
	free(p);
	return r;
}
#endif



BOOLEAN bef_version(const char *dummy TOM_ATTRIB_UNUSED)
{
	mbprintf("\r\n Mailboxsystem TOM  (c) 1989-98\r\n");
	print_version(mbprintf);
	mbprintf("\r\n");
	return TRUE;

} /* bef_version */



BOOLEAN bef_zeit(const char *para)
{
	struct tm *tm;

	set_status_line("Zeit:");

	if (!strcmp(para,"#"))
	{
		/* Maus-hnliche Ausgabe */
		char *t = zeige_datum_S(time(NULL));

		mbprintf(" Heute ist %s, der %-8.8s, es ist %-5.5s Uhr.\r\n",
		         wochentagS(),t,t+9);
		mbprintf(" Ihnen stehen noch %ld Minuten zur Verfgung.\r\n",
		         restzeit() / 60);
		return TRUE;
	}

	mbprintf(" %s Zeit/Datum :%s %s %s\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),hh_mm_ss(),dd_mm_yy());

	tm=localtime(&akt_anruf.userstartzeit);
	mbprintf(" %s Online seit:%s %02d:%02d\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),tm->tm_hour,tm->tm_min);
	mbprintf(" %s Restzeit   :%s %ld Minuten\r\n",
				vt_S(ATTR_FETT),vt_S(ATTR_OFF),restzeit()/60);

	if (fileexist(tprintf("%sgebuehren",box_conf.bin_dir))
		&& akt_connection.is_modem)
	{
		mboutput("  "); /* erste Zeile einrcken */
		call_piped(tprintf("%sgebuehren --from %lu",box_conf.bin_dir,
						   (unsigned long) akt_anruf.startzeit),FALSE);
	}
	return TRUE;

} /* bef_zeit */
