/* befehle/chat.c: Chat und Zwangschat (Seiteneffekt!) */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/


#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "befehle.h"
#include "user.h"
#include "io.h"
#include "modem.h"
#include "terminal.h"
#include "aktdata.h"
#include "box_conf.h"

extern int col_ix[];

extern USER user;

extern int logout_modus;

extern BOOLEAN mitten_im_chat;

extern int sysop_in_fd;
extern int sysop_out_fd;


BOOLEAN bef_chat(const char *dummy TOM_ATTRIB_UNUSED)
{
	WORD iW;
	char dialogW = 0;
	char buf[sizeof(user.name)+20];

	mbprintf("%s%s",vt_pos_S(4,1),vt_S(DEL_SCR_REST));

	set_status_line("SYSOP-Chat");

	/* Hack: Usernamen nur auf Console/Sysopseite ausgeben */
	sprintf(buf,"[%s]\r\n",user.name);
	write(sysop_out_fd,buf,strlen(buf));

	if (!box_conf.console_besetzt)
	{
		char datei[PATH_MAX];

		akt_anruf.chat_status=TRISTATE_FAILURE;

		sprintf(datei,"%sdialog.txt",box_conf.texte_dir);
		if (fileexist(datei))
			zeige_datei(datei);
		else
			mboutput(" Console nicht besetzt - bitte schreiben Sie an den Sysop\r\n\n");
	}
	else
	{
		BOOLEAN ok = FALSE;

		mboutput(" >>> Sysop wird an die Console gerufen [Abbruch mit Escape]\r\n\n ");
		akt_anruf.chat_status = TRISTATE_FAILURE;

		/* externes Programm, um Sysop zu rufen? */
		if (box_conf.sysop_call && *box_conf.sysop_call)
		{
			ok = (call_extern(
				box_conf.sysop_call,
				NULL,                 /* spezielles Arbeitsverzeichnis */
				time(NULL)+60,        /* killzeitpunkt, just for the case */
				FALSE,                /* ignore_exitcode */
				FALSE                 /* nicht unter uid des Users */
				) == 0);
		}

		for (iW = 0; iW < 60; iW++)
		{
			mboutput(".");
			if (!ok)
			{
				write(sysop_out_fd,"\a",1);
			}
			if (io_charavail(sysop_in_fd))
				read(sysop_in_fd,&dialogW,1);
			else
				msleep(200);
			if (dialogW==' ')
			{
				akt_anruf.chat_status = TRISTATE_OK;
				mboutput("\r\n\n");
				mboutput(" ** Dialog mit dem Sysop aktiv:  (Wechsel mit Leerzeile)\r\n");
				chat_modus();
				mboutput("\r\n");
				mboutput(" ** Dialog mit dem Sysop beendet.\r\n");

				break;
			}

			if (userbreak())
				break;
		}

		if (akt_anruf.chat_status != TRISTATE_OK)
			mboutput("\r\n Der Sysop ist wohl momentan nicht da ...\r\n\n");
	}

	if (akt_anruf.chat_status == TRISTATE_OK)
	{
		redraw_status();		/* notwendig? */
		return TRUE;
	}

	return FALSE;

} /* bef_chat */


void chat_modus(void)
{
	char chatS[80];
	char restS[80]="";
	time_t start,end;

	BOOLEAN sysop_ist_dran=TRUE;
	BOOLEAN name_ausgegeben=FALSE;
	BOOLEAN timed_out=FALSE;

	mitten_im_chat=TRUE;

	name_ausgegeben=FALSE;
		
	mboutput("\r\n");
	start=time(NULL);

	do
	{
		if (box_conf.color_chat)
		{
			if (sysop_ist_dran)
				mboutput(vt_S(col_ix[C_BLAU]));
			else
				mboutput(vt_S(col_ix[C_GRUEN]));
		}
		if (!name_ausgegeben)
		{
			if (sysop_ist_dran)
				mboutput(" => SYSOP\r\n");
			else
				mbprintf(" => %s\r\n",user.name);
			name_ausgegeben=TRUE;
		}

		mboutput("  > ");

		if (box_conf.color_chat)
			mboutput(vt_S(ATTR_OFF));

		*chatS = 0;
		mbinput(chatS,restS);
		if (!chatS[0])
		{
			sysop_ist_dran=!sysop_ist_dran;
			name_ausgegeben=FALSE;
			mboutput("\r\n");
		}
		if (!timed_out && restzeit()<=0)
		{
			mboutput(" Ihre Onlinezeit wre nun vorbei!\r\n");
			timed_out=TRUE;
		}
	}
	while (!logout_modus && strcmp(chatS,"."));

	end=time(NULL);

	akt_anruf.soft_limit += end - start;
	if (akt_anruf.hard_limit < akt_anruf.soft_limit)
	{
		akt_anruf.soft_limit=akt_anruf.hard_limit;
		mboutput(
	"  Die Chatzeit konnte wegen des anstehenden Events nicht vollstndig\r\n"
	"  angerechnet werden!\r\n");
	}
	mitten_im_chat=FALSE;

} /* chat_modus */


