/* senden.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <syslog.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdlib.h>
#include <ctype.h>

#include "prototyp.h"
#include "befehle.h"
#include "modem.h"
#include "brett.h"
#include "user.h"
#include "msg.h"
#include "bin_msg.h"
#include "box_conf.h"
#include "tompaths.h"
#ifdef OFFLINE2
#include "offline/inc/message.h"
#include "offline/inc/mdb_global.h"
#else
#include "offline/message.h"
#include "offline/mdb_global.h"
#endif
#include "routing.h"


extern USER user;
extern BRETT akt_brett;
extern BRETTNR brettnrW;
extern BRETTINFO *br_ind;
extern BRETTART postfach_art;
extern int logout_modus;

extern BYTE
pm_schutzB;

extern long
actual_uploadL,
actual_writeL;

struct bin_para
{
	BRETTNR bnr;
	BOOLEAN ist_mail;
	USERNR  empfaengernr;
	char empfaengerstr[256];
	char absender[256];
	char betreff[256];
	char gruppe[256];
};


static BOOLEAN senden_binaer(struct bin_para *para);
static BOOLEAN write_prg(struct bin_para *para,const char *filename_in_tmp, 
	long upload_nr);

BOOLEAN bef_senden(const char *para)
{
	BOOLEAN retcode;

#if 0
	/*
	 * Nachricht in moderierte Gruppe?
	 */
	if (brettnrW!=0 && *adr=='\0' && br_ind[brettnrW].flags & B_MODERIERT)
	{
		const char *p;
		mbprintf(" Das Brett %s ist moderiert,\r\n", akt_brett.name);
		p=get_moderator(akt_brett.name):
		if (!p)
		{
			mbprintf(" und falsch installiert.\r\n");
			syslog(LOG_NOTICE,"%s moderiert, kein Moderator gefunden",
				akt_brett.name);
			return FALSE;
		}
		mbprintf(" sende Nachricht an %s.r\n", p);
		strcpy(adr,p);
		/* hier fehlt noch eine Mglichkeit, die Gruppenzeile 
		 * durchzuschleusen
		 */
	}
#endif

	if ((brettnrW==0 && postfach_art==BINAER_BRETT)
		|| (brettnrW && brettart(brettnrW)==BINAER_BRETT))
	{
		/* Das ist also eine werdende Binrnachricht */
		char adr[256];
		BOOLEAN old_schutz;
		struct bin_para bin_para=
		{
			0, FALSE, 0, "", "", "", ""
		};
		strncpy(adr,para,sizeof(adr));

		if (brettnrW==0)
		{
			bin_para.ist_mail=TRUE;

			set_status_line("Datei senden");

			/* eventuell noch den Empfnger holen */
			if (!*adr)
			{
				mboutput(" Bitte whlen Sie den Empfnger aus:\r\n");
				mbquestion(75,3,TRUE," > ","",adr);
				mboutput("\r\n");
			}
			else
				mbprintf(" Empfnger: %s\r\n",adr);
			strtrim(adr);
			if (!*adr)
			{
				mboutput(" Dann eben nicht!\r\n\n");
				return FALSE; /* Sauberer Abbruch */
			}

			/* irgendwelche zweckfreien @ xyz.maus.de abschneiden */
			{
				char *p=strchr(adr,'@');
				if (p)
				{
					if (!r_is_me(p+1))
					{
						mbfehler("Binrdaten knnen nur lokal versandt werden");
						return FALSE;
					}
					*p=0;
					strtrim(adr);
				}
			}
			if (!ub_find_username(&bin_para.empfaengernr,adr))
			{
				mboutput(" unbekannter Benutzer\r\n");
				return FALSE;
			}

			strcpy(bin_para.empfaengerstr,adr);
			strcat(bin_para.empfaengerstr," @ ");
			strcat(bin_para.empfaengerstr,MYDOMAINPART);

		}
		else
		{
			/* ffentliche Nachricht in ein Binrbrett */
			set_status_line("Datei senden");

			mbprintf(" Brett: %s\r\n", akt_brett.name);
			if (!(br_ind[brettnrW].brett->flags & B_WRITE))
			{
				mbfehler("Dieses Brett ist schreibgeschtzt");
				return FALSE;
			}

			strcpy(bin_para.gruppe,akt_brett.name);
			bin_para.bnr=brettnrW;
			mboutput("\r\n");
		}
		old_schutz=pm_schutzB;
		if (bin_para.ist_mail)
			pm_schutzB = TRUE;

		sprintf(bin_para.absender, "%s @ %s",user.name, MYDOMAINPART);

		retcode=senden_binaer(&bin_para);

		pm_schutzB = old_schutz;

	}
	else 
	{
		if ((para && *para) || brettnrW==0)
		{
			BOOLEAN old_schutz;
			old_schutz=pm_schutzB;
			if (brettnrW==0)
				pm_schutzB=TRUE;
			retcode=senden_text(TRUE,NULL, para && *para ? para : NULL, NULL);
			pm_schutzB = old_schutz;
		}
		else if (!(br_ind[brettnrW].brett->flags & B_WRITE))
		{
			mbfehler("Dieses Brett ist schreibgeschtzt");
			retcode=FALSE;
		}
		else
			retcode=senden_text(FALSE,NULL,NULL,akt_brett.name);
	}

	return retcode;

} /* senden */



static BOOLEAN senden_binaer(struct bin_para *para)
{
	long upload_nr;
	char art='\0';
	DIR *d;
	struct dirent *e;

	rm_dir_content(tom_utmp_dir);

	switch (transfer_receive(&art,NULL,NULL))
	{
	case 1: mboutput("Abbruch des Uploads\r\n"); return FALSE;
	case 2: mboutput("Fehler beim Upload\r\n"); return FALSE;
	}

	d=opendir(tom_utmp_dir);
	if (!d)
	{
		mbfehler("das sollte nicht passieren: das Temporrverzeichnis ist weg");
		syslog(LOG_ERR,"Temporaerverzeichnis weg: %s",strerror(errno));
		return FALSE;
	}
	while ((e=readdir(d))!=NULL)
	{
		char datei[PATH_MAX];
		if (*e->d_name=='.')
			continue;
		mbprintf("%s:\r\n",e->d_name);
		mbquestion(60,0,TRUE," Betreff: ","",para->betreff);
		strtrim(para->betreff);
		if (!*para->betreff)
		{
			mboutput(
"Sie mssen einen Betreff angeben!\r\n"
"Wenn Sie nocheinmal keinen Betreff angeben wird der Upload abgebrochen!\r\n"
				);
			mbquestion(60,0,TRUE," Betreff: ","",para->betreff);
			strtrim(para->betreff);
			if (!*para->betreff)
			{
				mbfehler("kein Betreff");
				continue;
			}
		}
		upload_nr = get_new_id_nr(TRUE);
		mboutput(" Bitte kurzen Info-Text (max.12 Zeilen) zur Binrdatei eingeben\r\n\n");
		mboutput(" (W)eiter,(Cr)Eingabe:");

		if (mbdecide("W\r"," Weiter\r\n| Eingabe\r\n") == 2)
		{
			sprintf(datei,"%s%ld.txt",brettpfad(brettnrW),upload_nr);
			call_editor(datei, FALSE);
		}

		sprintf(datei,"%s%s",tom_utmp_dir,e->d_name);

		if (!write_prg(para,datei,upload_nr))
		{
			unlink(tprintf("%s%ld.txt",brettpfad(brettnrW),upload_nr));
			closedir(d);
			rm_dir_content(tom_utmp_dir);
			return FALSE;
		}
	}
	closedir(d);
	rm_dir_content(tom_utmp_dir);
	return TRUE;

} /* senden_binaer */

/*
	Datei uploaden (User -> Box), high-level

	->			para			:	...
				upload_nr	:	...
*/
static BOOLEAN write_prg(struct bin_para *para,const char *datei, long upload_nr)
{
	char name[PATH_MAX];
	BOOLEAN ok = TRUE;
	long msgnr;
	long bytesL = 0;
	struct stat statbuf;
	BIN_MSG bin_info;
	char *p;

	sprintf(name,"%s%ld.bin",brettpfad(para->bnr),upload_nr);

	bytesL=len_datei(datei);
	if (!bytesL)
		return FALSE;

	if (!file_move(datei,name))
	{
		mbfehler("kann Datei nicht kopieren");
		return FALSE;
	}

	if (stat(tprintf("%s%s",brettpfad(para->bnr),"inhalt.dat"),&statbuf))
		msgnr = 1;
	else
		msgnr = statbuf.st_size / sizeof(BIN_MSG) +1;

	memset(&bin_info,0,sizeof(BIN_MSG));
	bin_info.nr       = upload_nr;
	bin_info.lokal    = msgnr;
	bin_info.brettnr  = brettnrW;
	bin_info.usernr   = user.nummer;
	if (para->ist_mail)
		bin_info.empfaenger = para->empfaengernr;
	bin_info.zugriffe = 0;
	bin_info.bytes    = bytesL;

#ifdef HAVE_DOSDRIVES
	p=strrchr(datei,'\\');
	if (!p)
		p=strrchr(datei,'/');
#else
	p=strrchr(datei,'/');
#endif
	strncpy(bin_info.name,(p) ? p+1 : datei,sizeof(bin_info.name));
	strncpy(bin_info.absender,para->absender,sizeof(bin_info.absender));
	strncpy(bin_info.betreff ,para->betreff ,sizeof(bin_info.betreff));
	strncpy(bin_info.zeit    ,hh_mm_ss(),sizeof(bin_info.zeit));
	strncpy(bin_info.datum   ,dd_mm_yy(),sizeof(bin_info.datum));

	bin_info.datime   = time(NULL);
	bin_info.deleted  = 0;
	bin_info.status   = 0;
	bin_info.art      = 0;
	bin_info.system   = 0;
	bin_info.bereich  = 0;
	memset(bin_info.resvd,0,sizeof(bin_info.resvd));
	binaer_dat_anhaengen(para->bnr,&bin_info);

	/* Userdaten aktualisieren */
	user.ul_bytes  += bytesL;
	actual_uploadL += bytesL;

	/* Brettdaten aktualisieren */
	br_ind[para->bnr].brett->flags |= B_NEU;
	bb_update_brett(para->bnr);

	mbprintf(" -> Datei unter Nr.%ld ",msgnr);
	if (para->ist_mail)
		mbprintf("an: %s\r\n\n",para->empfaengerstr);
	else
		mbprintf("ins Brett: %s\r\n\n",para->gruppe);

	return ok;

} /* write_prg */

static const char *
get_distribution(const char d)
{
	switch(d)
	{
	case 'M': return "MausNet"; break;
	case 'N': return "Net"; break;
	case 'L': return "Lokal"; break;
	}
	return "";
}

static void
senden_text_edit_liste(const char *what, BOOLEAN secure, 
	BOOLEAN adr, simplelist_t **list)
{
	/* (L)schen, (N)eue, (E)ditieren sind belegt! */
	const char *name=adr ? "Adresse" : "Gruppe";

	while (1)
	{
		int zahl=0;
		int wahl;
		simplelist_t *akt;
		mbprintf("\r\n%s\r\n",what);
		for (akt=*list;akt;akt=akt->next)
		{
			mbprintf("%2d %s\r\n",++zahl,akt->data);
		}
		if (!*list)
			mbprintf("Noch keine %s angegeben.\r\n",name);

		mboutput("\r\n");

		if (zahl)
		{
			mbprintf("(N)och eine %s hinzufgen\r\n",name);
			mbprintf("%s (L)schen\r\n",name);
			mbprintf("%s (E)di%seren\r\n",name,box_conf.ti ? "ti" : "");
		}
		else
			mbprintf("(N)eue %s\r\n",name);
		mbprintf("(F)ertig\r\n");

		do
		{
			wahl=mbchar();
			if (logout_modus)
				return;
			wahl=toupper(wahl);
			if (wahl=='F')
				return;
			if ((wahl=='N') || ((wahl=='L' || wahl=='E') && zahl))
				break;
		} while (1);

		if (wahl=='L' || wahl=='E')
		{
			char buf[3];
			int such;
			int i;
			simplelist_t *last;
			mbprintf("Nummer der %s\r\n",name);
			if (!mbquestion(2,0,FALSE, NULL,NULL, buf))
				return;
			such=strtol(buf,NULL,10);
			if (such<=0)
				continue;
			if (such > zahl)
			{
				mboutput("Nummer zu hoch\r\n");
				continue;
			}
			i=0;
			for (akt=*list,last=NULL;akt;last=akt,akt=akt->next)
			{
				if (++i==such)
					break;
			}
			if (i != such)
			{
				/* hm? */
				mboutput("nicht gefunden\r\n");
				continue;
			}

			if (wahl=='L')
			{
				mbprintf("%s\r\n",akt->data);
				mboutput(" (L)schen, (N)icht lschen: ");
				wahl = mbdecide("LN","Lschen\r\n|Nicht lschen\r\n");
				if (wahl==1)
				{
					if (last)
						last->next=akt->next;
					else
						*list=akt->next;
					akt->next=NULL;
					simple_free(akt);
				}
			}
			else
			{
				char buf2[128];
				/* Editieren */
				if (adr)
					mboutput("Neue Adresse:\r\n");
				else
					mboutput("Neue Gruppe:\r\n");

				if (mbquestion(75, 0, FALSE, NULL, akt->data, buf2) && *buf2)
				{
					free(akt->data);
					akt->data=XSTRDUP(buf2);
				}
			}
		}
		else /* Fall N wie Neu */
		{
			char buf2[128];
			/* Editieren */
			if (adr)
				mboutput("Neue Adresse:\r\n");
			else
				mboutput("Neue Gruppe:\r\n");

			if (mbquestion(75, 0, FALSE, NULL, NULL, buf2) && *buf2)
			{
				BOOLEAN erlaubt=TRUE;
				if (secure)
				{
					/* Zugriffsrechte abfragen */
					if (adr)
					{
						char *com=NULL;
						if (!r_vrfy(buf2,&com,level(),user.bezahlt))
						{
							if (com)
								mbprintf("nicht mglich: %s\r\n",com);
							else
								mboutput("Das ist leider nicht mglich\r\n");
							erlaubt=FALSE;
						}
						free(com);
					}
					else
					{
						BRETTNR bnr=brettnr(buf2);
						if (bnr && !(br_ind[bnr].brett->flags & B_WRITE))
						{
mboutput("In diese Gruppe zu Schreiben ist Ihnen nicht erlaubt\r\n");
							erlaubt=FALSE;
						}
						else if (!bnr)
						{
mboutput("Die Gruppe ist lokal nicht vorhanden. Wissen Sie, was Sie tun?\r\n");
						}
					}
				}
				if (erlaubt)
				{
					simplelist_t *n;
					simplelist_t *last;
					n=simple_alloc(buf2);
					XNULLCHECK(n);
					for (akt=*list,last=NULL;akt;last=akt,akt=akt->next)
						;
					if (last)
						last->next=n;
					else
						*list=n;
				}
			}
		}
	}
}

/* 
 * eine Nachricht senden. Komplizierte Sache ...
 */
BOOLEAN senden_text(BOOLEAN pm, const char *ref_id, 
	const char *p_empfaenger, const char *p_gruppe)
{
	simplelist_t *o_gruppen=NULL;
	simplelist_t *o_reply_to=NULL;
	simplelist_t *o_followup_to=NULL;
	char         *o_absender=NULL;
	char         *o_subject=NULL;
	char          o_distribution=0;

	simplelist_t *gruppen=NULL;
	simplelist_t *reply_to=NULL;
	simplelist_t *followup_to=NULL;
	simplelist_t *to=NULL;
	char         *subject=NULL;
	char          distribution=0;
	
	char datei[PATH_MAX];
	char quotefname[PATH_MAX];
	char buf[16384];
	BOOLEAN ok=TRUE;
	BOOLEAN gequotet=FALSE;

	struct mbselect_t janein[]=
	{
		{ 'J', "Ja\r\n" },
		{ 'N', "Nein\r\n" },
	 	{ 0, NULL }
	};

	*quotefname='\0';

	if (ref_id)
	{
		char exportfname[PATH_MAX];
		char ihavefname[PATH_MAX];
		FILE *f;
		FILE *f2;
		/* kommentiere Nachricht exportieren */
		sprintf(exportfname,"%s%ld.exp",tom_tmp_dir,(long)getpid());
		sprintf(ihavefname,"%s%ld.ihave",tom_tmp_dir,(long)getpid());
		sprintf(quotefname,"%s%ld.quote",tom_tmp_dir,(long)getpid());
		f=xfopen(ihavefname,BINWRITE);
		fprintf(f,"%s\n",ref_id);
		fclose(f);

		if (!mdb_get_article(ihavefname,exportfname,FALSE))
		{
			syslog(LOG_NOTICE,"zu kommentierende Nachricht unlesbar");
			mbfehler("zu kommentierende Nachricht unlesbar");
			unlink(ihavefname);
			unlink(exportfname);
			/* Was tun? */
			goto reference_not_found;
		}
		unlink(ihavefname);
		f=xfopen(exportfname,"r");
		f2=xfopen(quotefname,"w");
		while (fgets(buf,sizeof(buf),f))
		{	
#define PREPEND(list,str) { simplelist_t *n=simple_alloc(strtrim(str)); \
 XNULLCHECK(n); n->next=list; list=n; }

 char *p=strpbrk(buf,"\r\n");
 if (p) *p=0;
 switch(*buf)
 {
 case 'G': PREPEND(o_gruppen,buf+1); break;
 case 'F': PREPEND(o_followup_to,buf+1); break;
 case 'R': PREPEND(o_reply_to,buf+1); break;
 case 'V': o_absender=XSTRDUP(strtrim(buf+1)); break;
 case 'W': o_subject=XSTRDUP(strtrim(buf+1)); break;
 case 'D': o_distribution=buf[1]; break;
 case ':':
	 fprintf(f2,">%s\n",buf+1);
	 break;
 }
#undef PREPEND
		}
		if (ftell(f2)==0)
		{
			unlink(quotefname);
			*quotefname=0;
		}
		fclose(f2);
		fclose(f);
		unlink(exportfname);

		/* So, jetzt bernehmen wir die Daten der kommentierten Nachricht
		 * als Default */
		if (o_subject)
			subject=XSTRDUP(o_subject);
		distribution=o_distribution;

		if (!pm && o_followup_to)
		{
			/* followup-To Poster und den hufigen Fehler Followup user@kiste */
			simplelist_t *akt;
			const char *adr=NULL;
			for (akt=o_followup_to;akt;akt=akt->next)
			{
				if (!stricmp(akt->data,"poster") && o_absender) 
					adr=o_absender;
				else if (strchr(akt->data,'@'))
					adr=akt->data;
			}
			if (adr)
			{
				int wahl;
				mbprintf(
					"Der Absender hat gebeten, ihm Antworten an die Adresse\r\n"
					"%s\r\n"
					"zu senden. Wollen Sie nicht doch lieber eine PM senden?\r\n", adr);
				mboutput("(J)a / (N)ein / als (K)opie: ");
				wahl = mbdecide("JNK","Ja\r\n|Nein\r\n|als Kopie\r\n");
				if (wahl==1)
				{
					pm=FALSE;
				}
				else if (wahl==3)
				{
					to=simple_alloc(adr);
					XNULLCHECK(to);
				}
			}
		}

		if (pm)
		{
			if (o_reply_to)
			{
				simplelist_t *akt;
				simplelist_t *last;
				for (last=NULL, akt=o_reply_to;akt;akt=akt->next)
				{
					char *com=NULL;
					if (!r_vrfy(akt->data,&com,level(),user.bezahlt))
					{
						mbprintf("Die Antwortadresse %s\r\n",akt->data);
						mboutput("kann nicht angeschrieben werden. Grund:\r\n");
						mbprintf("    %s\r\n",com ? com : "unbekannter Fehler");
					}
					else
					{
						if (last)
							last->next=akt->next;
						else
							o_reply_to=akt->next;
						akt->next=to;
						to=akt;
					}
					free(com);
				}
			}
			if (!to && o_absender)
			{
				char *com=NULL;
				if (!r_vrfy(o_absender,&com,level(),user.bezahlt))
				{
					mbprintf("Der Absender %s\r\n",o_absender);
					mboutput("kann nicht angeschrieben werden. Grund:\r\n");
					mbprintf("    %s\r\n",com ? com : "unbekannter Fehler");
				}
				else
				{
					to=simple_alloc(o_absender);
				}
				free(com);
			}
		}
		else /* wenn nicht PM */
		{
			if (o_followup_to)
			{
				simplelist_t *akt;
				simplelist_t *last;
				for (last=NULL, akt=o_followup_to;akt;akt=akt->next)
				{
					BRETTNR bnr=brettnr(akt->data);

					if (!stricmp(akt->data,"poster")
						|| strchr(akt->data,'@'))
						continue;
					if (bnr==0 || (br_ind[bnr].brett->flags & B_WRITE))
					{
						/* unbekanntes Brett, also bernehmen ... */
						if (last)
							last->next=akt->next;
						else
							o_followup_to=akt->next;
						akt->next=gruppen;
						gruppen=akt;
						continue;
					}
					else
					{
						mbprintf(
							"Followup-To-Gruppe %s ist schreibgeschtzt\r\n",
							akt->data);
					}
				}
			}
			if (!gruppen && o_gruppen)
			{
				simplelist_t *akt;
				simplelist_t *last;
				for (last=NULL, akt=o_gruppen;akt;akt=akt->next)
				{
					BRETTNR bnr=brettnr(akt->data);

					if (bnr==0 || (br_ind[bnr].brett->flags & B_WRITE))
					{
						/* unbekanntes Brett, also bernehmen ... */
						if (last)
							last->next=akt->next;
						else
							o_gruppen=akt->next;
						akt->next=gruppen;
						gruppen=akt;
						continue;
					}
					else
					{
						mbprintf(
							"Die Gruppe %s ist schreibgeschtzt\r\n",
							akt->data);
					}
				} /* for alle Gruppen in o_gruppen */
			}
		} /* pm oder nicht pm */
	}
	else
	{
	reference_not_found:
		/* keine Referenz-ID */
		if (pm && p_empfaenger)
		{
			char *com=NULL;
			if (!r_vrfy(p_empfaenger,&com,level(),user.bezahlt))
			{
				mbprintf("Die Adresse %s\r\n",p_empfaenger);
				mboutput("kann nicht angeschrieben werden. Grund:\r\n");
				mbprintf("    %s\r\n",com ? com : "unbekannter Fehler");
				ok=FALSE;
				goto cleanup;
			}
			else
			{
				to=simple_alloc(p_empfaenger);
				XNULLCHECK(to);
			}
			free(com);
		}
		else if (!pm && p_gruppe)
		{
			BRETTNR bnr=brettnr(p_gruppe);

			if (bnr!=0 && !(br_ind[bnr].brett->flags & B_WRITE))
			{
				mbprintf("In das Brett %s\r\n",p_gruppe);
				mboutput("drfen Sie nicht schreiben.\r\n");
				ok=FALSE;
				goto cleanup;
			}
			gruppen=simple_alloc(p_gruppe);
			XNULLCHECK(gruppen);
		}
	}

	/* Sicherheitshalber lschen */
	sprintf(datei,"%s%s",tom_tmp_dir,"msg.txt");
	unlink(datei);

	if (!to && pm)
	{
		char *com=NULL;
		do
		{
			mboutput(" An: (Abbruch mit Leereingabe)\r\n");
			mbquestion(75,0,FALSE," > ","",buf);
			mboutput("\r\n");
			if (!*buf)
			{
				ok=TRUE;
				mboutput("Abbruch!\r\n");
				goto cleanup;
			}
			if (!r_vrfy(buf,&com,level(),user.bezahlt))
			{
				mbprintf("Die Adresse %s\r\n",buf);
				mboutput("kann nicht angeschrieben werden. Grund:\r\n");
				mbprintf("    %s\r\n",com ? com : "unbekannter Fehler");
				continue;
			}
			break;
		} while (1);
		
		to=simple_alloc(buf);
		XNULLCHECK(to);
	}

	if (!subject) 
	{
		mboutput(" Wegen: (Abbruch mit Leereingabe)\r\n");
		mbquestion(75,0,FALSE," > ","",buf);
		mboutput("\r\n");
		if (!*buf)
		{
			ok=TRUE;
			mboutput("Abbruch!\r\n");
			goto cleanup;
		}
		subject=XSTRDUP(buf);
	}

 retry:

	while (1)
	{
		const char *filler="                "; /* 16 */
		simplelist_t *akt;
		struct mbselect_t auswahl[20];
		int auswahlzahl=0;
		WORD gewaehlt;
#define AUSWAHL(c,str) do { auswahl[auswahlzahl].key=c; \
			auswahl[auswahlzahl].output=str; auswahlzahl++; } while(0)

						   /* Men ausgeben */
						   mboutput("\r\n");
		mboutput("\r\n");
		mbprintf("%-16.16s%s\r\n","(W)egen:", subject ? subject : "");
		AUSWAHL('W',"Betreff ndern");
		if (pm)
		{

			mbprintf("%-16.16s","(E)mpfnger:");
			for (akt=to;akt;akt=akt->next)
				mbprintf("%s\r\n%s", akt->data,
						 akt->next ? filler : "");
			if (!to)
				mboutput("\r\n");
			AUSWAHL('E',"Empfnger ndern");
		}
		else
		{
			mbprintf("%-16.16s","(G)ruppen:");
			for (akt=gruppen;akt;akt=akt->next)
				mbprintf("%s\r\n%s", akt->data,
						 akt->next ? filler : "");
			if (!gruppen)
				mboutput("\r\n");
			AUSWAHL('G',"Gruppen ndern");

			mbprintf("%-16.16s","Anworten (I)n:");
			for (akt=followup_to;akt;akt=akt->next)
				mbprintf("%s\r\n%s", akt->data,
						 akt->next ? filler : "");
			if (!followup_to)
				mboutput("\r\n");
			AUSWAHL('I',"Followupgruppen ndern");

			mbprintf("%-16.16s","(K)opie an:");
			for (akt=to;akt;akt=akt->next)
				mbprintf("%s\r\n%s", akt->data,
						 akt->next ? filler : "");
			if (!to)
				mboutput("\r\n");
			AUSWAHL('K',"Kopie-An ndern");

			mbprintf("%-16.16s%s\r\n","(D)istribution:",
					 get_distribution(distribution));
			AUSWAHL('D',"Distribution ndern");
		}
		/* gemeinsamer Kram */
		mbprintf("%-16.16s","(A)ntwort an:");
		for (akt=reply_to;akt;akt=akt->next)
			mbprintf("%s\r\n%s", akt->data,
					 akt->next ? filler : "");
		if (!reply_to)
			mboutput("\r\n");
		AUSWAHL('A',"Anwort-Adresse ndern");

		mboutput("\r\n");
		mbprintf("(T)ext edi%seren\r\n", box_conf.ti ? "ti" : "");
		AUSWAHL('T', box_conf.ti ? "Text editieren": "Text edieren");
		if (*quotefname)
		{
			mbprintf("kommentierte Nachricht (Q)uoten\r\n");
			AUSWAHL('Q', "Nachricht quoten");
		}
		mbprintf("Nachricht (S)enden\r\n");
		AUSWAHL('S', "Nachricht senden");
		mbprintf("Nachricht (L)schen\r\n");
		AUSWAHL('L', "Nachricht lschen");
		mbprintf("(?) Hilfe\r\n");
		AUSWAHL('?', "Hilfe\r\n");
		AUSWAHL('0', NULL);
		mboutput("Ihre Wahl: ");
		gewaehlt=mbselect(auswahl);
		if (logout_modus)
			break;
		mboutput("\r\n\r\n\r\n");
		switch(gewaehlt)
		{
		case 'D':
		{
			struct mbselect_t dis[]=
			{
				{ 'N', "Netz / Weltweit\r\n" },
				{ 'M', "MausNet\r\n" },
				{ 'L', "Lokal\r\n" },
				{ 0, NULL }
			};
			if (distribution!=o_distribution && o_distribution)
			{
				mbprintf("Distribution der kommentierten Nachricht: %s\r\n",
						 get_distribution(o_distribution));
			}
			distribution=mbselect(dis);
		}
		break;
		case 'W': /* Betreff */
		{
			const char *vorgabe=NULL;
			if (subject && o_subject)
			{
				if (strcmp(subject,o_subject))
					mbprintf("Alter Betreff: \r\n%s\r\n",o_subject);
			} 
			if (subject)
				vorgabe=subject;
			else if (o_subject)
				vorgabe=o_subject;
			else
				vorgabe=NULL;
			mboutput("Neuer Betreff:\r\n");

			if (mbquestion(75, 0, FALSE, NULL, vorgabe, buf))
			{
				free(subject);
				subject=XSTRDUP(buf);
			}
		}
		break;
		case 'E':
			senden_text_edit_liste("Empfnger",TRUE, TRUE,&to); 
			break;
		case 'K':
			senden_text_edit_liste("Kopieempfnger",TRUE, TRUE,&to); 
			break;
		case 'A':
			senden_text_edit_liste("Antwort-An",FALSE, TRUE,&reply_to); 
			break;
		case 'G':
			senden_text_edit_liste("Gruppen",TRUE, FALSE,&gruppen); 
			break;
		case 'I':
			senden_text_edit_liste("Antwort-In",TRUE, FALSE,&followup_to); 
			break;
		case 'Q':
		{
			FILE *in;
			FILE *out;
			in=xfopen(quotefname,"r");
			out=xfopen(datei,"a");
			while (fgets(buf,sizeof(buf),in))
			{
				char *p=strpbrk(buf,"\r\n");
				if (p)
					*p=0;
				fprintf(out,"%s\n",buf);
			}
			fclose(in);
			fclose(out);
			mboutput("Originalnachricht gequotet\r\n");
			*quotefname=0; /* nur einmal ... */
			gequotet=TRUE;
		}
		break;
		case 'T': /* Text editieren */
			call_editor(datei, FALSE);
			break;
		case 'L': /* Verwerfen */
		{
			mboutput("Nachricht wirklich lschen? (J/N) ");
			if (mbselect(janein)=='J')
				goto cleanup;
		}
		break;
		case 'S':
		{
			BOOLEAN send=TRUE;
#define CHECKZAHL(liste,hoechst,text) \
			do { int checkzahl=0; simplelist_t *checkakt; \
															  for (checkakt=liste;checkakt; checkakt=checkakt->next) checkzahl++; \
																																	  if (checkzahl>hoechst) { mbprintf( \
"Sind Sie auch der Meinung, da %d " text " zu viele sind? (J/N) ",checkzahl); \
																				   if (mbselect(janein)=='J') send=FALSE; \
																															  } } while (0)

				if (!subject || !*subject)
				{
					mboutput("Die Nachricht hat noch keinen Betreff!\r\n");
					send=FALSE;
				}
				else if (pm && !to)
				{
					mboutput("Die Nachricht hat keine Empfnger!\r\n");
					send=FALSE;
				}
				else if (pm)
				{
					CHECKZAHL(to,4,"Empfnger");
					if (send && reply_to)
						CHECKZAHL(reply_to,4,"Antwortempfnger");
				}
				else /* ffentliche Nachricht */
				{
					CHECKZAHL(gruppen,4,"Gruppen");
					if (send && followup_to)
						CHECKZAHL(followup_to,4,"Antwortgruppen");
					if (send && to)
						CHECKZAHL(to,4,"Kopieempfnger");
					if (send && to)
						CHECKZAHL(reply_to,4,"Antwortempfnger");
					if (send && gruppen && gruppen->next && !followup_to)
					{
						mboutput(
							"Bei Crosspostings sollte angegeben werden, in welche Gruppen Kommentare\r\n"
							"gesendet werden sollen. Wollen Sie das noch tun? (J/N) ");
						send=mbselect(janein)=='N';
					}
					else if (send && followup_to)
					{
						/* nun testen wir mal, ob uns jemand verppelt:
						 * wenn alle G-Gruppen in F drin sind, und 
						 *   G > 2, dann ist hchstwahrscheinlich etwas falsch.
						 */
						simplelist_t *ft;
						simplelist_t *gp;
						int gzahl=0;
						int fzahl=0;
						BOOLEAN all_found=TRUE; /* all G in F gefunden */
						for (gp=gruppen;gp;gp=gp->next)
						{
							BOOLEAN this_found=FALSE;
							gzahl++;
							for (ft=followup_to;ft;ft=ft->next)
							{
								if (!stricmp(gp->data,ft->data))
								{
									this_found=TRUE;
									break;
								}
							}
							all_found&=this_found;
						}
						for (ft=followup_to;ft;ft=ft->next)
							fzahl++;
						if (all_found && fzahl==gzahl)
						{
							mboutput(
								"Die Gruppen, in die die Nachricht verschickt werden soll, sind identisch\r\n"
								"mit denen, in die Antworten gesendet werden sollen. Dies ist ohnehin der\r\n"
								"Fall, wenn keine Antwort-Gruppen angegeben werden.\r\n"
								"Wollen Sie dies noch ndern? (J/N) " );
							send=mbselect(janein)=='J';
						}
						else if (gzahl>2 && all_found)
						{
							mboutput(
								"Alle Gruppen, in die Sie schreiben wollen, sind auch in der Liste der\r\n"
								"Gruppen, in die Antworten gesendet werden sollen. Wollen Sie dies noch\r\n"
								"ndern? (J/N) ");
							send=mbselect(janein)=='J';
						}
					}
				}
			if (send)
			{
				if (!fileexist(datei))
				{
					mboutput("Die Nachricht ist leer!\r\n");
					send=FALSE;
				}
				else
				{
					FILE *f=xfopen(datei,"r");
					if (filesize(f)==0)
					{
						mboutput("Die Nachricht ist leer!\r\n");
						send=FALSE;
					}
					if (gequotet && send)
					{
						int lines=0;
						int quote=0;
						int quote_stueck=0;
						while (fgets(buf,sizeof(buf),f))
						{
							lines++;
							if (*buf=='>')
							{
								quote_stueck++;
								quote++;
							}
							else
								quote_stueck=0;
						}
						if (quote * 2>lines && quote >5)
						{
							mbprintf(
								"Von %d Zeilen sind %d Quotes. Wollen Sie das noch ndern? (J/N) ",
								lines,quote);
							send=mbselect(janein)=='N';
						}
						if (send && quote_stueck >10)
						{
							mbprintf(
								"Sie quoteten %d Zeilen am Stck. Wollen Sie das noch ndern? (J/N) ",
								quote_stueck);
							send=mbselect(janein)=='N';
						}
					}
					fclose(f);
				}
			}
			if (send)
			{
				mboutput("Nachricht wirklich senden? (J/N) ");
				if (mbselect(janein)=='J')
					goto send;
			}
		}
		break;
		case '?':
			if (!zeige_interpret_datei(tprintf("%ssenden_hilfe.txt",
											   box_conf.hilfe_dir)))
				mboutput(
					"der Hilfetext ist leider nicht korrekt installiert\r\n");
			break;
		}
	}

 send:
	/* */
	if (!logout_modus && !pm)
	{
		simplelist_t *akt;
		BOOLEAN done;
		struct veinfachpara *vpara=NULL;
		int zahl=2; /* subject, from */
		if (distribution && distribution!='N')
			zahl++;
		for (akt=gruppen;akt;akt=akt->next)
			zahl++;
		for (akt=followup_to;akt;akt=akt->next)
			zahl++;
		for (akt=reply_to;akt;akt=akt->next)
			zahl++;
		if (ref_id)
			zahl++;
		vpara=XMALLOC(sizeof(struct veinfachpara) * (zahl+1));

		zahl=2;
		vpara[0].kenn='W';
		vpara[0].str=XSTRDUP(subject);
		vpara[1].kenn='V';
		vpara[1].str=concat(user.name, " @ ", MYDOMAINPART, NULL);
		XNULLCHECK(vpara[1].str);
		if (distribution && distribution!='N')
		{
			vpara[zahl].kenn='W';
			vpara[zahl].str=XMALLOC(2);
			vpara[zahl].str[0]=distribution;
			vpara[zahl].str[1]=0;
			zahl++;
		}
		for (akt=gruppen;akt;akt=akt->next)
		{
			vpara[zahl].kenn='G';
			vpara[zahl].str=XSTRDUP(akt->data);
			zahl++;
		}
		for (akt=followup_to;akt;akt=akt->next)
		{
			vpara[zahl].kenn='F';
			vpara[zahl].str=XSTRDUP(akt->data);
			zahl++;
		}
		for (akt=reply_to;akt;akt=akt->next)
		{
			vpara[zahl].kenn='T';
			vpara[zahl].str=XSTRDUP(akt->data);
			zahl++;
		}
		if (ref_id)
		{
			vpara[zahl].kenn='-';
			vpara[zahl].str=XSTRDUP(ref_id);
			zahl++;
		}
		vpara[zahl].kenn=0;
		vpara[zahl].str=NULL;
		done=veinfachnachricht(FALSE,level(),user.bezahlt,datei,vpara);
		for (zahl=0;vpara[zahl].kenn;zahl++)
			free(vpara[zahl].str);
		free(vpara);
		if (!done)
		{
			mboutput("Die Nachricht konnte nicht versandt werden.\r\n\n");
			mboutput("Wollen Sie abbrechen? (J/N) ");
			if (mbselect(janein)=='N')
				goto retry;
		}

	}
	if (!logout_modus && (pm || to))
	{
		simplelist_t *akt;
		BOOLEAN done;
		struct veinfachpara *vpara=NULL;
		int zahl=2; /* subject, from */
		for (akt=to;akt;akt=akt->next)
			zahl++;
		for (akt=reply_to;akt;akt=akt->next)
			zahl++;
		if (ref_id)
			zahl++;
		vpara=XMALLOC(sizeof(struct veinfachpara) * (zahl+1));

		zahl=2;
		vpara[0].kenn='W';
		vpara[0].str=XSTRDUP(subject);
		vpara[1].kenn='V';
		vpara[1].str=concat(user.name, " @ ", MYDOMAINPART, NULL);
		XNULLCHECK(vpara[1].str);
		for (akt=to;akt;akt=akt->next)
		{
			vpara[zahl].kenn='A';
			vpara[zahl].str=XSTRDUP(akt->data);
			zahl++;
		}
		for (akt=reply_to;akt;akt=akt->next)
		{
			vpara[zahl].kenn='T';
			vpara[zahl].str=XSTRDUP(akt->data);
			zahl++;
		}
		if (ref_id)
		{
			vpara[zahl].kenn='-';
			vpara[zahl].str=XSTRDUP(ref_id);
			zahl++;
		}
		vpara[zahl].kenn=0;
		vpara[zahl].str=NULL;
		done=veinfachnachricht(TRUE,level(),user.bezahlt,datei,vpara);
		for (zahl=0;vpara[zahl].kenn;zahl++)
			free(vpara[zahl].str);
		free(vpara);
		if (!done)
		{
			const char *fill="";
			if (!pm)
				fill="Kopie der ";
			mbprintf("Die %sNachricht konnte nicht versandt werden.\r\n\n",
					 fill);
			mboutput("Wollen Sie abbrechen? (J/N) ");
			if (mbselect(janein)=='N')
				goto retry;
		}
	}

 cleanup:
	simple_free_chain(o_gruppen);
	simple_free_chain(o_reply_to);
	simple_free_chain(o_followup_to);
	simple_free_chain(gruppen);
	simple_free_chain(reply_to);
	simple_free_chain(followup_to);
	simple_free_chain(to);
	free(o_absender);
	free(o_subject);
	free(subject);
	unlink(datei);
	if (*quotefname)
		unlink(quotefname);

	return ok;
}

