/* test.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "prototyp.h"
#ifdef OFFLINE2
#include "offline/inc/version.h"
#include "offline/inc/mdb_global.h"
#else
#include "offline/version.h"
#include "offline/mdb_global.h"
#endif
#include "befehle.h"
#include "brett.h"
#include "modem.h"
#include "terminal.h"

extern int col_ix[];

extern BRETTNR brettnrW;
extern BRETT akt_brett;




static BOOLEAN test_text(const char *para);
static BOOLEAN test_binaer(const char *para);



BOOLEAN bef_test(const char *para)
{
	if (brettart(brettnrW) == BINAER_BRETT)
		return test_binaer(para);
	else
		return test_text(para);

} /* bef_test */



BOOLEAN bef_dump(const char *para TOM_ATTRIB_UNUSED)
{
	BOOLEAN pm = (brettnrW == 0);

	if (brettart(brettnrW) == BINAER_BRETT)
	{
		mbfehler("Dump nur in Textbrettern");
		return FALSE;
	}
#ifdef OFFLINE_VERSION
	/*
		ein Dump ist nur in der standalone-Version mglich, nicht 
		aber in der Client-Version.
		der Unterschied ist hier aber nicht sichtbar, so da die 
		Dump-Mglichkeit vorerst generell gesperrt ist.
		FB 17.1.97
	*/
#ifdef YES_I_AM_SURE_THIS_IS_NOT_QUARK_III
#error gruppen_dump disabled!
	gruppen_dump(akt_brett.name,pm,stdout);
#else 
	mbfehler("Dump z.Z. nicht mglich, ggf. Offline verwenden");
	return FALSE;
#endif
#else
	gruppen_dump(akt_brett.name,pm);
#endif

	return TRUE;

} /* bef_dump */



/*
	berprfung der Nachrichten-Datenbank

	04.11.93 Frank
*/
static BOOLEAN test_text(const char *para)
{
	BOOLEAN pm;					/* Flag, ob PM oder Gruppe */
	BOOLEAN ok;

	set_status_line("Nachrichtendatenbank-Prfung/korrektur");

	pm = (brettnrW == 0);

	if (!strcmp(para,"*"))
	{
#ifdef OFFLINE_VERSION
		mdb_check("*",pm,TRUE);
#else
		mdb_check_all(TRUE);
#endif
	}
	else
	if (!*para)
	{
#ifdef OFFLINE_VERSION
		ok = mdb_check(akt_brett.name,pm,TRUE);
#else
		ok = mdb_check_group(akt_brett.name,pm,TRUE);
#endif

		if (pm)
			mboutput(" Postfach");
		else
			mboutput(" Gruppe");

		if (ok)
			mboutput(" ok\r\n");
		else
			mbprintf(" %sdefekt%s\r\n",vt_S(col_ix[C_ROT]),vt_S(ATTR_OFF));
	}
	else
	{
		parameter_falsch("TEST",para);
		return FALSE;
	}

	return TRUE;

} /* test_text */



/*
	04.11.93 Frank

	dummy-Funktion, wird spter Konsistenz von Archiven prfen, 
	defekte protokollieren und erstmal fr Downloads sperren
*/
static BOOLEAN test_binaer(const char *para TOM_ATTRIB_UNUSED)
{
	mbfehler("Befehl TEST in Binrbrettern noch nicht mglich");

	return FALSE;

} /* test_binaer */
