/* userantrag.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h> /* sleep */
#include <ctype.h>
#include <limits.h>
#include <dirent.h>
#include "fnmatch.h"

#include "tomsysdep.h"
#include "prototyp.h"
#include "modem.h"
#include "befehle.h"
#include "terminal.h"
#include "user.h"
#include "routing.h"
#include "aktdata.h"
#include "box_conf.h"
#include "tompaths.h"
#include "cslib.h"
#include "tomtcl.h"


extern USER user;

extern int logout_modus;
extern ULONG ub_userzahl;

extern const char *comp_type[];
extern UWORD comp_type_zahl;

static void show_comp_type(void);
static UWORD comp_type_vorschlag(const char *s);

static UWORD 
comp_type_vorschlag(const char *s)
{
	UWORD res=0; /* sonstiges */
	char buf[128];
	strcpy(buf,s);
	strlwr(buf);
	if (strstr(buf,"atari") || strstr(buf,"falcon"))
		return 1;
	if (strstr(buf,"amiga"))
		return 2;
	if (strstr(buf,"archi"))
		return 7;
	if (strstr(buf,"ibm") || strstr(buf,"pc") || strstr(buf,"dos")
	|| strstr(buf,"86") || strstr(buf,"pentium"))
		res=3; /* IBM kompatibel */
	if (strstr(buf,"unix") || strstr(buf,"bsd") || strstr(buf,"linux"))
		return 4; /* Unix */
	if (strstr(buf,"windows"))
		return 11;
	if (strstr(buf,"os2") || strstr(buf,"os-2") || strstr(buf,"os/2"))
		return 10;
	if (strstr(buf,"ppc") || strstr(buf,"power pc"))
		return 6;
	if (strstr(buf,"sparc") || strstr(buf,"sun"))
		return 8;
	if (strstr(buf,"apple") && !strstr(buf,"][") && !strstr(buf,"ii"))
		return 5;
	if (strstr(buf,"mac"))
		return 5;
	if (strstr(s,"ST") || strstr(s,"TT"))
		return 1;
	return res;
}

BOOLEAN 
bef_userantrag(const char *dummy TOM_ATTRIB_UNUSED)
{
	BOOLEAN abbruch = FALSE;
	BOOLEAN mistB = FALSE;
	BOOLEAN name_okB;
	UWORD versuchW = 0;
	UWORD zaehlerW = 0;
	USER antrag;
	char nameS[80];
	cstl_t *cs;

	set_status_line("Userantrag zur Aufnahme in die Box");

	zeige_datei(tprintf("%s%s",box_conf.texte_dir,"postfach.txt"));

	mboutput(" >> Postfach anlegen? (J/N) ");
	if (mbdecide("JN","Ja ...\r\n|Nein, schade\r\n\n") == 2)
		return FALSE;

	cs=get_charset_from_nr(user.zeichensatz);
	if (!cs || !stricmp(cs->name,"usascii"))
	{
		bef_umlaut("*");
		cs=get_charset_from_nr(user.zeichensatz);
	}

	memset(&antrag,0,sizeof(USER));
/*	antrag = std_user;*/

 again:
	do
	{
		BOOLEAN space_ok=FALSE;
		USERNR *nummern;

		name_okB = FALSE;

		do
		{
			mboutput("\r\n");
			mboutput("Name (Vorname Nachname):\r\n");
			if (!mbfrage(sizeof(antrag.name)-1,MBF_LINE,"",antrag.name)) {
				/* takes care of carrier lost! */
				mboutput("Abbruch\r\n\n");
				return FALSE;
			}
			strtrim(antrag.name);
			if (!*antrag.name)
			{
				mboutput("Abbruch\r\n\n");
				return FALSE;
			}
			if (!strchr(antrag.name,' ') && !box_conf.allow_one_part_usernames)
				mboutput("Vorname und Nachname bitte!\r\n\n");
			else
				space_ok=TRUE;
		} while (!space_ok);
		if (!box_conf.username_keepcase)
			capitalize_words(antrag.name);

		if (!check_username_syntax(antrag.name,TRUE))
		{
			zaehlerW++;
			continue;
		}

		nummern=ub_find_username_multi(antrag.name,FALSE);
		if (nummern)
		{
			mboutput(" Benutzername leider schon vergeben\r\n");
			free(nummern);
			return FALSE;
		}

		if (!mistuser(antrag.name,FALSE))
			name_okB = TRUE;
		else
		{
			mistuser_routine(antrag.name);
			mistB = TRUE;
		}

		zaehlerW++;
	}
	while (!(name_okB || zaehlerW==3 || mistB));

	if (mistB)
	{
		*nameS = 0;
		logout_modus = 1;
		return FALSE;
	}
	if ((zaehlerW==3 && !name_okB) || abbruch)
		return FALSE;

	if (strpbrk(antrag.name,""))
		mboutput(
"  Ihr Name enthlt Umlaute. Wenn Sie sich einloggen, mssen sie diese\r\n"
"  in Langform schreiben ('' -> 'UE'), da die Box zu diesem Zeitpunkt\r\n"
"  noch nicht wei, welchen Zeichensatz Sie benutzen.\r\n"
		);

	while (!abbruch)
	{
		BOOLEAN leer;
		versuchW++;
		if (passwort_aenderung(&antrag,&leer))
			break;
		if (versuchW > 3 || leer)
			abbruch = TRUE;
	};

	if (abbruch)
	{
		mbfehler("falsche Angaben");
		return FALSE;
	}

	zaehlerW = 0;

	{
		char pa[PATH_MAX];
		sprintf(pa,"%santrag_extra.txt",box_conf.texte_dir);
		if (fileexist(pa)) {
			mboutput("\r\n");
			zeige_interpret_datei(pa);
		}
	}

	mboutput("\r\n    Geburtsdatum...\r\n");
	if (antrag.geburtstag)
		sprintf(nameS,"%d",antrag.geburtstag);
	else
		*nameS=0;
	mbfrage(2,MBF_LINE,"    Tag         : ",nameS);
	antrag.geburtstag = atoi(nameS);

	if (antrag.geburtsmonat)
		sprintf(nameS,"%d",antrag.geburtsmonat);
	else
		*nameS=0;
	mbfrage(2,MBF_LINE,"    Monat       : ",nameS);
	antrag.geburtsmonat = atoi(nameS);

	if (antrag.geburtsjahr)
		sprintf(nameS,"%d",antrag.geburtsjahr);
	else
		*nameS=0;
	mbfrage(4,MBF_LINE,"    Jahr        : ",nameS);
	antrag.geburtsjahr = atoi(nameS);

	if (antrag.geburtsjahr && antrag.geburtsjahr < 1900)
		antrag.geburtsjahr += 1900;

	if (antrag.geschlecht == WEIBLICH) 
		strcpy(nameS,"w");
	else
		strcpy(nameS,"m");
	mbfrage(1,MBF_LINE|MBF_TOUPPER,"    Geschlecht(m/w): ",nameS);
	if (*nameS == 'W')
		antrag.geschlecht = WEIBLICH;
	else
		antrag.geschlecht = MAENNLICH;

	mbfrage(sizeof(antrag.plz)-1,MBF_LINE,"    Postleitzahl: ",
			antrag.plz);

	mbfrage(sizeof(antrag.ort)-1,MBF_LINE,"    Wohnort     : ",
			antrag.ort);
	capitalize_words(antrag.ort);

	mbfrage(sizeof(antrag.strasse)-1,MBF_LINE,"    Strasse/Nr. : ",
			antrag.strasse);
	capitalize_words(antrag.strasse);

	mbfrage(sizeof(antrag.telefon)-1,MBF_LINE,"    Telefonnr.  : ",
			antrag.telefon);

	mbfrage(sizeof(antrag.computer)-1,MBF_LINE,"    Computer    : ",
			antrag.computer);

	if (antrag.computertyp)
		sprintf(nameS,"%d",antrag.computertyp);
	else
		*nameS=0;
	do
	{
		show_comp_type();

		if (logout_modus)
			break;
	
		mbfrage(2,MBF_LINE,"    Computertyp (fr die Statistik): ",
			nameS);

		if (!*nameS)
			zaehlerW=comp_type_vorschlag(antrag.computer)+1;
	
		zaehlerW = strtol(nameS,NULL,10);
	} while (zaehlerW>comp_type_zahl || zaehlerW==0);
	antrag.computertyp = zaehlerW-1;

	mboutput("\r\n");
	mboutput(" >> Angaben alle ok? (J/N) ");
	if (mbdecide("JN"," Ja ...\r\n|Nein\r\n\n") == 2)
	{
		mboutput(" Dann nochmal ... Abbruch durch Leereingabe des Benutzernamens.\r\n");
		goto again;
	}

	antrag.erster_login = time(NULL);
	antrag.level = ULV_NEU;
	antrag.protokoll = box_conf.neuuser_protokoll;
	antrag.mehr=user.mehr;
	antrag.bs_zeilen=user.bs_zeilen;
	antrag.bs_spalten=user.bs_spalten;
	antrag.terminal_typ=user.terminal_typ;
	antrag.uhrmodus=user.uhrmodus;
	antrag.box_stil=user.box_stil;
	antrag.menue_stil=user.menue_stil;
	antrag.glocke=user.glocke;
	antrag.autohilfe=user.autohilfe;
	antrag.autobefehl=user.autobefehl;
	antrag.zeichensatz=user.zeichensatz;
	antrag.protokoll=user.protokoll;
	if (akt_connection.shelluser)
		antrag.assigned_uid=akt_connection.ruid;

	mboutput("\r\n");
	if (!ub_create_user(&antrag))
	{
		mboutput(" Leider ist ein Fehler aufgetreten!\r\n");
		return FALSE;
	}

	/* GAST-Daten speichern (ntzlich wegen der Anzahl der Anrufe)
	 * und unlocken.
	 */
	ub_write_user(&user,TRUE);

	user = antrag;
	user.erster_login=time(NULL);
	user.letzter_login=user.erster_login;
	user.anrufe=1; /* was sonst tut der User gerade? */
	user.restzeit=box_conf.onlinezeit[1] * 60;
	/* und auf jeden Fall sichern */
	ub_write_user(&user,FALSE);
	mboutput(" Postfach ist angelegt\r\n\n");
	akt_anruf.neuuser=TRUE;
	strcpy(akt_anruf.name,antrag.name);

	/* Neuusertext anzeigen
	 * das ist in der DU3 das Geschwafel "Sie sind unter der und der
	 * Internetadresse erreichbar 
	 */
	 
	{
		char pa[PATH_MAX];
		sprintf(pa,"%sneuuser.txt",box_conf.texte_dir);
		if (fileexist(pa))
			zeige_interpret_datei(pa);
	}

	/* 
	 * Infotexte an den Benutzer senden 
	 */
	{
		DIR *d;
		char pa[PATH_MAX];
		char empfaenger[256];
		char absender[256];

		sprintf(absender,"Quark @ %s",MYDOMAINPART);
		sprintf(empfaenger,"%s @ %s",user.name,MYDOMAINPART);

		sprintf(pa,"%sneuuser",box_conf.texte_dir);
		d=opendir(pa);
		if (d)
		{
			struct dirent *de;
			int i=0;
			while ((de=readdir(d))!=NULL)
			{
				char betreff[256];
				if (de->d_name[0]=='.')
					continue;
				i++;
				if (i==1) {
					mboutput(" Einfhrungstext(e) zusenden\r\n");
				}
				sprintf(betreff,"Einfhrungstext %d: %s",
					i,de->d_name);
				sprintf(pa,"%sneuuser/%s",box_conf.texte_dir,de->d_name);
				einfachnachricht(TRUE,9,TRUE,pa,
					'A', empfaenger,
					'V', absender,
					'W', betreff,
					0);
			}
			closedir(d);
		}
	}
	{
		char pa[PATH_MAX];
		char empfaenger[256];
		char absender[256];
		char betreff[256];
		FILE *f;

		sprintf(absender,"Quark @ %s",MYDOMAINPART);
		sprintf(empfaenger,"Sysop @ %s",MYDOMAINPART);
		sprintf(betreff,"Neuer Benutzer: %s",user.name);

		sprintf(pa,"%sneumail",tom_tmp_dir);
		f=xfopen(pa,"w");
		fprintf(f,"Ein neuer Benutzer hat sich eingetragen:\n");
		fprintf(f,"\n");
		fprintf(f,"Name:         %s\n",user.name);
		fprintf(f,"Geburtsdatum: %d.%d.%d\n",
			user.geburtstag, user.geburtsmonat, user.geburtsjahr);
		fprintf(f,"Geschlecht:   %s\n",
			(user.geschlecht == WEIBLICH) ? "weiblich" : "mnnlich");
		fprintf(f,"PLZ:          %s\n",user.plz);
		fprintf(f,"Wohnort:      %s\n",user.ort);
		fprintf(f,"Strasse:      %s\n",user.strasse);
		fprintf(f,"Telefon:      %s\n",user.telefon);
		fprintf(f,"Computer:     %s\n",user.computer);

		fclose(f);

		mboutput("\r\n Eben mal die Systembetreuer informieren.\r\n");

		einfachnachricht(TRUE,9,TRUE,pa,
			'A', empfaenger,
			'V', absender,
			'W', betreff,
			0);
		unlink(pa);
	}

#ifdef HAVE_LIBTCL
	{
		char tclp[PATH_MAX];
		sprintf(tclp,"%s/maus/interface.tcl",box_conf.tcl_dir);
		if (fileexist(tclp)) {
			int old_mode;

			char pa[PATH_MAX];
			sprintf(pa,"%sfrontends.txt",box_conf.texte_dir);
			if (fileexist(pa))
				zeige_interpret_datei(pa);
			else
				mboutput("Wollen Sie sich nun ein MausTauschfrontend holen? (J/N) ");
			if (JAnein(NULL)) {
				old_mode=set_scroll_area(0);
				ttcl_call_func(tclp,"pt_tauschsoftmenu",NULL,NULL);
				set_scroll_area(old_mode);
			}
		}

	}
#endif

	return TRUE;

} /* bef_userantrag */

void mistuser_routine(const char *name)
{
	int i;

	mboutput("\r\n    Moment ");
	for (i = 0; i < 10; i++)
	{
		msleep(200);
		mboutput(".");
	}
	mbprintf("\r\n\n >> %s (J/N)? ",name);
	mbdecide("JN","Ja\r\n|Ja\r\n");

	mboutput("\r\n    Moment ");
	for (i = 0; i < 10; i++)
	{
		msleep(200);
		mboutput(".");
	}

	mbprintf("\r\n\n >> wirklich %s (J/N)? ",name);
	mbdecide("JN","Ja\r\n|Nein\r\n");
	mboutput("\r\n");
	mboutput("    ... na dann eben nicht.\r\n\n");
	sleep(1);
	mboutput("    und tsch.....\r\n\n");
	sleep(1);

} /* mistuser_routine */

static void
show_comp_type(void)
{
	int i;

	mboutput("\r\n");
	for (i = 0; i < comp_type_zahl; i++)
		mbprintf("  %s %d%s -> %s\r\n",
		vt_S(ATTR_INVERS),i+1,vt_S(ATTR_OFF),comp_type[i]);
}

