/* zugriff.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "befehle.h"
#include "brett.h"
#include "user.h"
#include "modem.h"

extern BRETTNR brettnrW;

/*
	Zugriffsprotokoll
	nur fr Binrbretter

	15.12.92 Frank

	BUGS:
	- diese Funktion ist eigentlich berflssig, gedacht war sie dazu, 
	  smtliche Download-Zugriffe auf ein Brett mit Username, Uhrzeit 
	  usw. zu protokollieren
	- falls die Funktion beibehalten werden soll, mu eine andere Datei 
	  als "zugriff.lst" verwendet werden, da diese bereits durch Mit-
	  gliederlisten belegt ist.
*/
BOOLEAN bef_zugriff(const char *para)
{
	char name[PATH_MAX];
	FILE *zug_f;

	if (brettart(brettnrW) != BINAER_BRETT)
	{
		mbfehler("kein Zugriffsprotokoll in Textbrettern");
		return FALSE;
	}

	sprintf(name,"%s%s",brettpfad(brettnrW),"zugriff.lst");

	if (!stricmp(para,"USER"))
	{
		if (fileexist(name))
		{
			set_status_line("Zugriffsprotokoll");
			mboutput(" Datum    Zeit   Username        Nr.  Bytes   Betreff\r\n");
			mbprintf(" %s\r\n",trennzeile);
			zeige_datei(name);
			mboutput("\r\n");
		}
		else
			mbfehler("kein Zugriffsprotokoll vorhanden");
		mboutput("\r\n");
	}
	else if (!stricmp(para,"INST"))
	{
		if (!fileexist(name))
		{
			set_status_line("Zugriffsprotokoll installieren");
			if ((zug_f = fopen(name,BINWRITE)) == NULL)
			{
				mboutput(" Kann Zugriffsprotokoll nicht anlegen\r\n");
				return FALSE;
			}
			fclose(zug_f);
			mboutput("\r\n");
			mboutput(" Zugriffsprotokoll ist installiert\r\n");
			mboutput("\r\n");
		}
		else
			mbfehler("bereits ein Zugriffsprotokoll vorhanden");
		mboutput("\r\n");
	}
	else if (!stricmp(para,"KILL"))
	{
		if (fileexist(name))
		{
			set_status_line("Zugriffsprotokoll lschen");
			unlink(name);
			mboutput("\r\n");
			mboutput(" Zugriffsprotokoll ist gelscht\r\n");
			mboutput("\r\n");
		}
		else
			mbfehler("kein Zugriffsprotokoll vorhanden");
		mboutput("\r\n");
	}
	else
	{
		return bef_inhalt(para);
	}

	return TRUE;
}
