###############################################################################
source $tomtcl_dir/maus/vars.tcl

# Ausloggen mit ! aus den Mens?
# Auf 0 oder 1 setzen.
set SCHNELLOGOUT 1

#
# Trennstriche in den Mens?
# Auf 0 oder 1 setzen.
set TRENNSTRICHE 1

#
# Wie sollen die langen Mens gestalten werden?
# "", "invers", "fett"
set MENUEHIGHLIGHT "fett"
# "", "rot", "gruen", "schwarz", "gelb",  "blau", "pink", "tuerkis", "weiss"
set MENUECOLOR "rot"

set pers_progteil_pfad "/var/spool/quark/persprog"
set pers_public_pfad "/pub/du3/benutzer"

#
# Definition von intern und extern gehandhabten Programmteilbereichen.
# Folgende Zeichen sind belegt:
# P - persnlicher Pteil.
# I - Informationen
# T - Tauschsoftware
# ! - Schnellogout
# ^ - Programmteil verlassen
# Z - Zurck
#
#
# intern gehandhabte Programmteilbereiche
#
define_progteil "(O)effentlicher Programmteil" /pub

#
# externe Programmteiloberflchen
#
define_extern_progteil "(S)hell" { tom_befehl PROGSHELL }
define_extern_progteil "(M)engefhrt (Gopher)" { tom_befehl GOPHER }

#
# An wen sollen Benachrichtigungen gehen?
# 
# Reihenfolge ist wichtig: die mehr generellen Wildcardausdrcke
# stehen *hinten*, also:
#    define_pt_mailadr "/pub/comp/*" xxx
#    define_pt_mailadr "/pub/*" yyy
# und nicht etwa umgekehrt!
#
define_pt_mailadr "*" "uwe_ohse arnd_graefe"

#
# Zugriffskontrolle
define_pt_acc "/pub/*lost+found*"       9 9 ""
# mirror rules here
define_pt_acc "/pub/gnu"                0 9 ""
# Sorry, nur fr mich ...
define_pt_acc "/pub/archiv/tmp"         9 9 ""
# newsarchiver rules here
define_pt_acc "/pub/archiv"             0 7 ""
# contributed quark stuff
define_pt_acc "/pub/quark/contrib"      0 2 ""
# official quark stuff
define_pt_acc "/pub/quark"              0 9 ""
# ich mag es nicht, wenn jemand anderes Kernel hochldt ... die installiere
# ich ja vielleicht ...
define_pt_acc "/pub/comp/linux/kernel*"  0 9 ""
# mirror rules here
define_pt_acc "/pub/comp/dos/antivirus*" 0 7 ""
# anything else under comp is read/write
define_pt_acc "/pub/comp/*"              0 2 ""
# /pub/comp selbst ist readonly
define_pt_acc "/pub/comp"                0 9 ""
# in allen anderen Unterverzeichnisse von /pub sind Uploads erlaubt
define_pt_acc "/pub/*"                   0 2 ""
# catch all
define_pt_acc "*"                        0 9 ""



define_tauschsoft "(M)auscon: Unix, Konverter RFC<->MausTausch" "mauscon" \
	/pub/maustausch/unix/mauscon-0.3.4-pre6.tar.gz
define_tauschsoft "(O)4x: Unix, MausTauschfrontend unter X11" "o4x" \
	/pub/maustausch/unix/o4x_004.tgz
define_tauschsoft "(C)at: Atari, MausTauschfrontend" "cat" \
	"/pub/maustausch/atari/cat263.tos /pub/maustausch/atari/cputz227.zip"
define_tauschsoft "O(K)ami: Atari, Frontend fr Use- und MausNet" "o4atari" \
	/pub/maustausch/atari/o_026.zip
define_tauschsoft "(X) Crosspoint: DOS, Frontend fr viele Netze" "crosspoint" \
	"/pub/maustausch/dos/xp311-1.exe \
	/pub/maustausch/dos/xp311-2.exe"
define_tauschsoft "Mi(I)nnie: DOS, Maustauschfrontend" "minnie" \
	"/pub/maustausch/dos/minf9_1.arj \
	/pub/maustausch/dos/minf9_2.arj"
define_tauschsoft "(W)intausch: Windows, Maustauschfrontend" "wintau" \
	/pub/maustausch/windows/wt_098d.zip
define_tauschsoft "(E)instein: Windows, Maustauschfrontend" "einstein" \
	/pub/maustausch/windows/ein099c3.arj
define_tauschsoft "Mause(F)alle: Macintosh, Maustauschfrontend" "mausefalle" \
	/pub/maustausch/apple/mausshar.cpt

