# gruppen.tcl: Gruppenverwaltungsmen der Mausoberflche
#
#   Copyright (C) 1995, 1996 Uwe Ohse
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#   Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
#      Snail Mail (don't expect me to answer):
#            Uwe Ohse
#            Drosselstrae 2
#            47055 Duisburg
#            Germany
#   Contact2: MausNet Newsgroups Quark & Q-Sysops.
#
#
proc gruppenmenuhelp { off lang } {
	global gname
	global SCHNELLOGOUT TRENNSTRICHE
	set auswahl ""
	if { ![tom_getvar "%gn"] } {
		set gname "Postfach"
		# Wenn im Programmfach, dann wechseln
		if { [string compare [tom_getvar "postfach_art"] "PM"] } {
			tom_befehl "PM" 
		}
	} else {
		set gname [tom_getvar "%gN"]
	}

	append_entry auswahl liste "(G)ruppe wechseln"
	append_entry auswahl liste "(K)urze Gruppenliste"
	append_entry auswahl liste "(L)ange Gruppenliste"
	if {$TRENNSTRICHE} {
		lappend liste "-----------------------------"
	}
	append_entry auswahl liste "(M)itgliederliste"
	append_entry auswahl liste "Mitgliederliste (E)ditieren"
	append_entry auswahl liste "Gruppen(I)nformation ndern"
	append_entry auswahl liste "Gruppen(S)tatistik"
	append_entry auswahl liste "Gruppen(T)raffic"
	if {$TRENNSTRICHE} {
		lappend liste "-----------------------------"
	}
	if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}
	append_entry auswahl liste "(Z)urck zum Hauptmen"

	if { $lang } {
		if { $off > 0} {
			# Wenn nicht Hilfe, sondern Men 
			tom_puts "($gname)"
		}
		do_help $off $liste
		return "$auswahl"
	}
	kurz_menue_hilfe "$auswahl"
	return "${auswahl},?"
}

proc gruppenmenu { } {
	global gname
	global logout_modus
	while (1) {
		set wahl [work_menu "Gruppenverwaltung" gruppenmenuhelp]
        if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
        } elseif { "$wahl" == "!" } {
            tom_befehl LOGOUT
		} elseif { "$wahl" == "G" } {
			set gruppe "X"
			while {[string length "$gruppe"] == 1} {
				tom_puts "Welche Gruppe? (L fr Liste)"
				set gruppe [tom_gets]
				if { ![string compare "L" "$gruppe"] \
					|| ![string compare "l" "$gruppe"]} {
					tom_befehl "BRETT *"
				} elseif {[string length "$gruppe"] >0} {
					tom_puts "$gruppe"
					tom_befehl "BRETT $gruppe"
				} else {
					break
				}
			}
			set gname [tom_getvar "%gN"]
		} elseif { "$wahl" == "K" } {
			tom_befehl "INFO IGK"
    		wait_after
		} elseif { "$wahl" == "L" } {
			tom_befehl "INFO IGL"
    		wait_after
		} elseif { "$wahl" == "M" } {
			# Mitgliederliste ansehen
			tom_befehl "LISTE"
    		wait_after
		} elseif { "$wahl" == "E" } {
			# Mitgliederliste editieren
			tom_befehl "EDIT ACCESS"
    		wait_after
		} elseif { "$wahl" == "I" } {
			# Gruppeninformationstext editieren
			tom_befehl "EDIT INFO"
    		wait_after
		} elseif { "$wahl" == "S" } {
			# Gruppenstatistik
			tom_befehl "BRETT #"
    		wait_after
		} elseif { "$wahl" == "T" } {
			# Gruppentraffic
			tom_befehl "TRAFFIC"
    		wait_after
		} elseif { "$wahl" == "L" } {
			# Lschen 
			tom_puts -nonewline "Welche Nachricht(en) lschen? "
	    	set bereich [tom_gets]
    		if { [string length "$bereich"] > 0 } {
    			tom_befehl "KILL $bereich"
    		}
    		wait_after
		} else { 
			tom_puts "????" 
		}
	}
}

