# Informationen.tcl: Informationsmen der Mausoberflche
#
#   Copyright (C) 1995, 1996 Uwe Ohse
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#   Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
#      Snail Mail (don't expect me to answer):
#            Uwe Ohse
#            Drosselstrae 2
#            47055 Duisburg
#            Germany
#   Contact2: MausNet Newsgroups Quark & Q-Sysops.
#
#
#
proc do_infomenuhelp { off lang } {
	global SCHNELLOGOUT
	global TRENNSTRICHE
	global aktuelles_infomenue
	set my_lv [expr [tom_getvar "%ul"] + 0 ]
	set auswahl ""
	set files [tom_infomenu_files "$aktuelles_infomenue"]
	foreach i $files {
		set lv [expr [tom_info_level $i] + 0]
		if {$lv > $my_lv} {
			continue;
		}
		set key [tom_info_key $i $aktuelles_infomenue]
		if {0 == [string compare "$key" "" ] } continue;
		set text [tom_info_text $i]
		set key [string toupper $key]
		if {[regsub -nocase $key $text "($key)" text] == 0} {
			lappend liste "-- cannot substitute selection key $key --"
		} else {
			append_entry auswahl liste $text
		}
	}
	set menues [tom_infomenu_submenus "$aktuelles_infomenue"]
	if [string compare $menues ""] {
		if {$TRENNSTRICHE} {
			lappend liste "-----------------------------"
		}
	}
	foreach i $menues {
		set lv [expr [tom_infomenu_level $i] + 0]
		if {$lv > $my_lv} continue;
		set key [tom_infomenu_key $aktuelles_infomenue $i]
		if {0 == [string compare "$key" "" ] } continue;
		set key [string toupper $key]
		set title [tom_infomenu_title $i]
		regsub -nocase $key $title "($key)" title
		append_entry auswahl liste $title
	}
	if {$TRENNSTRICHE} {
		lappend liste "-----------------------------"
	}
	if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}
	append_entry auswahl liste "(Z)urck"
	if {$lang} {
		do_help $off $liste
		return "${auswahl}"
	}
	kurz_menue_hilfe "$auswahl"
	return "${auswahl}?"
}

proc do_infomenu { which } {
	global logout_modus
	global aktuelles_infomenue
	set files [tom_infomenu_files "$which"]
	set title [tom_infomenu_title "$which"]
    set menues [tom_infomenu_submenus "$which"]
	set aktuelles_infomenue $which
	set my_lv [expr [tom_getvar "%ul"] + 0 ]
	while (1) {
		set wahl [work_menu "$title" do_infomenuhelp]
		if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
		} elseif { "$wahl" == "!" } {
			tom_befehl LOGOUT
		} else {
			set files [tom_infomenu_files "$aktuelles_infomenue"]
			set found 0
			foreach i $files {
				set lv [expr [tom_info_level $i] + 0]
				if {$lv > $my_lv} continue;
				set key [tom_info_key $i $aktuelles_infomenue]
				if {0 != [string compare "$key" "$wahl" ] } continue;
				# das ist er
				tom_befehl "INFO $i"
				set found 1
				wait_after
				break
			}
			if {$found == 0} {
				set menues [tom_infomenu_submenus "$aktuelles_infomenue"]
				foreach i $menues {
					set lv [expr [tom_infomenu_level $i] + 0]
					if {$lv > $my_lv} continue;
					set key [tom_infomenu_key $aktuelles_infomenue $i]
					if {0 != [string compare [string toupper "$key"] "$wahl" ] } continue;
					set old $aktuelles_infomenue
					do_infomenu $i
					set aktuelles_infomenue $old
					set found 1
					break
				}
			}
			if {$found == 0} {
				tom_puts "Infofile/Men fr $wahl nicht gefunden"
			}
		}
	}
}
