proc pt_readdir { dir dirs dirscount filescount} {
	upvar $dirs d
	upvar $dirscount dc
	upvar $filescount fc
	set dc 0
	set fc 0
	if {[catch {set f [glob "$dir/*"]}] == 0} {
		foreach i $f {
			if [file isdirectory $i] {
				set d($dc) [file tail $i]
				incr dc
			} else {
				incr fc
			}
		}
	}
	for {set i 0} {$i < $dc - 1} {incr i} {
		for {set j [expr $i + 1]} {$j < $dc} {incr j} {
			if {[string compare $d($i) $d($j)] > 0} {
				set t $d($i)
				set d($i) $d($j)
				set d($j) $t
			}
		}
	}
}

proc pt_calcfiles {dir files_p filescount_p uplfiles_p oneliners_p} {
	upvar $files_p files
	upvar $filescount_p filescount
	upvar $uplfiles_p uplfiles
	upvar $oneliners_p oneliners
	set found 0

	set count 0
	if {[catch {set g [glob "$dir/*"]}] == 0} {
		foreach i $g {
			if [file isdirectory $i] {
				continue
			} else {
				lappend lis [file tail $i]
				incr found
			}
		}
	}
	if {0==$found} return
	# Sortieren - bis jetzt ist das ja noch einfach.
	if {$count > 50} { tom_puts "sortiere"}
	foreach i [lsort $lis] {
		set f($count) $i
		set is_upl($count) -1
		set has_upl($count) -1
		incr count
	}

	if {$count > 50} { tom_puts "analysiere"}
	# der folgende Code geht absichtlich nicht durch die gesamte Liste,
	# sondern nur die 5 Files vor und nach dem aktuellen. Das reicht
	# aus, da a) die Liste sortiert ist und b) nur wenige Files
	# mit demselben Namensanfang existieren drften.
	for {set i 0} {$i < $count} {incr i} {
		if {$is_upl($i) > -1} { continue }
		if {$has_upl($i) > -1} { continue }
		set this $f($i)
		set e [file extension $this]
		if {0==[string compare $e ".upl"]  \
			|| 0==[string compare $e ".lsm"] \
			|| 0==[string compare $e ".README"]} {
			set is_upl($i) 1
			set newlen [expr [string length $this] - [string length $e] - 1]
			set s [string range $this 0 $newlen]
			set j [expr $i - 5]
			if {$j < 0} {set j 0}
			for {} {$j < $count && $j < $i + 5} {incr j} {
				if {$has_upl($j) > -1 || $is_upl($j) > -1} continue
				if {0==[string first $s $f($j)]} {
					set e2 [file extension $f($j)]
					if {0!=[string compare $e2 ".upl"]  \
						&& 0!=[string compare $e2 ".lsm"] \
						&& 0!=[string compare $e2 ".README"]} {
						set has_upl($j) $i
					}
				}
			}
		}
	}

	# jetzt in das Resultatarray eintragen.
	if {$count > 50} { tom_puts "vervollstndige"}
	set filescount 0
	for {set i 0} {$i < $count} {incr i} {
		if {$is_upl($i) > 0} continue
		set files($filescount) $f($i)
		if {$has_upl($i)>-1} {
			set uplfiles($filescount) $f($has_upl($i))
		} else {
			set uplfiles($filescount) ""
		}
		set oneliners($filescount) ""
		incr filescount
	}
	if {$count > 50} { tom_puts "hole kurzbeschreibungen"}
	set s "$dir/INDEX"
	if [file exists $s] {
		set text [readfile $s]
		pt_sunsite_index $text $filescount files oneliners
		pt_tcl_index $text $filescount files oneliners
	}
}


proc pt_printout { args } {
	foreach i $args {
		foreach j [split $i "\n"] {
			set ret [tom_puts "$j"]
			if {$ret <= 0} { 
				return 0
			}
		}
	}
	return 1
}

proc pt_printout_ls { args } {
	global suchwort
	set found 0
	if [string compare $suchwort ""] {
		foreach i $args {
			foreach j [split $i "\n"] {
				if {1 == [string match $suchwort [string tolower $j]]} {
					tom_puts "$j"
					set found 1
				}
			}
		}
		if {$found > 0} {
			tom_puts ""
		}
		return
	}
	foreach i $args {
		foreach j [split $i "\n"] {
			tom_puts "$j"
		}
	}
}

proc pt_match { str such suchart } {
	set s [string tolower $str]
	if {$suchart == 0} {
		if {[string first $such $s] == -1} { return 0}
		return 1
	} elseif {$suchart == 1} {
		if {1 == [string match $such $s]} { return 1}
		return 0
	} else {
		if {1 == [regexp -- $such $s]} { return 1}
		return 0
	}
}

proc pt_get_acc { which readflag writeflag } {
	global pt_username
	upvar $readflag r
	upvar $writeflag w
	global pt_userlevel
	global pt_acc pt_acczahl

	set r 0
	set w 0
	for {set i 0} {$i<$pt_acczahl} {incr i} {
		if {1 == [string match $pt_acc($i,dir) $which]} { 
			if {$pt_acc($i,r) <= $pt_userlevel} { set r 1}
			if {$pt_acc($i,w) <= $pt_userlevel} { set w 1}
			if {$pt_acc($i,acl)>""} {
				also gut, acl-Kontrolle ...
				set f $pt_acc($i,acl)
				if [file exists $f] {
					set w [tom_acl -user "$pt_username" -level $pt_userlevel -type "W" $f]
					set r [tom_acl -user "$pt_username" -level $pt_userlevel -type "R" $f]
				}
			}
			return
		}
	}
} 

proc pt_find_persprog { name nummer } {
	global pers_progteil_pfad
	set tmp "$pers_progteil_pfad/$name"
	regsub " " $tmp "_" tmp
	set tmp2 "$pers_progteil_pfad/$nummer"
	if [file isdirectory $tmp] {
		set dir $tmp
	} elseif [file isdirectory $tmp2] {
		set dir $tmp2
	} else {
		catch {exec sh -c "mkdir $tmp 2>/dev/null"}
		if [file isdirectory $tmp] {
			catch {exec sh -c "chmod 0700 $tmp 2>/dev/null"}
			set dir $tmp
		} else {
			catch {exec sh -c "mkdir $tmp2 2>/dev/null"}
			if [file isdirectory $tmp2] {
				catch {exec sh -c "chmod 0700 $tmpw 2>/dev/null"}
				set dir $tmp
			} else {
				return ""
			}
		}
	}
	return $dir
}
