

# Sunsite-Indexfiles:
#/pub/Linux (INDEX)
#------------------------------------------------------------------------------
#00-find.Linux.gz         output of find . -name "*" -print
#ALPHA/                   software and patches in the ALPHA stage
#GCC/                     A port of GNU C and C++ for Linux
#Incoming/                Place new uploads here
#
# oh, well - we *can* handle this!

proc pt_sunsite_index {text filescount files_p oneliners_p} {
	upvar $oneliners_p oneliners
	upvar $files_p files

	set lc 0
	set found 0

	for {set k 0} {$k < $filescount} {incr k} {
		set ptr($files($k)) $k
	}

	foreach i [split $text "\n"] {
		incr lc
		if {$lc == 1} {
			set c [string index $i 0]
			if [string compare $c "/"] {
				# die erste Zeile enthlt den Dateinamen
				# der Indexdatei. Und beginnt mit /
				return 0
			}
			continue
		}
		if {$lc == 2} {
			# zweite Zeile enthlt nur Minuszeichen
			set rest [string trim $i "-"]
			if [string compare $rest ""] {
				return 0
			}
			continue
		}
		set j [string first " " $i]
		set name [string trim [string range $i 0 $j]]
		set desc [string trim [string range $i $j end]]
		set k [array names ptr $name]
		if {0==[string compare $k ""]} {
			continue
		}
		incr found
		set nummer $ptr($k)
		if {0==[string compare $desc ""]} {continue}
		set oneliners($nummer) $desc
	}
	return $found
}

# Tcl/Tk-Indexfiles:
#################################################
#Tcl/Tk Code Index
#-----------------
#Directory: /tcl/code
#
#tkinspect-4d.README
#tkinspect-4d.tar.gz Browser/inspector for Tk programs. For Tk 3.6.
#               Sam Shen (sls@aero.org)
#
#tkinspect-5.1.6.README
#tkinspect-5.1.6.tar.gz  Browser/inspector for Tk programs. For Tk 4.0.
#               Sam Shen (sls@aero.org)
#################################################
#
# oh, well - we *can* handle this, even if it hurts
proc pt_tcl_index {text filescount files_p oneliners_p} {
	upvar $oneliners_p oneliners
	upvar $files_p files

	set lc 0
	set found 0

	set info ""
	set nummer -1

	for {set k 0} {$k < $filescount} {incr k} {
		set ptr($files($k)) $k
	}

	foreach s [split $text "\n"] {
		incr lc
		if {$lc == 1} {
			if [string first "Tcl/Tk" $s] {
				return
			}
			continue
		} elseif {$lc == 2} {
			# zweite Zeile enthlt nur Minuszeichen
			set rest [string trim $s "-"]
			if [string compare $rest ""] {
				return 0
			}
			continue
		} elseif {$lc == 3} {
			if [string first "Directory" $s] {
				return 0
			}
			continue
		}
		if {0==[string compare $s ""]} {
			# leerzeile beendet einen Datensatz
			if {-1!=$nummer && $info != ""} {
				set oneliners($nummer) $info
				incr found
			}
			set nummer -1
			set info ""
			continue
		}
		# zwei Zeilentypen ...
#tkinspect-5.1.6.README
#tkinspect-5.1.6.tar.gz  Browser/inspector for Tk programs. For Tk 4.0.
#               Sam Shen (sls@aero.org)
		# brigens kann der Text mehrzeilig sein ...
		set j [string first "\t" $s]
		if {$j==-1} {set j 999}
		set name [string trim [string range $s 0 $j]]
		set desc [string trim [string range $s $j end]]

		set k [array names ptr $name]
		if {0==[string compare $k ""]} {
			continue
		}
		set nummer $ptr($k)
		if {0==[string compare $desc ""]} {continue}
		if {0==[string compare $info ""]} {
			set info $desc
		} else {
			set info "$info $desc"
		}
	}
	return $found
}

