#
# pt_progteil.tcl: Die Behandlung eines Programmteils
#
proc pt_printdirs { d dirscount } {
set llen 80
	upvar $d dirs
	set len 0
	set max 0
	for {set i 0} {$i < $dirscount} {incr i} { 
		set l [string length $dirs($i)]
		if {$l > $max} {
			set max $l
		}
	}
	tom_puts "max=$max"
	if {$max <= 0} return
	set dperline [expr $llen / $max]
	if {$dperline < 0} {
		set dperline 1
	}
	set place [expr $llen / $dperline - 1]
	if {$place < 15} {
		set place 15
	}
	for {set i 0} {$i < $dirscount} {incr i} { 
		set l [string length $dirs($i)]
		if {[expr $len + $l + 4] >= $llen} {
			tom_puts ""
			set len 0
		}
		if {$i<10} {
			set s [format " (%d) %-*.*s" $i $place $place $dirs($i)]
		} elseif {$i<36} {
			set s [format " (%c) %-*.*s" [expr $i + 65 - 10] $place $place $dirs($i)]
		} else {
			set s [format "    %-*.*s" $place $place $dirs($i)]
		}
		set len [expr $len + [string length $s]]
		tom_puts -nonewline $s
	}
	tom_puts ""
}

proc pt_files_loeschen { which files_p filescount uplfiles_p oneliners_p } {
	global pt_dir_hack
	global pt_in_pers_progteil
	global pt_in_pers_public
	global pt_tagged_files
	upvar $files_p files
	upvar $uplfiles_p uplfiles
	upvar $oneliners_p oneliners


	if {0!=[info exists pt_tagged_files] && [llength $pt_tagged_files]} {
		pt_handle_tagged 1
		return;
	}

	tom_puts "Bitte geben sie das Suchwort ein (Wildcards erlaubt)."
	tom_puts "Vergleiche werden caseinsensitiv durchgefhrt. Suchbegriff:"
	set such [tom_gets]
	if {$such == ""} {
		return
	}
	for {set i 0} { $i < $filescount} { incr i } {
		set this [pt_match $files($i) $such 1]
		if {$this} {
			set e [pt_present_one $which $files($i) $uplfiles($i) $oneliners($i) 1]
			if {$e==0} break
		}
	}
}

proc progteilmenuhelp { off lang} {
	global SCHNELLOGOUT TRENNSTRICHE
	global pt_dir_hack
	global pt_in_pers_progteil
	global pt_in_pers_public
	set auswahl ""

	if [file exists $pt_dir_hack/.quarkinfo] {
		tom_display_file $pt_dir_hack/.quarkinfo
	}

	if {! $pt_in_pers_progteil} {
		if {$pt_in_pers_public} {
			append_entry auswahl liste "(V)erzeichnis wechseln"
			append_entry auswahl liste "Benutzer (E)ingeben"
		} else {
			append_entry auswahl liste "(V)erzeichnis wechseln"
			append_entry auswahl liste "Verzeichnis (E)ingeben"
		}
	} 
	append_entry auswahl liste "(L)ange Liste ausgeben"
	append_entry auswahl liste "(K)urze Liste ausgeben"
	append_entry auswahl liste "(S)ehr kurze Liste ausgeben"
	append_entry auswahl liste "Such(B)egriff konfigurieren"
	append_entry auswahl liste "(D)ownload"
	append_entry auswahl liste "(U)pload"
	if {$pt_in_pers_progteil} {
		append_entry auswahl liste "(P)rogramme loeschen"
	}
	if {$TRENNSTRICHE} {
		lappend liste "-----------------------------"
	}
	append_entry auswahl liste "(Z)urck"
	append_entry auswahl liste "(^) Programmteil verlassen"
	if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}
	if {$lang} {
		do_help $off $liste
		return "${auswahl}"
	}
	kurz_menue_hilfe "$auswahl"
	return "${auswahl}?"
}

proc progteilmenu { which } {
	global quickout
	global logout_modus
	global pt_dir_hack
	global pt_in_pers_progteil
	global pt_in_pers_public
	global pt_username
	global pers_public_pfad

	if {$pt_in_pers_progteil == 0} {
		if {$pt_in_pers_public == 0} {
			pt_get_acc $which r_ok w_ok
			if {0==$r_ok} {
				tom_puts ""
				tom_puts "Verzeichnis gesperrt!"
				tom_puts ""
				return
			}
		} else {
			set r_ok 1
			set index [string last "/" $which]
			if {$index == -1} {
				tom_puts "interner Fehler: Kein / im Pfad"
				return
			}
			set index [expr $index + 1]
			set s [string range $which $index 9999]
			if {0==[string length $s]} {
				tom_puts "interner Fehler: Kann Benutzernamen nicht identifizieren"
				return
			}
			set t [tom_getvar "\${ucanon %uN}"]
			regsub " " $t "_" t

			if {0==[string compare $t $s]} {
				set r_ok 1
				set w_ok 1
			} else {
				set r_ok 1
				set w_ok 0
			}
		}
	} else {
		set r_ok 1
		set w_ok 1
	}

	pt_readdir $which dirs dirscount filescount

	set got_files 0

	set l [string length $which]
	if {$l > 40} {
		set dirname [format "...%s" [string range $which [expr $l - 40] end]]
	} else {
		set dirname $which
	}
	while (1) {
		if {$quickout} { return }

		set pt_dir_hack $which
		if {$w_ok==0} {
			set desc "readonly, "
		} elseif {$r_ok==0} {
			set desc "writeonly, "
		} else {
			set desc ""
		}
		set wahl [work_menu "Programmteil ($desc$dirname)" progteilmenuhelp]
		if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
		} elseif { "$wahl" == "!" } {
			tom_befehl LOGOUT
		} elseif { "$wahl" == "^"} {
			set quickout 1
			return
		} elseif { "$wahl" == "L"} {
			# lange Liste ausgeben 
			if {0 == $got_files} {
				pt_calcfiles $which files filescount uplfiles oneliners
				set got_files 1
			}
			pt_inhalt $which "lang" files $filescount uplfiles oneliners
			wait_after
		} elseif { "$wahl" == "K"} {
			# kurze Liste ausgeben 
			if {0 == $got_files} {
				pt_calcfiles $which files filescount uplfiles oneliners
				set got_files 1
			}
			pt_inhalt $which "mittel" files $filescount uplfiles oneliners
			wait_after
		} elseif { "$wahl" == "S"} {
			# sehr kurze Liste ausgeben 
			if {0 == $got_files} {
				pt_calcfiles $which files filescount uplfiles oneliners
				set got_files 1
			}
			pt_inhalt $which "kurz" files $filescount uplfiles oneliners
			wait_after
		} elseif { "$wahl" == "B"} {
			progteilsuchmenu
		} elseif { "$wahl" == "P"} {
			# loeschen von Files.
			if {0 == $got_files} {
				pt_calcfiles $which files filescount uplfiles oneliners
				set got_files 1
			}
			pt_files_loeschen $which files $filescount uplfiles oneliners
			# recalc ...
			pt_calcfiles $which files filescount uplfiles oneliners
		} elseif { "$wahl" == "D"} {
			# Download
			if {0 == $got_files} {
				pt_calcfiles $which files filescount uplfiles oneliners
				set got_files 1
			}
			progteildownloadmenu $which files $filescount uplfiles oneliners
		} elseif { "$wahl" == "U"} {
			# Upload
			if {$w_ok} {
				pt_upload $which
			} else {
				tom_puts "Verzeichnis ist fr Uploads gesperrt."
			}
			tom_puts ""
			wait_after
		} elseif { "$wahl" == "V"} {
			# Verzeichnis wechseln
			set c ""
			tom_puts ""
			tom_puts "Verzeichnis wechseln"
			tom_puts ""
			pt_printdirs dirs $dirscount
			tom_puts "(.). Ein Verzeichnis zurck"
			tom_puts ""
			tom_puts "( ) Abbruch"
			set allowed [string range "01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ" 0 $dirscount]
			set allowed "${allowed} ."
			while {-1 == [string first $c $allowed]} {
				set c [string toupper [tom_getchar]]
			}
			if {0==[string compare $c "."]} { return }
			if {0==[string compare $c " "]} { continue }
			set i [string first $c "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"]
			if {$i < $dirscount} {
					progteilmenu "$which/$dirs($i)"
			} else {
				tom_puts "hmm? i=$i, dirscount=$dirscount"
			}
		} elseif { "$wahl" == "E" } {
			if {$pt_in_pers_public} {
				tom_puts "Zu welchem Benutzer wechseln? Leereingabe bricht ab"
				set p [tom_gets]
				if {0==[string compare $p ""]} { continue }
				if {0==[string compare $p ".."]} { return }
				set n [tom_user find $p]
				if {0==[string compare $n ""]} {
					tom_puts ""
					tom_puts "Benutzer unbekannt"
					tom_puts ""
					continue
				}
				set t [tom_getvar "\${ucanon $n}"]
				regsub " " $t "_" t
				progteilmenu "$pers_public_pfad/$t"
			} else {
				# Pfad angeben
				tom_puts "In welches Verzeichnis wechseln? Leereingabe bricht ab"
				set p [tom_gets]
				if {0==[string compare $p ""]} { continue }
				if {0==[string compare $p ".."]} { return }
				if {-1!=[string first ".." $p ]} { 
					tom_puts ".. im Pfad nicht erlaubt"
					continue;
				} 
				set c [string range $p 0 1]
				if {0!=[string compare $c "/"]} {
					progteilmenu "$which/$p"
				} else {
					progteilmenu "$p"
				}
			}
		}
	}
}

proc pt_progteil { which } {
	global pt_tagged_files

	#
	# Problem: Beim Verlassen eines Programmteils/persnlichen Programmfaches
	# muessen die Tags geloescht werden, weil beim Lschen von getaggten 
	# Files keine Zugriffsrechtsprfung stattfindet. C'est la vie ...
	#
	while {1} {
		progteilmenu $which
		if {0==[info exists pt_tagged_files]} return
		if [llength $pt_tagged_files] {
			tom_puts \
"Sie haben noch Dateien getaggt. Wollen Sie die jetzt downloaden?" 
			tom_puts \
"  (J)etzt downloaden, (P)rogrammteil nicht verlassen, Tags (L)schen: "
			set wahl [format %c [tom_select { J "Jetzt\r\n" \
				"P" "Programmteil nicht verlassen" \
				"L" "Tags lschen\r\n"} ]]
			if {0==[string compare $wahl "J"]} {
				pt_handle_tagged 0
			} elseif {0==[string compare $wahl "L"]} {
				set pt_tagged_files ""
				return
			}
		} else {
			return 
		}
	}

}
