proc pt_upload { which } {
	global pers_progteil_pfad

	set tmpdir [tom_getvar %pu]
	global pt_in_pers_progteil

	set mailadr "uwe_ohse"

	if {![file isdirectory $tmpdir]} {
		tom_putfehler "Tempverzeichnis ist kein Verzeichnis?"
		wait_after
		return
	}
	set readmemagic "readme|upl|lsm"

	catch {exec -- rm -rf $tmpdir/* 2>/dev/null}
	catch {exec -- rmdir -f $tmpdir/* 2>/dev/null}

	set p [tom_user get "default_protokoll"]
	if {0==[string compare $p ""]} {
		tom_puts "Protokollauswahl"
		set p [tom_transfer_protokollauswahl]
	}
	if {0==[string compare $p ""]} {
		tom_puts "Abbruch: Kein Protokoll ausgewhlt"
	}

	if {"" == [tom_transfer_receive $p]} {
		# nichts upgeloadet
		tom_puts "Abbruch: Keine Datei upgeloadet"
		return;
	}

	set liste [ glob -nocomplain -- "$tmpdir/*"]
	# Pass 1: Alles, was nicht .README, .upl endet.
	set readmes 0
	set files 0
	foreach i $liste {
		if {[file isdirectory $i]} {
			# Ein Verzeichnis angelegt? Wie das? Aber egal - besser
			# wir kommen damit klar ... was heit: Weg damit
			tom_puts ""
			tom_puts "$i"
			tom_puts "  Verzeichnis ignoriert!"
			tom_puts ""
			catch {exec -- rmdir -f $i/* 2>/dev/null}
			continue
		}

		set pos [string last / $i]
		incr pos
		set i [string range $i $pos end]
		if [regexp -nocase "\.($readmemagic)$" $i] {
			tom_puts "$i: uploadinfo"
			set readme($readmes) $i
			incr readmes
		} else {
			tom_puts "$i: file"
			set file($files,fname) $i
			set file($files,upl) ""
			incr files
		}
	}

	if {$readmes == 0 && $files == 0} {
		tom_puts "kein Upload erfolgt"
		return;
	}
	if  {$pt_in_pers_progteil} {
		set ziel ""
		while {[string compare $ziel ""] == 0} {
			tom_puts "Wem uploaden? Leereingabe fr Abbruch"
			set ziel [tom_gets]
			if {[string compare $ziel ""] == 0} {
				tom_puts "Wirklich abbrechen?"
				set janein [tom_select { "J" "Ja, Abbruch\r\n" "N" "Nein" }]
				if {[string compare $janein "J"] == 0} {
					set ziel "..abbruch.."
				} else {
					set ziel ""
				}
			} else {
				set u [tom_user find $ziel]
				if {[string compare $u ""] == 0} {
					tom_puts "Benutzer unbekannt!"
					set ziel ""
				} else {
					set ziel $u
					set tmp_uname [tom_getvar "\${ucanon $ziel}"]
					set tmp_unummer [tom_user -user $ziel get nummer]
					set which [pt_find_persprog $tmp_uname $tmp_unummer]
					if {0==[string compare $which ""]} {
						tom_puts " Der persnliche Programmteil von $tmp_uname ist nicht vorhanden."
						tom_puts " Er kann kann auch nicht angelegt werden"
					}
				}
			}
		}
		if {[string compare $ziel "..abbruch.."] == 0} {
			catch {exec -- rm -rf $tmpdir/* 2>/dev/null}
			catch {exec -- rmdir -f $tmpdir/* 2>/dev/null}
			return
		}
		tom_puts " upload nach $which"
	}
	for {set i 0} {$i < $files} {incr i} {
		set f $file($i,fname)

		# Suchen nach $f.upl, $f.readme
		for {set j 0} {$j < $readmes} {incr j} {
			set u $readme($j)
			if [regexp -nocase "^$f\.($readmemagic)$" $u] {
				set file($i,upl) "$u" 
				set readme($j) ""
				break;
			}
		}
		# Falls "xyz.tar.gz", dann finden wir auch noch "xyz.readme" und
		# "xyz.tar.readme"
		if {$file($i,upl) == ""} {
			for {set j 0} {$j < $readmes} {incr j} {
				set u $readme($j)
				# $f.upl, $f.readme
				if {$u > ""} {
					set pos [string last . $f]
					if {$pos>0} {
						incr pos -1
						set f [string range $f 0 $pos]
				 		if [regexp -nocase "^$f\.($readmemagic)$" $u] {
							set file($i,upl) "$u" 
							set readme($j) ""
				 			break;
				 		}
					}
					# und noch ein Punkt weniger ...
					set pos [string last . $f]
					if {$pos>0} {
						incr pos -1
						set f [string range $f 0 $pos]
				 		if [regexp -nocase "^$f\.($readmemagic)$" $u] {
							set file($i,upl) "$u" 
							set readme($j) ""
				 			break;
				 		}
					}
				}
			}
		}
	}

	# jetzt knnte jedes File einen Uploadtext haben.
	for {set i 0} {$i < $files} {incr i} {
		set f $file($i,fname)
		set u $file($i,upl)
		if {$u == ""} {
			tom_puts "Zu $f fehlt ein Uploadtext."
			tom_puts -nonewline "Wollen Sie den jetzt eingeben? (J/N)"
			set wahl [format %c [tom_select { J "Uploadtext eingeben\r\n" "N" "Nicht\r\n" }]]
			if {$wahl == "N"} {
				tom_puts \
"Bitte! So eine kleine Beschreibung macht nicht viel Arbeit und hilft sehr!"
				tom_puts -nonewline "Wollen Sie ihn nun doch eingeben? (J/N)"
				set wahl [format %c [tom_select { J "Uploadtext eingeben\r\n" \
					"N" "Wirklich nicht :-(\r\n" } ]]
			}
			if {$wahl == "J"} {
				set e "$tmpdir/$f.upl"
				tom_edit $e
				if [file exist $e] {
					set file($i,upl) $f.upl
				}
			}
		} 
	}
	set fd [open "$tmpdir/.uploadinfo" "w"]
	puts $fd "Upload von [tom_user get name] in $which:"
	# Nun den Kram verschieben.
	for {set i 0} {$i < $files} {incr i} {

		puts $fd "$file($i,fname): [file size $tmpdir/$file($i,fname)] Bytes"

		if {[catch {exec -- mv -f $tmpdir/$file($i,fname) $which} errt]!=0} {
			tom_puts "kann Datei nicht verschieben: $errt"
			continue
		}
		set u $file($i,upl)
		if {$u >""} {
			regsub -nocase ".readme$" $u .README u
			regsub -nocase ".lsm$" $u .lsm u
			regsub -nocase ".upl$" $u .upl u

			puts $fd "$u: [file size $tmpdir/$file($i,upl)] Bytes"

			if {0==[catch {set id [open $u "a+"]} errt]} {
				puts $id "------------------------------"
				puts $id "Upload durch: [tom_getvar %uN]"
				close $id
			}
			exec -- mv -f $tmpdir/$file($i,upl) $which/$u
		} else {
			if {0==[catch {set id [open $u "w"]} errt]} {
				puts $id "Upload durch: [tom_getvar %uN]"
				close $id
			}
		}

		puts $fd ""
	}
	# Nun nicht zu einem File gehrige Infotexte verschieben.
	for {set i 0} {$i < $readmes} {incr i} {
		if {$readme($i) > ""} {
			puts $fd \
"Stray text: $readme($i): [file size $tmpdir/$readme($i)] Bytes"
			exec -- mv -f $tmpdir/$readme($i) $which
		}
	}
	close $fd
# Swig kriegt BOOLEAN wohl nicht hin?
#	tom_puts "Nachricht an den/die Programmteilverwalter senden:"
#
#	set mailadr [pt_get_mailadr $which]
#
#	tom_einfachnachricht YES 9 YES "$tmpdir/.uploadinfo"	\
#		{ W "Uploads in $which" \
#		V "Quark @ [tom_getvar %@]" \
#		A "$mailadr" }

	catch {exec -- rm -rf $tmpdir/* 2>/dev/null}
	catch {exec -- rmdir -f $tmpdir/* 2>/dev/null}
}
