# sysopmenu.tcl: Sysopmen der Mausoberflche
#
#   Copyright (C) 1995, 1996 Uwe Ohse
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#   Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
#      Snail Mail (don't expect me to answer):
#            Uwe Ohse
#            Drosselstrae 2
#            47055 Duisburg
#            Germany
#   Contact2: MausNet Newsgroups Quark & Q-Sysops.
#
proc sysopmenuhelp { off lang } {
	global SCHNELLOGOUT
	global TRENNSTRICHE
	set auswahl ""

	append_entry auswahl liste "(K)onfiguration ndern"
	append_entry auswahl liste "(S)hell aufrufen"
	append_entry auswahl liste "S(Y)sopinformationen"
	if {$TRENNSTRICHE != 0} {
		lappend liste "---------------------"
	}
    if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}

	append_entry auswahl liste "(Z)urck"

	if { $lang } {
		do_help $off $liste
		return "$auswahl"
	}
	kurz_menue_hilfe $auswahl
	return "$auswahl?"
}

proc sysopmenu { } {
	global logout_modus
	while (1) {
		set wahl [work_menu "Sysopfunktionen" sysopmenuhelp]
		if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
        } elseif { "$wahl" == "!" } {
			tom_befehl LOGOUT
		} elseif { "$wahl" == "S" } {
			tom_befehl "SHELL"
		} elseif { "$wahl" == "K" } {
			konfigmenu
		} elseif { "$wahl" == "Y" } {
			do_infomenu sysop
		} else { 
			tom_puts "????" 
		}
	}
}

proc misckonfigmenuhelp { off lang } {
	global SCHNELLOGOUT
	global TRENNSTRICHE
	set auswahl ""

	append_entry auswahl liste "(S)ortierung der Gruppen, order.cnf"
	append_entry auswahl liste "(P)acker, packer.cnf"
	append_entry auswahl liste "(C)onnects, connect.cnf"
	append_entry auswahl liste "Sp(E)zielle Logins, speclogin.cnf"
	append_entry auswahl liste "S(A)ugtausch, saugtausch.cnf"
	append_entry auswahl liste "(U)nerwnschte User, mistuser.cnf"
	append_entry auswahl liste "(B)ertragungsprotokolle, transfer.cnf"
	if {$TRENNSTRICHE} {
		lappend liste "---------------------"
	}
    if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}

	append_entry auswahl liste "(Z)urck"

	if { $lang } {
		do_help $off $liste
		return "$auswahl"
	}
	kurz_menue_hilfe $auswahl
	return "$auswahl?"
}

proc misckonfigmenu { } {
	global logout_modus
	while (1) {
		set wahl [work_menu "Boxkonfiguration" misckonfigmenuhelp]
		if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
        } elseif { "$wahl" == "!" } {
			tom_befehl LOGOUT
		} elseif { "$wahl" == "S" } {
			tom_edit -backup "[tom_getvar %ps]order.cnf"
		} elseif { "$wahl" == "P" } {
			tom_edit -backup "[tom_getvar %ps]packer.cnf"
		} elseif { "$wahl" == "C" } {
			tom_edit -backup "[tom_getvar %ps]connect.cnf"
		} elseif { "$wahl" == "E" } {
			tom_edit -backup "[tom_getvar %ps]speclogin.cnf"
		} elseif { "$wahl" == "A" } {
			tom_edit -backup "[tom_getvar %ps]saugtausch.cnf"
		} elseif { "$wahl" == "U" } {
			tom_edit -backup "[tom_getvar %ps]mistuser.cnf"
		} elseif { "$wahl" == "B" } {
			tom_edit -backup "[tom_getvar %ps]transfer.cnf"
		} else { 
			tom_puts "????" 
		}
	}
}

proc konfigmenuhelp { off lang } {
	global SCHNELLOGOUT
	global TRENNSTRICHE
	set auswahl ""


	append_entry auswahl liste {(A)liasse, alias.cnf}
	append_entry auswahl liste {(B)efehle, befehle.cnf}
	append_entry auswahl liste {(E)vents, event.cnf}
	append_entry auswahl liste {(I)nfofiles, infofile.cnf}
	append_entry auswahl liste {(O)nlinezeiten, business.cnf}
	append_entry auswahl liste {(P)utz, putz.cnf}
	append_entry auswahl liste {(R)outing, routing.cnf}
	append_entry auswahl liste {e(X)terne Programme, extern.cnf}
	if {$TRENNSTRICHE} {
		lappend liste "---------------------"
	}
	append_entry auswahl liste "(V)erschiedenes"
	if {$TRENNSTRICHE} {
		lappend liste "---------------------"
	}
    if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}

	append_entry auswahl liste "(Z)urck"

	if { $lang } {
		do_help $off $liste
		return "$auswahl"
	}
	kurz_menue_hilfe $auswahl
	return "$auswahl?"
}

proc konfigmenu { } {
	global logout_modus
	while (1) {
		set wahl [work_menu "Boxkonfiguration" konfigmenuhelp]
		if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
        } elseif { "$wahl" == "!" } {
			tom_befehl LOGOUT
		} elseif { "$wahl" == "B" } {
			tom_edit -backup "[tom_getvar %ps]befehle.cnf"
		} elseif { "$wahl" == "O" } {
			tom_edit -backup "[tom_getvar %ps]businett.cnf"
		} elseif { "$wahl" == "P" } {
			tom_edit -backup "[tom_getvar %ps]putz.cnf"
		} elseif { "$wahl" == "E" } {
			tom_edit -backup "[tom_getvar %ps]event.cnf"
		} elseif { "$wahl" == "X" } {
			tom_edit -backup "[tom_getvar %ps]extern.cnf"
		} elseif { "$wahl" == "I" } {
			tom_edit -backup "[tom_getvar %ps]infofile.cnf"
		} elseif { "$wahl" == "A" } {
			tom_edit -backup "[tom_getvar %ps]alias.cnf"
		} elseif { "$wahl" == "R" } {
			tom_edit -backup "[tom_getvar %ps]routing.cnf"
		} elseif { "$wahl" == "V" } {
			misckonfigmenu
		} else { 
			tom_puts "????" 
		}
	}
}

