/* cmdline.c : still no description */
/*
    Copyright (C) 1994 1995 1996 1997 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "config.h" /* HAVE_GETOPT_LONG, HAVE_DOSDRIVES */

#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <libquark.h>
#include <errno.h>

#include "conflib.h" /* damit sie in . liegen darf */
#include "tomsysdep.h"
#include "prototyp.h"

#include <portab.h>

#include "getopt.h"
#define LINK_ARGUMENTS_IN
#include "argument.h"

struct my_option {
	const char *name;
	int has_arg;
	int *flag;
	int val;
	int need_username;
	int setuid_allowed;
	const char *ko_text;
	const char *lo_text;
	const char *kurz_text;
};

struct my_option box_options[]=
{
	{"as-login",no_argument,NULL,'A',
		FALSE, FALSE,
		"-A", "--as-login", "als login arbeiten",
	},
	{"batch",required_argument,NULL,'b',
		TRUE, TRUE,
		"-b BATCHFILE", "--batch BATCHFILE", "Batchdatei ausfhren",
	},
	{"bootstrap",no_argument,NULL,'B',
		FALSE, FALSE,
		"-B", "--bootstrap", "Datenbanken anlegen",
	},
	{"check-configuration",no_argument,NULL,'\03',
		FALSE, FALSE,
		NULL, "--check-configuration", "Konfiguration prfen",
	},
	{"convdate",required_argument,NULL,'\04',
		FALSE, TRUE,
		NULL, "--convdate MTZEIT:{epoch|mt|ctime}", "MTZEIT konvertieren und ausgeben",
	},
	{"command",required_argument,NULL,'c',
		TRUE, TRUE,
		"-c KOMMANDO", "--command KOMMANDO", "Befehl KOMMANDO ausfhren",
	},
	{"cnffile",required_argument,NULL,'C',
		FALSE, FALSE,
		"-C CONFIGFILE", "--cnffile CONFIGFILE", "CONFIGFILE als quark.cnf verwenden",
	},
	{"dump-cnf",no_argument,NULL,'D',
		FALSE, TRUE,
		"-D", "--dump-cnf", "Konfigurationsvariablen ausgeben",
	},
	{"dump-shell-vars",no_argument,NULL,'\02',
		FALSE, TRUE,
		NULL, "--dump-shell-vars", "Variablen fr Shellscripte ausgeben",
	},
	{"dummy",required_argument,NULL,'\01',
		FALSE, TRUE,
		NULL, "--dummy TEXT", "Kommandozeile vergrern",
	},
	{"events",no_argument,NULL,'e',
		FALSE, FALSE,
		"-e", "--events", "dieser Getty soll Events ausfhren",
	},
	{"term",required_argument,NULL,'E',
		FALSE, TRUE,
		"-E TERM", "--term TERM", "Terminaltyp TERM einstellen (getty)",
	},
	{"file",required_argument,NULL,'f',
		FALSE, FALSE,
		"-f FILE", "--file FILE", "FILE als quarktcl-Script ausfhren",
	},
	{"getty",no_argument,NULL,'g',
		FALSE, FALSE,
		"-g", "--getty", "als getty arbeiten",
	},
	{"help",no_argument,NULL,'h',
		FALSE, TRUE,
		"-h", "--help", "dieser Text",
	},
	{"infile",required_argument,NULL,'i',
		TRUE, TRUE,
		"-i INFILE", "--infile INFILE", "INFILE eintauschen",
	},
	{"log-entry",required_argument,NULL,'l',
		TRUE, FALSE,
		"-l", "--log-entry", "Usernamen und Argument ins Log eintragen",
	},
	{"no-log-entry",no_argument,NULL,'n',
		FALSE, FALSE,
		"-n", "--no-log-entry", "Nichts in die .log eintragen",
	},
	{"outfile",required_argument,NULL,'o',
		TRUE, TRUE,
		"-o OUTFILE", "--outfile OUTFILE", "OUTFILE exportieren",
	},
	{"fake-prompt",required_argument,NULL,'P',
		TRUE, FALSE,
		"-P INPUT", "--prompt INPUT", "INPUT als Eingabe am Benutzerprompt",
	},
	{"port",required_argument,NULL,'p',
		FALSE,FALSE,
		"-p DEVICE", "--port DEVICE", "DEVICE als remoteport verwenden",
	},
	{"queue-run",no_argument,NULL,'q',
		FALSE, FALSE,
		"-q", "--queue-run", "Nachrichtenschlange abarbeiten",
	},
	{"rsmtp",no_argument,NULL,'r',
		FALSE, FALSE,
		"-r", "--rsmtp", "Als SMTP-Daemon laufen",
	},
	{"since",required_argument,NULL,'s',
		FALSE, TRUE,
		"-s MTZEIT", "--since-run MTZEIT", "Tauschdatum MTZEIT verwenden",
	},
	{"search-id",required_argument,NULL,'S',
		FALSE, TRUE,
		"-s ID", "--search-id ID", "Nachricht ID suchen",
	},
	{"tausch",no_argument,NULL,'t',
		TRUE, TRUE,
		"-t", "--tausch", "Tausch durchfhren",
	},
	{"tty",required_argument,NULL,'T',
		FALSE, FALSE,
		"-T TTY", "--tty TTY", "im Gettymodus TTY als Console verwenden",
	},
	{"user",required_argument,NULL,'u',
		FALSE, FALSE,
		"-u USER", "--username USER", "fr Benutzer USER arbeiten",
	},
	{"urgent",required_argument,NULL,'U',
		FALSE, TRUE,
		"-U HH:MM", "--urgent HH:MM", "Eventuelle andere Boxprozesse dann abbrechen",
	},
	{"version",no_argument,NULL,'v',
		FALSE, TRUE,
		"-v", "--version", "Versionsnummern ausgeben",
	},
	{"versioncode",no_argument,NULL,'V',
		FALSE, TRUE,
		"-V", "--versioncode", "Versionscode ausgeben",
	},
	{NULL,0,NULL,0,
		FALSE, TRUE,
		NULL, NULL, NULL
	}
};

#define POS_NACH_LANG 40
static void usage(FILE *out, const char *av0,int exitcode)
{
	struct my_option *mo;

	fprintf(out,"Benutzung: %s [optionen]\n",av0);
	fprintf(out,"Verfgbare Optionen:\n");
	for (mo=box_options;mo->name;mo++)
	{
		size_t pos=0;
		if (mo->need_username)
		{
			putc('u',out);
			pos++;
		}
		if (!mo->setuid_allowed)
		{
			putc('S',out);
			pos++;
		}
		while (pos++<3)
			putc(' ',out);
		if (mo->ko_text)
			pos+=fprintf(out,"%s,", mo->ko_text);
		pos+=fprintf(out," %s:", mo->lo_text);
		if (pos>POS_NACH_LANG)
			fprintf(out,"\n    ");
		else
			fwrite("                                                ",
				1,POS_NACH_LANG-pos+1,out);
		fprintf(out,"%s\n",mo->kurz_text);
	}
	fprintf(out,
		"\n"
		"u: bentigt Benutzername (-u)\n"
		"S: bei setuid-Einsatz nicht erlaubt\n");
	exit(exitcode);
}

void
cmdline_evaluation(int argc, char **argv,BOOLEAN is_setuid)
{
	struct option *opts,*o;
	char *ostring,*ostring_p;
	struct my_option *mo;
	int opts_count=0;
	size_t os_len=0;
	size_t id_len=0;
	int option_index=0;
	int c;
	BOOLEAN para_fehler=FALSE;
	BOOLEAN username_noetig=FALSE;

	for (mo=box_options;mo->name;mo++)
	{
		if (is_setuid && !mo->setuid_allowed)
			continue;
		opts_count++;
		if (!mo->ko_text)
			continue;
		if (mo->has_arg!=no_argument)
			os_len+=2;
		else
			os_len++;
	}
	os_len++; /* \0 */
	opts_count++; /* leerelement */
	opts=XMALLOC(sizeof(struct option) * opts_count);
	ostring=XMALLOC(os_len);
	for (o=opts,ostring_p=ostring,mo=box_options;mo->name;mo++)
	{
		if (is_setuid && !mo->setuid_allowed)
			continue;
		*o=*(struct option *)mo;
		o++;
		if (mo->ko_text)
		{
			*ostring_p++=mo->val;
			if (mo->has_arg!=no_argument)
				*ostring_p++=':';
		}
	}
	*o=*(struct option *)mo;
	*ostring_p=0;

	while (1)
	{
		c=getopt_long(argc,argv,ostring,opts,&option_index);
		if (c==-1)
			break;
		for (mo=box_options;mo->name;mo++)
		{
			if (mo->val==c)
			{
				if (mo->need_username)
					username_noetig=TRUE;
			}
		}
		switch(c)
		{
		case '\01': /* --dummy */
			break;
		case '\02': /* --dump-shell-vars */
			argument_dump_shell_vars=TRUE;
			break;
		case '\03': /* --check-configuration */
			argument_check_configuration=TRUE;
			break;
		case '\04':  /* --comvdate XX */
			argument_convdate=optarg;
			break;
		case 'A': 
			argument_as_login=TRUE;
			break;
		case 'b': 
			argument_batch=XSTRDUP(optarg);
			argument_auto=TRUE;
			break;
		case 'B': 
			argument_bootstrap=TRUE;
			argument_auto=TRUE;
			break;
		case 'c': 
			argument_command=XSTRDUP(optarg); 
			argument_auto=TRUE;
			break;
		case 'C': argument_cnffile=XSTRDUP(optarg); break;
		case 'D': 
			argument_dump_cnf=TRUE; 
			argument_auto=TRUE;
			break;
		case 'e': argument_execute_events=TRUE; break;
		case 'E': argument_term=XSTRDUP(optarg); break;
		case 'f': argument_tclscript=XSTRDUP(optarg); break;
#ifndef THIS_IS_TOMSHELL
		case 'g': argument_getty=TRUE; break;
#endif
		case 'h': usage(stdout,argv[0],0); break;
		case 'i': argument_infile=XSTRDUP(optarg); break;
		case 'l': 
			if (optarg)
				argument_logentry=XSTRDUP(optarg);
			break;
		case 'n': argument_no_log_entry=TRUE; break;
		case 'o': argument_outfile=XSTRDUP(optarg); break;
		case 'p': argument_port=XSTRDUP(optarg); break;
		case 'P': argument_prompt=XSTRDUP(optarg); break;
		case 'q': 
			argument_queue_run=TRUE; 
			argument_auto=TRUE;
			break;
		case 's': argument_seit=XSTRDUP(optarg); break;
		case 'S': 
			if (!id_len) {
				id_len=strlen(optarg)+2;
				argument_search_id=XMALLOC(id_len);
				strcpy(argument_search_id,optarg);
				argument_search_id[id_len-1]=0;
			} else {
				size_t n=id_len+strlen(optarg)+1;
				char *s=XMALLOC(n);
				memcpy(s,argument_search_id,id_len-1);
				strcpy(s+id_len-1,optarg);
				s[n-1]=0;
				free(argument_search_id);
				argument_search_id=s;
				id_len=n;
			}
			break;
		case 'T': argument_tty=XSTRDUP(optarg); break;
		case 't': 
			argument_tausch=TRUE; 
			argument_auto=TRUE;
			break;
		case 'u': argument_user=XSTRDUP(optarg); break;
		case 'U': /* --urgent=14:30 -> Sptestens um 14:30 anfangen */
			{
				char *p;
				BOOLEAN ok=FALSE;
				int hh=0; /* keep gcc quiet */
				int mm=0; /* keep gcc quiet */
				struct tm *tm;
				time_t now=time(NULL);
				tm=localtime(&now);
				p=strchr(optarg,':');
				if (p)
				{
					p++;
					hh=(int) strtol(optarg,NULL,10);
					mm=(int) strtol(p,NULL,10);
					if (hh >= 0 && hh < 24 && mm >=0 && mm <60)
						ok=TRUE;
				}
				else if (!p && strlen(optarg) == 4)
				{
					mm=(int) strtol(optarg+2,NULL,10);
					optarg[2]=0;
					hh=(int) strtol(optarg,NULL,10);
					if (hh >= 0 && hh < 24 && mm >=0 && mm <60)
						ok=TRUE;
				}
				if (ok)
				{
					/* Wenn der Zeitpunkt schon vorbei ist ... */
					if (hh < tm->tm_hour 
						|| (hh == tm->tm_hour && mm < tm->tm_min))
					{
						/* dann mu es einen Tag spter sein */
						now+=86400;
						tm=localtime(&now);
					}
					tm->tm_hour=hh;
					tm->tm_min=mm;
					argument_urgent=mktime(tm);
				}
				else
				{
					fprintf(stderr,"%s: unparsbares Datum\n",argv[0]);
					para_fehler=TRUE;
				}
			}
			break;
		case 'v': 
			argument_version=TRUE; 
			argument_auto=TRUE;
			break;
		case 'V': 
			argument_versioncode=TRUE; 
			argument_auto=TRUE;
			break;
		default:
			/* we should nether be here */
			fprintf(stderr,"%s: hm - i should now this option?\n",argv[0]);
		case '?':
			usage(stderr,argv[0],2);
			break; /* unntig */
		} /* switch */
	} /* while */
	free(ostring);
	free(opts);
	if (optind<argc)
	{
		fprintf(stderr,"%s: Mll auf der Kommandozeile: %s\n",argv[0],
			argv[optind]);
		usage(stderr,argv[0],2);
	}
	if (para_fehler)
	{
		usage(stderr,argv[0],2);
	}
	/* Ok, so weit, so gut. Und nun notwendige Sicherheitsprfungen */
	if (is_setuid)
	{
		if (argument_infile && 0!=access(argument_infile,R_OK)) {
			fprintf(stderr,"%s: Lesezugriff auf %s verwehrt: %s\n",
				argv[0],argument_infile,strerror(errno));
			exit(1);
		}
		/* Das ist, wenn man alles durchgehen lt, ein ernsthaftes
		 * Sicherheitsleck 
		 */
		if (argument_outfile && 0!=access(argument_outfile,W_OK)) {
			char *s;
			char *p;
			if (errno != ENOENT) {
				fprintf(stderr,"%s: Schreibzugriff auf %s verwehrt: %s\n",
					argv[0],argument_outfile,strerror(errno));
				exit(1);
			}
			/* darf der User in das Verzeichnis schreiben? */
			s=XSTRDUP(argument_outfile);
			p=strrchr(s,'/');
			if (p)
				*p=0;
			else
			{
				s[0]='.';
				s[1]=0; 
			}
			if (0!=access(s,W_OK)) {
				fprintf(stderr,"%s: Schreibzugriff auf %s verwehrt: %s\n",
					argv[0],s,strerror(errno));
				exit(1);
			}
		}
	}
	/* Bei setuid-Einsatz ist der Username *nicht* ntig */
	if (username_noetig && !argument_user && !is_setuid)
	{
		fprintf(stderr,"%s: Angabe eines Benutzernamens ntig\n", argv[0]);
		exit(2);
	}

	/* kleinere Fehlbedienungen abfangen */
	if (argument_execute_events && !argument_getty)
		argument_execute_events=FALSE;
}

