/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>

#include "prototyp.h"
#include "tompaths.h"
#include "box_conf.h"
#include "user.h"
#ifdef OFFLINE2
#include "offline/inc/mdb_global.h"
#else
#include "offline/mdb_global.h"
#endif
#include "modem.h"
#include "bin_msg.h"

extern BRETTINFO *br_ind;
extern long max_brettnr;

void
delete_user(USERNR unr)
{
	BRETTNR i;

	mboutput("Aus den Mitgliederlisten lschen\r\n");
	for (i = 1; i < max_brettnr; i++)
	{
		if (br_ind[i].brett && br_ind[i].brett->flags & (B_READ | B_WRITE))
			b_del_access(i,unr);
	}

	mboutput("Batchinstallation lschen\r\n");
	unlink(tprintf("%s%ld.bat",box_conf.batch_dir,(long) unr));

	mboutput("Tauschinstallation lschen\r\n");
	unlink(tprintf("%s%ld.tau",box_conf.tausch_dir,(long) unr));

	mboutput("Programmfach loeschen\r\n");
	loesche_programmfach(unr);

	mboutput("Persnliche Nachrichten lschen\r\n");
	{
		LISTUSER *lu;
		lu=ub_find_usernummer(unr);
		if (lu && lu->name)
			mdb_remove_group(lu->name,TRUE);
	}

	mboutput("Userdatensatz lschen\r\n");
	ub_remove_user(unr);

	mboutput("OK\r\n\n");
}
