/* service.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef TOM_LIB_SERVICE_H
#define TOM_LIB_SERVICE_H

typedef struct {
	char *host;
	char *servicename;
	char buf[1024];
	size_t used;
	int fd;
} service_t;

service_t *service_open(const char *servicename);
void service_close(service_t *);

enum serv_results {
	SERV_OK,
	SERV_EOF,
	SERV_TIMEOUT,
	SERV_TOO_LONG
};

enum serv_results service_readblock(service_t *, void *buf, size_t cnf, int timeout);
enum serv_results service_readstr(service_t *, char *buf, size_t max, int timeout);
enum serv_results service_writeblock(service_t *, const void *buf, size_t cnt, int timeout);
/* enum serv_results service_writestr(service_t *, char *buf, int timeout); */
#define service_writestr(ser,str,timeout) \
	service_writeblock(ser,str,strlen(str),timeout)

const char *service_explain(enum serv_results);

#endif
