/* inter_f2f.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <syslog.h>

#include "tompaths.h"
#include "prototyp.h"
#include "modem.h"
#include "terminal.h"
#include "aktdata.h"
#include "tomtcl.h"

/*
 * Datei anzeigen, zentrale Routine.
 * Uwe, 24.9.1995
 */
BOOLEAN 
interpret_file_to_file (FILE *fin,FILE *fout)
{
	char *rbuf;
	char *ibuf;
	char *rpos;
#define RBUF 8192
#define IBUF 16384

	if (!fin)
		return FALSE;
	ibuf=XMALLOC(IBUF);
	rbuf=XMALLOC(RBUF);

	rpos=rbuf;
	while (fgets(rpos,RBUF-(rpos-rbuf),fin))
	{
		char *start;
		BOOLEAN abbruch=FALSE;
		char *p=strpbrk(rpos,"\r\n");
		if (p)
		{
			*p=0;
			/* Backslash am Zeilenende? */
			if (p>rpos && p[-1]=='\\')
			{
				/* Zwei Backslashs am Ende entwerten die Entwertung */
				if (p-1<=rpos || p[-2]!='\\')
				{
					rpos=p-1;
					*rpos=0;
					/* Zeile wird fortgesetzt */
					continue;
				}
				p--;
				*p=0;
			}
		}
		/* 
		 * Was hier ankommt kann interpretiert und ausgegeben werden.
		 */
		rpos=rbuf;
		if (do_interpret(rbuf,ibuf,IBUF))
			start=ibuf;
		else
			start=rbuf;
		while (start && !abbruch)
		{
			char *next;
			p=strpbrk(start,"\r\n");
			if (p)
			{
				if (*p=='\n')
					next=p+1;
				else
					next=p+2;
				*p=0;
			}
			else
				next=NULL;
			fprintf(fout,"%s\r\n",start);
			if (next && !*next)
				next=NULL;
			start=next;
		}
	}

	free(ibuf);
	free(rbuf);

	return TRUE;

} /* interpret_file_to_file */
