/* mistuser.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "tomsysdep.h"

#include <portab.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "fnmatch.h"

#include "prototyp.h"
#include "modem.h"
#include "befehle.h"
#include "terminal.h"
#include "user.h"
#include "routing.h"
#include "aktdata.h"
#include "box_conf.h"
#include "tompaths.h"
#include "cslib.h"

/*
	->			username		:	zu berprfender Username
				gross_klein	:	Gro/Kleinschreibung beachten

	<-			TRUE			:	Username in mistuser enthalten
				FALSE			:	dito nicht enthalten

	Unerwnschte User anhand der Datei "/tom/system/nouser.cnf"
	berprfen. Jede Zeile in der Datei steht dabei fr einen zu
	filternden Eintrag und kann auch die Wildcards * und ? enthalten.

	10.06.92 Frank
	18.03.93 Frank, fast neu
*/
extern USER user;
BOOLEAN mistuser(const char *username,BOOLEAN gross_klein)
{
	char eintrag[100];
	char eintrag_canon[200];
	char username_canon[sizeof(user.name)*2];
	BOOLEAN mist = FALSE;
	FILE *mist_f;

	/* Username mit smtlichen Eintrgen vergleichen */
	if ((mist_f = fopen(tprintf("%s%s",box_conf.config_dir,"mistuser.cnf"),BINREAD)) == NULL)
		return FALSE;
	ub_canonical(username,username_canon);
	while (tom_fgetline(eintrag,mist_f))
	{
		if (*eintrag=='#' || !*eintrag)
			continue;
		ub_canonical(eintrag,eintrag_canon);
		if (*eintrag && !fnmatch(eintrag_canon,username_canon,0))
		{
			mist = TRUE;
			break;
		}
	}
	fclose(mist_f);

	return mist;

} /* mistuser */
