#ifndef MTZEIT_H
#define MTZEIT_H

#include "time.h"

/*****************************************************************************
 * Zeitfunktionen
 ****************************************************************************/

/*
 * Schnellere, aber unvollstndige strftime-Routine.
 * Keine Bercksichtigung der locales.
 * Kennt die folgenden Token:
 * %d -> Tag im Monat
 * %H -> Stunde (00..24)
 * %j -> Tag im jahr
 * %M -> Minute (00..59)
 * %m -> Monat im Jahr
 * %S -> Sekunde (00..59)
 * %w -> Tag in der Woche (0..6)
 * %y -> Jahr (00..99)
 * %Y -> Jahr (vierstellig)
 * Extrafeature: wenn buf NULL ist, wird ausreichend Platz alloziert.
 */
char * fast_strftime(char *buf,size_t buflen, const char *format,struct tm *tm);

 /* mtzeit.c */
BOOLEAN mtzeit_to_tm (const char *s, struct tm *tm);
BOOLEAN mtzeit_to_time_t (const char *mt, time_t * tt);
BOOLEAN time_t_to_mtzeit (time_t * t, char *buf);
BOOLEAN time_t_to_mtzeit_sec (time_t * t, char *buf);
BOOLEAN tm_to_mtzeit (struct tm *tm, char *buf);
BOOLEAN tm_to_mtzeit_sec (struct tm *tm, char *buf);

/* getdate.y */
time_t get_date (char *p, time_t now, long zone);

 /* zeit.c */
	/* aktuelle Zeit im Format hh:mm:ss in statischen String kopieren */
char * hh_mm_ss(void);
	/* aktuelles Datum im Format dd.mm.yy in statischen String kopieren */
char * dd_mm_yy(void);
	/* aktuelles Datum im Format yy_mm_dd in statischen String kopieren.
	 * Verwendungszweck: Protokolldateien. Benutzt denselben Puffer wie
	 * datum_pro_S2.
	 */
char * datum_pro_S(void);
	/* beliebiges Datum im Format yy_mm_dd in statischen String kopieren.
	 * Verwendungszweck: Protokolldateien.
	 */
char * datum_pro_S2(time_t);

#endif
