/*
    Copyright (C) 1994 1995 1996

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/

#include "config.h"

#include "portab.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#include "mtzeit.h"

/* _FUNCTION(Funktion,BOOLEAN,mtzeit_to_tm,
[[(char *@var{buf}, struct tm *@var{tim})]],[[
Die Funktion konvertiert die MausTauschzeit in @var{buf} (mit oder ohne
Sekunden) in das @code{broken down time format} und legt das Ergebnis in
@var{tim} ab.

Diese Funktion verwendet localtime und ist nicht berragend schnell.
Jemand knnte die Notwendigkeit fr den Gebrauch von localtime
beseitigen.

Liefert TRUE bei Erfolg, sonst FALSE.
]] */

#define GET(offset) ((10 * (s[offset]-'0')) + (s[offset+1]-'0'))
#define GET2(offset)

BOOLEAN
mtzeit_to_tm (const char *s, struct tm *tm)
{
	size_t l;

	if (!tm)
		return FALSE;

	l = strlen (s);

	if (l != 12 && l != 14)
		return FALSE;

	if (l == 14)
	{
		tm->tm_sec = GET (12); GET2(12);
	}
	else
		tm->tm_sec = 0;
	tm->tm_min = GET (10); GET2(10);
	tm->tm_hour = GET (8); GET2(8);
	tm->tm_mday = GET (6); GET2(6);
	tm->tm_mon = GET (4)-1; GET2(4);
	tm->tm_year = GET (2) + 100*(GET(0)) - 1900;
#if 1
   /* Grrr - das ist langsam und teuer, aber keineswegs 100%ig. Problem:
    * wie bekomme ich zu einem beliebigen Zeitpunkt lokaler Zeit heraus,
    * ob er Sommerzeit ist/war oder nicht?
    */
	{
		time_t t;
		struct tm *tm2;
		struct tm  tm1;

		tm1 = *tm;
		t = mktime (&tm1);
		tm2 = localtime (&t);
		tm->tm_isdst = tm2->tm_isdst;

	   /* bei der Gelegenheit knnen wir dann auch tm_wday und tm_yday
	    * setzen. */
		tm->tm_wday = tm2->tm_wday;
		tm->tm_yday = tm2->tm_yday;
	}
#endif
	return TRUE;

}

