/* offline.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Verteiler und Hauptmodul
	(c) 1992-95 bei Frank Baumgart

	begonnen am 20.03.1992
	Version vom 26.01.1995
*/

#include "portab.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>
#include <limits.h>

#include "system.h"
#include "missing/missing.h"
#include "offline.h"
#include "mdb_conf.h"
#include "struktur.h"
#include "frontend/frontend.h"
#include "mdb_glob.h"
#include "mdb/mdb_intr.h"			/* wg. *_sgrplst -> mdb_glob.h */
#include "mdb/msgid.h"
#include "message.h"
#include "screen/io.h"
#include "tool.h"
#include "fehler.h"
#include "screen/termcap.h"
#include "lib/readkonf.h"

#if defined(HAVE_GETOPT) || defined(HAVE_GETOPT_LONG)
#include <getopt.h>
#endif

#ifdef CLIENT
#include "server/comm_clnt.h"
#endif

extern cmd_typ cmds[];
extern CONFIG config;
extern BOOLEAN interaktiv;


static BOOLEAN cmd_markierung(BOOLEAN kill,const char *gruppe,const char *para);
static void usage(void);
static void greetings(void);
static void global_init(void);
static BOOLEAN outfile_auspacken(void);
static BOOLEAN user_import(const char *outfile);
static void verteiler(void);
static void offline_status(void);
static void verwaltung(void);
static void gruppen_verwaltung(void);

static BOOLEAN gruppen_anlegen(void);
static BOOLEAN gruppen_putzen(void);
static void bearbeiten(void);


static int ret_code = EXIT_SUCCESS;		/* Programm-Returncode */



static void usage(void)
{
#ifdef HAVE_GETOPT_LONG
	fputs(
	"usage: offline [-option] [-command(s)]\n"
	"option:\n"
	" -m --maildate                            : Mailzeitpunkt importieren\n"
	"commands:\n"
	" -c --check gruppe                        : Gruppe berprfen\n"
	" -C --check-all                           : global berprfen\n"
	" -d --delete gruppe                       : Gruppe entfernen\n"
	" -D --dbinfo                              : Datenbankinfo\n"
	" -x --correct gruppe                      : Gruppe korrigieren\n"
	" -X --correct-all                         : global korrigieren\n"
	" -d --delete gruppe                       : Gruppe lschen\n"
	" -e --export listfile [[zeit]|nr1[-nr2]]  : Nachrichten exportieren\n"
	" -E --export-ids gruppe                   : IDs exportieren\n"
	" -f --cnf cnffile                         : Konfigurationsdatei\n"
	" -G --create-id                           : globale ID-Neuerstellung\n"
	" -h --help                                : diese Hilfe\n"
	" -i --import [outfile]                    : importieren\n"
	" -I --infile                              : Infile erstellen\n"
	" -k --kill gruppe [nr1-nr2|date1-date2]   : Nachrichten zum Lschen mark.\n"
	" -K --killid id                           : Nachricht mit ID zum L. mark.\n"
	" -M --sendme requestfile outfile          : Msgs. mit best. IDs export.\n"
	" -p --putz gruppe                         : Gruppe putzen\n"
	" -P --putz-all                            : global putzen\n"
	" -r --rename gruppe gruppe                : Gruppe umbenennen\n"
	" -s --showcnf                             : akt. Konfiguration ausgeben\n"
	" -S --search id                           : ID suchen\n"
	" -u --unkill gruppe [nr1-nr2|date1-date2] : Lschmarkierungen entfernen\n"
	" -v --version                             : Versionsnummer ausgeben\n"
	,stderr);

#else

	fputs(
	"usage: offline [-option] [-command(s)]\n"
	"option:\n"
	" -m                               : Mail- statt Importdatum verwenden\n"
	"commands:\n"
	" -c gruppe                        : Gruppe berprfen\n"
	" -C                               : global berprfen\n"
	" -d gruppe                        : Gruppe entfernen\n"
	" -D                               : Datenbankinfo\n"
	" -x gruppe                        : Gruppe korrigieren\n"
	" -X                               : global korrigieren\n"
	" -d gruppe                        : Gruppe lschen\n"
	" -e listfile [[zeit]|nr1[,nr2]]   : Nachrichten exportieren\n"
	" -E gruppe                        : IDs exportieren\n"
	" -f cnffile                       : Konfigurationsdatei\n"
	" -G                               : globale ID-Neuerstellung\n"
	" -h                               : diese Hilfe\n"
	" -i [outfile]                     : importieren\n"
	" -I                               : Infile erstellen\n"
	" -k gruppe [nr1-nr2|date1-date2]  : Nachrichten zum Lschen markieren\n"
	" -K id                            : Nachricht mit ID zum L. mark.\n"
	" -M requestfile outfile           : Msgs. mit best. IDs export.\n"
	" -p gruppe                        : Gruppe putzen\n"
	" -P                               : global putzen\n"
	" -r gruppe gruppe                 : Gruppe umbenennen\n"
	" -s                               : akt. Konfiguration ausgeben\n"
	" -S id                            : ID suchen\n"
	" -u gruppe [nr1-nr2|date1-date2]  : Lschmarkierungen entfernen\n"
	" -v                               : Versionsnummer ausgeben\n"
	,stderr);
#endif

} /* usage */



/*
	den User je nach Uhrzeit begren
	dabei $USER und $FULLNAME auswerten
*/
static void greetings(void)
{
	time_t zeit;

	if (getenv("FULLNAME"))
	{
		int stunde;
		int len;

		time(&zeit);
		stunde = localtime(&zeit)->tm_hour;

		if (stunde > 19 && stunde <= 23)
			printf("n\'Abend");
		else if (stunde > 23 || stunde <= 5)
			printf("Gute Nacht");
		else if (stunde > 5 && stunde <= 9)
			printf("Moin");
		else if (stunde > 9 && stunde <= 12)
			printf("Hallo");
		else if (stunde == 13)
			printf("Mahlzeit");
		else if (stunde > 13 && stunde <= 19)
			printf("Hallo");

		/* nur den Vornamen ausgeben */
		len = (int) strcspn(getenv("FULLNAME")," ");
		printf(" %.*s\r\n",len,getenv("FULLNAME"));
	}
} /* greetings */



/*
	dafr sorgen, da die relativ zeitaufwendige Initialisierung der 
	Referenz-DB nur erfolgt, wenn dies auch notwendig ist, und nicht 
	etwa bei "offline --help".
	Auerdem darf die Initialisierung erst erfolgen, wenn die Pfade 
	auch stimmen, die vorangehenden Kommandozeilenargumente bereits 
	ausgewertet sind
*/
static void global_init(void)
{
	static BOOLEAN erledigt = FALSE;

	if (!erledigt)
	{
#if !defined(CLIENT)
		/* bei Clients fand die Initialisierung bereits im Server statt */
		if (!msgid_init())
			exit(3);
#else
		/* Verbindung zum Server aufnehmen */
		if (!mc_init())
			exit(3);
#endif
		erledigt = TRUE;
	}
} /* global_init */



/*
	Hauptprogramm
*/
int main(int argc,const char *argv[])
{
#if defined(HAVE_GETOPT_LONG)
	struct option opts[] =
	{
		{ "maildate",		no_argument,		NULL,'m' },
		{ "check",			required_argument,NULL,'c' },
		{ "check-all",		no_argument,		NULL,'C' },
		{ "correct",		required_argument,NULL,'x' },
		{ "correct-all",	no_argument,		NULL,'X' },
		{ "delete",			required_argument,NULL,'d' },
		{ "dbinfo",			no_argument,		NULL,'D' },
		{ "export",			required_argument,NULL,'e' },
		{ "export-ids",	required_argument,NULL,'E' },
		{ "sendme",			required_argument,NULL,'M' },
		{ "cnf",				required_argument,NULL,'f' },
		{ "showcnf",		no_argument,		NULL,'s' },
		{ "create-id",		no_argument,		NULL,'G' },
		{ "help",			no_argument,		NULL,'h' },
		{ "import",			optional_argument,NULL,'i' },
		{ "infile",			no_argument,		NULL,'I' },
		{ "kill",			required_argument,NULL,'k' },
		{ "killid",			required_argument,NULL,'K' },
		{ "putz",			required_argument,NULL,'p' },
		{ "putz-all",		no_argument,		NULL,'P' },
		{ "rename",			required_argument,NULL,'r' },
		{ "search",			required_argument,NULL,'S' },
		{ "unkill",			required_argument,NULL,'u' },
		{ "version",		no_argument,		NULL,'v' },
		{ NULL,0,NULL,0 }
	};
	int option_index=0;
#endif
#if defined(HAVE_GETOPT_LONG) || defined(HAVE_GETOPT)
	int c;
	const char *ostr="c:Cd:De:E:f:Ghi:Ik:K:mM:p:Pr:sS:u:vx:X";
#else
	int nr = 1;
#endif

#if defined(__WATCOMC__)
	/* Bug: Watcom ldt die Filehandle-Table nicht automagisch um */
	_grow_handles(120);
#endif

	interaktiv = TRUE;

	if (argc == 1)
		greetings();

	/* initialisiert interne Var., ID-DB, und ldt Konfigurationsdatei */
	if (!mdb_init())
		return 1;

#if defined(HAVE_GETOPT) || defined(HAVE_GETOPT_LONG)
	while (1)
	{
		time_t zeit;
		BOOLEAN pm;

#if defined(HAVE_GETOPT_LONG)
		if ((c = getopt_long(argc,(char **)argv,ostr,opts,&option_index)) == -1)
#else
		if ((c = getopt(argc,(char **)argv,ostr)) == -1)
#endif
			break;

		if (c != 'f')
			interaktiv = FALSE;

		switch (c)
		{
			case 'h' :	/* Benutzungshinweise geben ? */
							usage();
							exit(0);
							break;

			case 'f' :	/* Konfigurationsdatei laden */
							cnf_read(optarg,cmds);
							break;

			case 'v' :	/* Versionsnummer ausgeben ? */
							global_init();
							{
								int v = mdb_version();
								printf("Offline Version %d.%02d\r\n",v / 100,v % 100);
							}
							break;

			case 's' :	/* aktuelle Konfiguration ausgeben */
							cnf_export(NULL,cmds,TRUE);
							break;

			case 'S'	:	/* ID suchen */
							global_init();
							{
								char g[256],u[256],a[256];
								if (msgid_find_infos(optarg,g,u,a,NULL,NULL,NULL))
								{
									if (*g)
										printf("Gruppe: %s\r\n",g);
									if (*u)
										printf("User  : %s\r\n",u);
									if (*a)
										printf("Autor : %s\r\n",a);
								}
								else
									puts("nicht vorhanden");
							}
							break;

			case 'K' :	/* Nachricht mit ID zum Lschen markieren */
							global_init();
							if (!mdb_kill_article(optarg))
								ret_code = EXIT_FAILURE;
							break;

			case 'M' :	/* SENDME Msgs. mit IDs */
							global_init();
							if (argc <= optind)
							{
								puts("zuwenig Argumente");
								break;
							}
							if (!mdb_get_article(optarg,argv[optind]))
								ret_code = EXIT_FAILURE;
							optind++;
							break;

			case 'C' :	/* vollstndige berprfung der Datenbasis */
							global_init();
							if (!mdb_check_all(FALSE))
								ret_code = EXIT_FAILURE;
							break;

			case 'c'	:	/* berprfung einer einzelnen Gruppe */
							global_init();
							pm = (optarg[0] == '*');
							if (!mdb_check_group(optarg+pm,pm,FALSE))
								ret_code = EXIT_FAILURE;
							break;

			case 'x'	:	/* Korrektur einer einzelnen Gruppe */
							global_init();
							pm = (optarg[0] == '*');
							if (!mdb_check_group(optarg+pm,pm,TRUE))
								ret_code = EXIT_FAILURE;
							break;

			case 'X' :	/* Korrektur aller Gruppen */
							global_init();
							if (!mdb_check_all(TRUE))
								ret_code = EXIT_FAILURE;
							break;

			case 'e' :	/* Export anhand Exportlistendatei */
							global_init();
							/* wurden Datum/Zeit angegeben ? */
							/* ### testen: +1 ist vmtl. falsch ! */
							if (optind < argc && argv[optind+1][0] != '-')
							{
								zeit = berechne_zeit(argv[++optind],time(NULL));
#if 0
								printf("ctime: %s\r\n",ctime(&zeit));
								printf("Zeit: %ld\r\n",zeit);
#endif
							}
							else
								zeit = 0;
							{
								char outfile[PATH_MAX];
								EXPORT opt;

								opt.box = FALSE;
								opt.dist = V_LOKAL;		/* Alle Distributionen */
								opt.zeit = zeit;			/* Startzeitpunkt */
								opt.one_group = FALSE;	/* richtige crosspostings */
								opt.site = NULL;			/* site */
								opt.noidfname = NULL;	/* keine IDs bergehen */
								opt.maximum = 0;			/* kein Limit */

								strcpy(outfile,config.export);
								strcat(outfile,"outfile.txt");
								if (!mdb_export(optarg,outfile,&opt))
									ret_code = EXIT_FAILURE;
							}
							break;

			case 'E'	:	/* IDs einer Gruppe/User exportieren */
							global_init();
							if (!strcmp(optarg,"*"))
								msgid_export_all("/tmp/id.lst");
							else
							{
								pm = (optarg[0] == '*');
								msgid_export(optarg,pm,"/tmp/id.lst");
							}
							break;

			case 'i' :	/* Outfile importieren */
							global_init();
							if (!user_import(optarg))
								ret_code = EXIT_FAILURE;
							break;

			case 'I' :	/* Infile erstellen */
							global_init();
							if (!infile_erstellen())
								ret_code = EXIT_FAILURE;
							break;

			case 'D' :	/* Datenbank-Informationen, global */
							global_init();
							gruppenlisting();
							break;

			case 'd' :	/* Gruppe entfernen */
							global_init();
							pm = (optarg[0] == '*');
							if (!mdb_remove_group(optarg+pm,pm))
								ret_code = EXIT_FAILURE;
							break;

			case 'p' :	/* Gruppe putzen */
							global_init();
							pm = (optarg[0] == '*');
							if (!mdb_putze_gruppe(optarg+pm,pm,FALSE))
								ret_code = EXIT_FAILURE;
							break;

			case 'P' :	/* gesamte DB putzen */
							global_init();
							if (!mdb_putze_alles(TRUE,TRUE)
							||  !mdb_putze_alles(FALSE,TRUE))
								ret_code = EXIT_FAILURE;
							break;

			case 'r'	:	/* Gruppe umbenennen */
							global_init();
							/* ### argc-Abfrage fehlt; s.o. 'e' */
							if (!mdb_rename_group(optarg,argv[optind],FALSE))
								ret_code = EXIT_FAILURE;
							optind++;
							break;

			case 'G' :	/* globale Referenzdatei erstellen */
							if (!msgid_create())
								ret_code = EXIT_FAILURE;
							global_init();
							break;

			case 'm' :	/* mit Mail- statt Importdatum importieren */
							config.maildate = TRUE;
							break;

			case 'u' :	/* Lschflag von Mails entfernen */
							global_init();
							if (!cmd_markierung(FALSE,optarg,argv[optind++]))
								ret_code = EXIT_FAILURE;
							break;

			case 'k' :	/* Lschflag in Mails setzen */
							global_init();
							if (!cmd_markierung(TRUE,optarg,argv[optind++]))
								ret_code = EXIT_FAILURE;
							break;

			default :	usage();
							exit(1);
		}
	}

	if (optind < argc)
	{
		printf("garbage on commandline: %s\n",argv[optind]);
		usage();
		exit(2);
	}
#endif /* HAVE_GETOPT_LONG */

	if (interaktiv)
	{
		init_termcap();
		global_init();
		io_init();
		verteiler();
	}

	protokoll_schliessen();

	return ret_code;

} /* main */



/*
	Outfile auspacken

	mgliche Fehler:
	- Packer nicht gefunden
	- Entpacken fehlerhaft
*/
static BOOLEAN outfile_auspacken(void)
{
	char name[128];
	char *cmd = NULL;
	char temp[PATH_MAX];

	if (!*config.xtract)
		return TRUE;

	strcpy(name,config.xtract);
	/* Kommandozeile ? */
	if ((cmd = strchr(name,' ')) != NULL)
		*cmd++ = 0;
	mputs("entpacke Outfile");
	mprintf("%s %s\n",name,cmd);
	sprintf(temp,"%s %s",name,(cmd) ? cmd : "");
	(void) shell(temp);

	return TRUE;

} /* outfile_auspacken */



/*
	User-Outfile importieren, ggf. vorher entpacken

	->			outfile	:	Outfile-Datei inkl. Pfad bzw. NULL
*/
static BOOLEAN user_import(const char *outfile)
{
	char imp_pfad[PATH_MAX];

	outfile_auspacken();

	if (outfile)
		strcpy(imp_pfad,outfile);
	else
	{
		strcpy(imp_pfad,config.import);
		strcat(imp_pfad,"outfile.txt");
	}

	return (mdb_import(imp_pfad,FALSE) && infile_import(config.messages));

} /* user_import */



/*
	->			kill	:	TRUE = kill, FALSE = unkill
				gruppe:	klar
				para	:	Zeit/Nummern-Parameter:
							"-8"								Msgs. 0-8
							"8-"								Msgs. 8-Ende
							"20-83"							Msgs. 20-83
							"t-10"							Msgs. lter als 10 Tage
							"t+8"								Msgs. neuer als 8 Tage
							"-1.6.1994"						Msgs. lter als 1.6.94
							"-1.6."							Msgs. lter als 1.6. d.J.
							"-1."								Msgs. lter als 1. jeden Monats
							"5.11.93-6.4.94,12:00"		Zeitbereich, bis 6.4.94 12 Uhr 
							ohne Parameter					nur berzhlige (lt. KENNUNG)

	<-			TRUE	:	Markierung erfolgreich
				FALSE	:	Markierung fehlgeschlagen oder Parameter falsch
*/
static BOOLEAN cmd_markierung(BOOLEAN kill,const char *gruppe,const char *para)
{
	const char *pos = para;
	ULONG von_nr = 0;
	ULONG bis_nr = 0xFFFFFFFFl;
	time_t von_zeit = 0;
	time_t bis_zeit = (time_t) -1L;
	BOOLEAN zeit;
	BOOLEAN pm;

	if (*pos == 't')
	{
		pos++;
		if (*pos == '-' && isdigit(*(pos+1)))
		{
			pos++;
			bis_zeit = time(NULL) - atol(pos) * 60L*60L*24L;
		}
		else
		if (*pos == '+' && isdigit(*(pos+1)))
		{
			pos++;
			von_zeit = time(NULL) - atol(pos) * 60L*60L*24L;
		}
		else
		{
			fputs("Parameter falsch (entweder t-Tage oder t+Tage)\r\n",stderr);
			return FALSE;
		}
		zeit = TRUE;
	}
	else
	if (*pos == '-')
	{
		pos++;
		/* Zeit- oder Nummernangabe ? */
		if (strpbrk(pos,".:"))
		{
			bis_zeit = berechne_zeit(pos,time(NULL));
			zeit = TRUE;
		}
		else
		{
			bis_nr = (MESSAGE) atol(pos);
			while (isdigit(*pos))
				pos++;
			zeit = FALSE;
		}
	}
	else
	{
		/* Zeit- oder Nummernangabe ? */
		if (strpbrk(pos,".:"))
		{
			von_zeit = berechne_zeit(pos,time(NULL));
			if (strchr(pos,'-'))  pos = strchr(pos,'-');
			zeit = TRUE;
		}
		else
		{
			von_nr = (MESSAGE) atol(pos);
			while (isdigit(*pos))
				pos++;
			zeit = FALSE;
		}

		if (*pos++ == '-')
		{
			if (zeit)
				bis_zeit = berechne_zeit(pos,time(NULL));
			else
				bis_nr = (MESSAGE) atoi(pos);
		}
	}

	/* Lschmarkierung setzen bzw. entfernen */
	pm = (gruppe[0] == '*');
	gruppe += pm;

	if (zeit)
		return mdb_markiere(gruppe,pm,kill,zeit,von_zeit,bis_zeit);
	else
		return mdb_markiere(gruppe,pm,kill,zeit,von_nr,bis_nr);

} /* cmd_markierung */



/*
	Verteiler
	auf die einzelnen Funktionsbereiche
*/
static void verteiler(void)
{
	int c;

	do
	{
		tprint("cl");
		puts("Offline");
		printf("Version %s",MAJOR_VERSION "." MINOR_VERSION);
		puts("");
		puts("(c) 1992-95 bei Frank Baumgart");

#ifdef __PUREC__
		puts("(Pure C)");
#elif LATTICE
		puts("(Lattice C)");
#elif DJGPPM
		puts("(GNU C DJGPP");
#elif EMX
		puts("(GNU C EMX");
#elif __GNUC__
		puts("(GNU C)");
#elif __WATCOMC__ && __DOS__
		puts("(WATCOM C DOS)");
#elif __BORLANDC__ && __MSDOS__
		puts("(Borland C MS-DOS)");
#elif __BORLANDC__ && __OS2__
		puts("(Borland C OS/2)");
#elif __IBMC__ && __OS2__
		puts("(IBM C-Set OS/2)");
#endif
		puts("");
		puts("(n)achrichten");
		puts("");
		puts("(t)ausch");
		puts("");
		puts("(i)mport");
		puts("");
		puts("(v)erwaltung");
		puts("");
		puts("");
		puts("(q)uit");

		do
		{
			switch (c = taste())
			{
				case 'i' :	tprint("cl");
								if (!user_import(NULL))
									ret_code = EXIT_FAILURE;
								break;

				case 'n' :	bearbeiten();
								break;

				case 'v' :	verwaltung();
								break;

				case 't' :	infile_edit();
								break;

				case 'q' :	break;

				default	:	c = 0;
			}
		}
		while (!c);
	}
	while (c != 'q');

} /* verteiler */



static void offline_status(void)
{
	tprint("cl");
	puts(
	"Das Copyright an Offline liegt bei Frank Baumgart\n"
	"\n"
	"Offline ist Freeware, d.h. es darf in binrer Form frei weitergegeben werden.\n"
	"Fr genauere Informationen lesen Sie bitte die im Archiv enthaltenen Nutzungs-\n"
	"bedingungen.\n"
	"\n"
	"Offline ist derzeit fr folgende Systeme erhltlich:\n"
	"\n"
	"DOS, OS/2, Linux (i86) (Text und X11), Atari (TOS und GEM), HP-UX 7xx,\n"
	"Sun 3 und 4 (SunOS 4 und 5), NeXT-Step (68k und i86), Windows NT;\n"
	"DEC Ultrix (in Vorbereitung)\n"
	"\n"
	"An Offline haben, in alphabetischer Reihenfolge, mitgewirkt:\n"
	"\n"
	"Carsten Ellermann @ PB2 (DOS,OS/2)\n"
	"Dirk Hagedorn @ PB (Atari GEM)\n"
	"Georg Bauer @ MS3 (DOS,OS/2,NT)\n"
#if 0
	"Hans Christian Eckert @ B (DEC)\n"
#endif
	"Jrg Henne @ BB (NeXT,HP-UX)\n"
#if 0
	"Marcus Schmidke @ BM (OS/2)\n"
	"Stefan Hrter @ LU (BSD)\n"
	"Stefan Rupp @ AC2 (SUN,X11)\n"
#endif
	"Uwe Ohse @ DU3 (Quark)\n"

	"\n"
	"Bei systemspezifischen Problemen wende man sich an die oben aufgefhrten\n"
	"Personen, bei allgemeinen Problemen an mich (Frank Baumgart @ PB3, ggf.\n"
	"problematische Outfiles etc. an godot@uni-paderborn.de).\n"
	"Falls mglich, \"richtige\" Usenet-Adresse angeben, fr (bug-)fixe Updates.\n"
	"\n"
	"Frank Baumgart"
	);

	taste();

} /* offline_status */



static void verwaltung(void)
{
	char datei[PATH_MAX];
	int c,d;

	do
	{
		tprint("cl");
		puts("Verwaltung");
		puts("");
		puts("");
		puts("(s)tatus");
		puts("");
		puts("(g)ruppen");
		puts("");
		puts("(i)nfofiles");
		puts("");
		puts("(a)dressen");
		puts("");
		puts("(f)ilter");
		puts("");
		puts("");
		puts("(q)uit");

		do
		{
			switch (c = taste())
			{
				case 's' :	offline_status();
								break;

				case 'g' :	gruppen_verwaltung();
								break;

				case 'i' :	show_infofile();
								break;

				case 'a'	:	strcpy(datei,config.messages);
								strcat(datei,"adressen.lst");
								call_editor(datei);
								break;

				case 'f' :	strcpy(datei,config.messages);
								puts("");
								puts("(a)utoren oder (t)hemen?");
								d = toupper(taste());
								if (d == 'A')
								{
									strcat(datei,"filter.aut");
									call_editor(datei);
								}
								else
								if (d == 'T')
								{
									strcat(datei,"filter.thm");
									call_editor(datei);
								}
								break;

				case 'q' :	break;

				default	:	c = 0;
			}
		}
		while (!c);
	}
	while (c != 'q');

} /* verwaltung */



/*
	Verwaltung der Gruppen

	- Liste
	- Traffic
	- Info
	- Parameter
	- Bestellung
	- berprfung
	- Gruppe anlegen
	- Gruppe verschieben
	- Gruppe entfernen
*/
static void gruppen_verwaltung(void)
{
	int c;

	do
	{
		tprint("cl");
		puts("Gruppenverwaltung");
		puts("");
		puts("");
		puts("(i)nfo (alles)");
		puts("");
		puts("(b)estellen");
		puts("");
		puts("(a)nlegen");
		puts("");
		puts("(p)utzen (alle)");
		puts("");
		puts("(t)esten (alle)");
		puts("");
		puts("(k)orrigieren (alle)");
		puts("");
		puts("");
		puts("(q)uit");

		do
		{
			switch (c = taste())
			{
				case 'i' :	gruppenlisting();
								break;

				case 'b' :	gruppenbestellung();
								break;

				case 'a' :	gruppen_anlegen();
								break;

				case 'p' :	gruppen_putzen();
								break;

				case 't' :	/* berprfen der kompletten Datenbasis */
								tprint("cl");
								(void) mdb_check_all(FALSE);
								(void) taste();
								break;

				case 'k' :	/* Korrigieren der kompletten Datenbasis */
								tprint("cl");
								(void) mdb_check_all(TRUE);
								(void) taste();
								break;

				case 'q' :	break;

				default	:	c = 0;
			}
		}
		while (!c);
	}
	while (c != 'q');

} /* gruppen_verwaltung */



/*
	Gruppen bzw. User interaktiv anlegen
*/
static BOOLEAN gruppen_anlegen(void)
{
	char name[MAX_CPG];
	BOOLEAN ok = TRUE;
	BOOLEAN pm = TRUE;
	int eingabe;

	tprint("cl");
	do
	{
		char *pos;

		mprintf("Gruppe oder User anlegen ? (G/U) ");
		eingabe = toupper(taste());
		mputs("");
		if (eingabe != 'G' && eingabe != 'U')
			break;
		if (eingabe == 'U')
			pm = TRUE;
		else
			pm = FALSE;

		if (pm)
			mputs("welchen User anlegen ?");
		else
			mputs("welche Gruppe anlegen ?");
		*name = 0;
		mgets(name,MAX_CPG);
		mputs("");
		if ((pos = strpbrk(name,"\r\n")) != NULL)
			*pos = 0;
		if (!name || !*name)
			break;

		ok = mdb_create_group(name,pm,NULL);
		if (ok)
			mputs((pm) ? "User angelegt" : "Gruppe angelegt");
		else
			mputs("Fehler");
	}
	while (ok);

	return ok;

} /* gruppen_anlegen */



/*
	alle Gruppen putzen
*/
static BOOLEAN gruppen_putzen(void)
{
	if (!mdb_putze_alles(TRUE,TRUE)
	||  !mdb_putze_alles(FALSE,TRUE))
		return FALSE;
	else
		return TRUE;

} /* gruppen_putzen */



/*
	Lesen in einer Gruppe
*/
static void bearbeiten(void)
{
	char liste[PATH_MAX];
	FILE *lst_f;
	char name[100];
	BOOLEAN fertig = FALSE;
	BOOLEAN pm;
	char *p;
	long dummy;

	tmpnam(liste);
	if (!mdb_grouplist(liste,TRUE,&dummy))
		return;
	if ((lst_f = fopen(liste,"r")) == NULL)
		return;

	while (1)
	{
		if ((p = gruppeneingabe("Gruppen/Userauswahl",SEL_PM_OM)) == NULL)
			break;

		strcpy(name,p);
		if (*name == '*')
			pm = TRUE;
		else
		if (!stricmp(name,"PM"))
		{
			strcpy(name,akt_username());
			pm = TRUE;
		}
		else
			pm = FALSE;

		do
		{
			char last[MAX_CPG];
			BOOLEAN next = FALSE;

			if (group_path(name,NULL,pm) < 0)
				break;

			if (!msg_browser(name,pm,config.inhalt,-3,0) || pm)
				break;

			rewind(lst_f);
			do
			{
				if (!freadline(last,sizeof(last),lst_f))
					break;

				next = !stricmp(last,name);
			}
			while (!next);

			do
			{
				if (next && freadline(name,sizeof(name),lst_f))
				{
					KENNUNG kennung;
					int wahl;

					if ((p = strchr(name,',')) != NULL)
						*p = 0;

					/*
						feststellen, ob die Gruppe berhaupt Nachrichten enthlt
						bzw. solche, die den Voreinstellungen (keine gelschten)
						entsprechen
					*/
					if (!group_info(name,FALSE,&kennung)
					|| (config.skip_del && !kennung.neue))
					{
						printf("Nichts neues in %s\n",name);
						continue;
					}

					printf("nchste Gruppe (%s) ? (j/n/q) ",name);
					wahl = taste();
					putchar(wahl);
					if (wahl == 'q')
						fertig = TRUE;
					else
					if (wahl == 'n')
					{
						puts("");
						strcpy(name,last);
						continue;
					}
					else
						break;
				}
				else
				{
					puts("keine weiteren Gruppen mehr");
					taste();
					fertig = TRUE;
				}
			}
			while (!fertig);
		}
		while (!fertig);
	}

	fclose(lst_f);
	unlink(liste);

} /* bearbeiten */



/*
	Eingabe eines Gruppennamens

	->			titel		:	als berschrift auszugebender Text
				typ		:	SEL_(OM/PM/OM_PM), s. frontend.h

	<-			Zeiger auf eingegebenen Gruppennamen bzw. NULL
*/
char *gruppeneingabe(const char *titel,int typ)
{
	static char name[MAX_CPG];
	static int last;							/* Nr. der letzten Gruppe */
	long anzahl;
	char **namen;
	SEL_EINTRAG *eintrag;
	KENNUNG kennung;
	int i;
	int wahl;
	BOOLEAN pm,om;
	char *tmp;
	FILE *tmp_f;
	char *next,*p;
	size_t bytes;
	char *last_names;

	pm = (typ == SEL_PM) || (typ == SEL_PM_OM);
	om = (typ == SEL_OM) || (typ == SEL_PM_OM);

	if (!pm && !om)
		return NULL;

	tmp = tmpnam(NULL);
	mdb_grouplist(tmp,TRUE,&anzahl);

	if ((tmp_f = fopen(tmp,"r")) == NULL)
		return NULL;
	bytes = (size_t) filesize(tmp_f);
	last_names = malloc(bytes+1);
	last_names[bytes] = 0;
	fread(last_names,bytes,1,tmp_f);
	fclose(tmp_f);
	unlink(tmp);

	if ((namen = (char **) malloc(anzahl * sizeof(char *))) == NULL)
	{
		fehler(NO_MEMORY);
		return NULL;
	}

	i = 0;
	next = last_names;
	while ((p = strpbrk(next,"\r\n")) != NULL)
	{
		*p = 0;
		namen[i++] = next;
		next = p+1;
		if (*next == '\r' || *next == '\n')
			next++;
	}

	eintrag = (SEL_EINTRAG *) calloc((size_t)anzahl,sizeof(SEL_EINTRAG));
	if (!eintrag)
	{
		free(namen);
		fehler(NO_MEMORY);
		return NULL;
	}

	for (i = 0; i < anzahl; i++)
	{
		char zahlen[40];

		eintrag[i].text = namen[i];
		eintrag[i].info = NULL;
		eintrag[i].fett = FALSE;

		if (!config.mark_unread
		|| !group_info(namen[i],namen[i][0] == '*',&kennung))
			continue;

		eintrag[i].fett = (kennung.neue != 0);
		if (kennung.neue)
			sprintf(zahlen,"%8ld %8ld",(long) kennung.neue,(long) kennung.anzahl);
		else
			sprintf(zahlen,"         %8ld",(long) kennung.anzahl);
		eintrag[i].info = strdup(zahlen);
	}

	wahl = uni_eingabe(titel,INPUT_GRUPPE,eintrag,(size_t)anzahl,last,TRUE,name);
	if (wahl >= 0)
		last = wahl;

	for (i = 0; i < anzahl; i++)
		if (eintrag[i].info)
			free(eintrag[i].info);
	free(namen);

	if (!*name)
		return NULL;
	else
		return name;

} /* gruppeneingabe */
