/* kennung.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#if !defined(DB_KENNUNG)
#define DB_KENNUNG

#include "mdb_defs.h"

/*
	Header einer jeden Indexdatei
	zur Kennzeichnung und evtl. Anpassung bei neueren Datenbankstrukturen

	Der Header stellt den ffentlichen Teil der Datenbank bereit.
	Nur dieser sollte nach auen sicht- und manipulierbar sein.
*/
typedef struct
{
	UWORD kn_size;			/* Gre der Kennung in Bytes */
	UWORD ix_size;			/* Gre eines Indexdatensatzes in Bytes */
	UWORD major;			/* Haupt-Versionsnummer */
	UWORD minor;			/* Unter-Versionsnummer */
	char sccs[80];			/* sccs ID */
	char name[128];		/* Gruppen/Username */

	UWORD unused2;			/* war: follow_up_to, Kommentare automatisch in andere Gruppe ? */
	UWORD unused;			/* war: follow_from, Gruppe selbst Ziel fr follow-ups ? */

	time_t imported[10];	/* Datum/Zeit der letzten 10 Importe */
	MESSAGE imp_anf[10];	/* Beginn der Mails des jeweiligen Imports */

	long imp_mon_anz[12];/* Anzahl Mails pro Monat */
	long imp_mon_byt[12];/* Anzahl Bytes pro Monat */

	time_t created;		/* Zeitpunkt bei Anlegen der Gruppe */
	time_t changed;		/* Zeitpunkt bei letzter Bearbeitung (Schreiben) */
	time_t latest;			/* Zeitpunkt des letzten Zugriffs */
	time_t geputzt;		/* Zeitpunkt des letzten Putzens */
	time_t tested;			/* Zeitpunkt der letzten Inspektion */

	ULONG max_msgs;		/* maximale Anzahl Messages */
	ULONG max_size;		/* maximale Gre in Bytes */
	ULONG max_time;		/* Aufbewahrungszeit in Tagen */
	MESSAGE anzahl;		/* Anzahl Nachrichten in der Gruppe */
	MESSAGE neue;			/* Anzahl ungelesener Nachrichten */
	MESSAGE putzen;		/* Anzahl zu lschender Nachrichten */
	MESSAGE letzte;		/* zuletzte gelesene Nachricht der Gruppe */
	MESSAGE gk_in;			/* Anzahl gK IN diese Gruppe */
	MESSAGE gk_out;		/* Anzahl gK AUS dieser Gruppe */
	MESSAGE min_putz;		/* minimal zu putzende Messages */
	MESSAGE status_anz;	/* Anzahl aller Mailstatus-Infos (nur PM) */
	MESSAGE status_neu;	/* Anzahl neuer Mailstatus-Infos (nur PM) */
	MESSAGE erst_stat;	/* erster neuer Mailstatus (nur PM) */
	MESSAGE reserved1;
	MESSAGE reserved2;
	ULONG reserved3;		/* war: Zugriffslevel, dezimal kodiert, LSIx */
	ULONG owner;			/* Besitzer/Bearbeiter dieser Gruppe */
	ULONG status;			/* z.B. Geheim oder Protected */
	ULONG reserved4;		/* war: zugriffe, Anzahl Zugriffe auf diese Gruppe */
	ULONG overall;			/* Anzahl Mails seit Bestehen der Gruppe */
	ULONG traffic;			/* ... */
	ULONG gruppe;			/* Gruppe (Menge von Leuten) */
	UWORD pm;				/* PM oder OM */
	UWORD codiert;			/* Nachrichten codiert speichern oder Klartext */
	ULONG resvd[12];		/* reserviert */

} KENNUNG;

#endif

