/* config.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Konfigurations-Strukturen
*/

#include "portab.h"
#include <stddef.h>

#include "mdb_conf.h"
#include "readkonf.h"


CONFIG config;


/*
	Schlsselworte

	's' steht fr Strings,'p' fr Pfade, 'n' fr numerische (long) Werte.
	'b' und 'B' bezeichnen boolesche Werte.
	Durch Angabe von "B" statt "b" wird bei der Initialisierung TRUE 
	statt FALSE voreingestellt
*/
cmd_typ cmds[] =
{
	{ "Username",			's',	0,		&config.username },
	{ "PackEin",			's',	0,		&config.crunch },
	{ "PackAus",			's',	0,		&config.xtract },
	{ "MaxAll",				'n',	0,		&config.max_all },
	{ "MaxMsgs",			'n',	0,		&config.max_msgs },
	{ "MaxSize",			'n',	0,		&config.max_size },
	{ "MaxTime",			'n',	0,		&config.max_time },
	{ "MinPutz",			'n',	0,		&config.min_putz },
	{ "AutoPutz",			'b',	0,		&config.auto_putz },
	{ "RmOutfile",			'b',	0,		&config.rm_outfile },
	{ "KeepFilter",		'n',	0,		&config.keep_filter },
	{ "ImportLog",			'b',	0,		&config.imp_log },
	{ "ExportLog",			'b',	0,		&config.exp_log },
	{ "TrafficLog",		'b',	0,		&config.trf_log },
	{ "PutzLog",			'b',	0,		&config.putz_log },
	{ "SystemPath",		'p',	0,		&config.system },
	{ "LogPath",			'p',	0,		&config.log },
	{ "GroupPath",			'p',	0,		&config.new_gr },	
	{ "UserPath",			'p',	0,		&config.new_us },
	{ "ImportPath",		'p',	0,		&config.import },
	{ "ExportPath",		'p',	0,		&config.export },
	{ "MessagePath",		'p',	0,		&config.messages },
	{ "InfofilePath",		'p',	0,		&config.infofiles },
	{ "InfofileBackup",	'b',	0,		&config.infobackup },
	{ "InfofileDiff",		's',	0,		&config.diff },
	{ "InfofileAutoDiff",'b',	0,		&config.autodiff },
	{ "Terminal",			's',	0,		&config.terminal },
	{ "TERM",				's',	0,		&config.termtyp },
	{ "Editor",				's',	0,		&config.editor },
	{ "Pager",				's',	0,		&config.pager },
	{ "Print",				's',	0,		&config.print },
	{ "Sorted",				'b',	0,		&config.sortiert },
	{ "Quark",				'b',	0,		&config.quark },
	{ "QuoteMessage",		'b',	0,		&config.quote_msg },
	{ "QuoteInitials",	'n',	0,		&config.initials },
	{ "ShowFooter",		'B',	0,		&config.show_footer },
	{ "TextEffects",		'B',	0,		&config.text_effects },
	{ "ColorQuotes",		'B',	0,		&config.color_quotes },
	{ "MarkUnreadGroups",'B',	0,		&config.mark_unread },
	{ "MarkNewInfofiles",'B',	0,		&config.mark_infofiles },
	{ "Pufferung",			'B',	0,		&config.pufferung },
	{ "OptCache",			'b',	0,		&config.opt_cache },
	{ "KV",					'B',	0,		&config.verkettung },
	{ "DupeCheck",			'B',	0,		&config.dupe_chk },
	{ "RequestPM",			'B',	0,		&config.req_pm },
	{ "RequestOM",			'B',	0,		&config.req_om },
	{ "RequestRename",	'B',	0,		&config.req_rename },
	{ "FilterAuthor",		'B',	0,		&config.filter_author },
	{ "FilterTopic",		'B',	0,		&config.filter_topic },
	{ "FilterImport",		'B',	0,		&config.filter_import },
	{ "FilterExport",		'B',	0,		&config.filter_export },
	{ "ImportFiltered",	'B',	0,		&config.import_filtered },
	{ "Maildate",			'b',	0,		&config.maildate },
	{ "CodedPM",			'b',	0,		&config.coded_pm },
	{ "KeepTauschPM",		'n',	0,		&config.tausch_pm },
#ifdef BOX
	{ "SkipRead",			'b',	0,		&config.skip_read },
#else
	{ "SkipRead",			'B',	0,		&config.skip_read },
#endif
	{ "SkipDeleted",		'B',	0,		&config.skip_del },
	{ "InfileJoinLines",	'B',	0,		&config.join_lines },
	{ "ResumeMail",		'B',	0,		&config.resume_mail },
	{ "EditFwd",			'B',	0,		&config.edit_fwd },
	{ "BrowserCache",		'n',	0,		&config.browser_cache },
	{ "BrowserIndexView",'b',	0,		&config.inhalt },
#ifndef BOX
	{ "ExportStatus",		'B',	0,		&config.exp_status },
	{ "ExportFlags",		'B',	0,		&config.exp_flags },
#endif
	{ "LinuxBugSetvbuf",	'b',	0,		&config.linux_bug },
#ifdef BOX
	{ "KillExported",		'n',	0,		&config.kill_exported },
	{ "KillRead",			'n',	0,		&config.kill_read },
	{ "KillUnread",		'n',	0,		&config.kill_unread },
#endif

	{ NULL,0,0,NULL, },
};
