/*
    Copyright (C) 1993 1994 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
*/
/*
	Message-Datenbank-Initialisierung
	auch fr fremde FrontEnds und die Quark

	Es mu zwischen der Server- und der Client-Version unterschieden werden.
	Der Server ldt seine eigene Konfiguration und ist nicht-interaktiv.
	Der Client ldt userspezifische Konf. und ist interakiv.
*/


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include "system.h"
#include "struktur.h"
#include "mdb_glob.h"
#include "fehler.h"
#include "offline.h"
#include "mdb_conf.h"
#include "msgid.h"
#include "fehler.h"
#include "tool.h" /* fileexist */
#include "lib/readkonf.h"

extern char sccs_mdb[];
extern BOOLEAN interaktiv;

extern cmd_typ cmds[];
extern CONFIG config;				/* globale Einstellungen (Verkettung...) */

KENNUNG leere_kennung;				/* initialisierte Datenbank-Kennung */

#if defined(TEXT_FRONTEND) && !defined(SERVER)
BOOLEAN interaktiv = TRUE;
#else
BOOLEAN interaktiv = FALSE;
#endif

char sccs_mdb[] = "@(#)Offline, Version " MAJOR_VERSION "." MINOR_VERSION 
                  " vom " __DATE__ ", (c) 1992-95 bei Frank Baumgart";



/*
	globale Variablen und Einstellungen/Konfigurationen initialisieren,
	Standardstrukturen bereitstellen und globale Ref-DB laden
*/
BOOLEAN mdb_init(const char *offline_cnf)
{
	/* Gruppenkennung initialisieren */
	memset(&leere_kennung,0,sizeof(KENNUNG));
	strcpy(leere_kennung.sccs,sccs_mdb);
	leere_kennung.kn_size = (UWORD) sizeof(KENNUNG);
	leere_kennung.ix_size = (UWORD) sizeof(INDEX);
	leere_kennung.major   = DB_MAJOR;
	leere_kennung.minor   = DB_MINOR;

	if (!offline_cnf)
		offline_cnf="offline.cnf";
#if defined(SERVER) || defined(BOX)
	{
		/* der Rckgabewert von cnf_read wird nicht ausgewertet, weil er
		 * belanglos ist: Bei nicht existierender oder unlesbarer 
		 * Datei wird TRUE zurckgegeben, bei Speichermangel FALSE und
		 * bei kleineren Fehlern auch FALSE.
		 */
		cnf_read(offline_cnf,cmds);
#if defined(SERVER)
		if (!msgid_init())
			return FALSE;
		}
#endif
	}

#if !defined(DEBUG)
	/* im Boxmodus (auer fr Entwickler) grundstzlich PM-Kodierung */
	config.coded_pm = TRUE;
	config.filter_import = FALSE;
	config.filter_export = FALSE;
#endif

#if defined(CLIENT)
	/* Verbindung zum Server aufnehmen */
	if (!mc_init())
		return FALSE;
#else
	/* refid-DB initialisieren */
	if (!msgid_init())
		return FALSE;
#endif

#else /* !BOX && !SERVER */
	cnf_read(NULL,cmds);
#endif

	return TRUE;

} /* mdb_init */
