/* mdb_conf.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

/*
	globale, systemspezifische Einstellungen
*/
typedef struct
{
	BOOLEAN
		verkettung,			/* Kommentarverkettung durchfhren */
		maildate,			/* Maildatum statt Importdatum */
		pufferung,			/* streams puffern */
		opt_cache,			/* optimierter Cache write-back bei i_close() */
		rm_outfile,			/* Flag, ob Outfile nach Import lschen */
		auto_putz,			/* Flag, ob beim Import putzen */
		infobackup,			/* Backup alter Infofiles */
		autodiff,			/* automatischer Infofile-diff bei Import */
		quark,				/* Flag, ob mit Quark getauscht wird */
		sortiert,			/* Flag, ob Outfile sortiert */
		imp_log,				/* Flag, ob Importe protokollieren */
		exp_log,				/* dito Exporte */
		trf_log,				/* dito Traffic */
		putz_log;			/* dito Putz */

	BOOLEAN
		mark_unread,		/* Gruppen mit ungelesenen Nachrichten kennzeichnen */
		mark_infofiles,	/* neue Infofiles kennzeichnen (sonst: vorhandene) */
		skip_read,			/* gelesene Nachrichten berspringen */
		skip_del,			/* dito zu lschende */
		show_footer,		/* Footer anzeigen */
		text_effects,		/* Text-Attribute (fett, blinkend, unterstrichen) */
		color_quotes,		/* Quote-Initialen farbig (rot) hervorheben */
		resume_mail,		/* Kommentare/Antworten wieder aufnehmen */
		edit_fwd,			/* weiterzuleitende Nachrichten edieren */
		join_lines;			/* Infile-Zeilen zu Endloszeilen zusammenfassen */

	BOOLEAN
		req_pm,				/* (neue) persnliche Nachrichten anfordern */
		req_om,				/* dito ffentliche */
		req_rename,			/* dito Gruppenumbenennungen */
		filter_author,		/* Autoren filtern */
		filter_topic,		/* Themen filtern */
		filter_import,		/* beim Import filtern */
		filter_export,		/* beim Import filtern */
		import_filtered,	/* gefilterte Mails mit Lschflag importieren */
		dupe_chk,			/* Dupecheck */
		coded_pm,			/* PMs beim Import kodieren */
		quote_msg,			/* Nachrichten fr Antwort/Kommentar quoten */
		exp_status,			/* Statusflags (PMs) im FE-Modus exportieren */
		exp_flags;			/* Flagexport im FE-Modus */

	BOOLEAN
		linux_bug;			/* Bug in Linux' clib: setvbuf() */

	long max_all,
		  max_msgs,			/* maximale Anzahl Messages */
		  max_size,			/* maximale Gre in Bytes */
		  max_time,			/* Aufbewahrungszeit in Tagen */
		  min_putz,			/* minimal zu putzende Messages */
		  tausch_pm;		/* Aufbewahrungszeit getauschter PMs */
	long kill_exported,	/* Aufbewahrungszeit getauschter PMs (Box) */
	     kill_read,		/* Aufbewahrungszeit gelesener PMs (Box) */
	     kill_unread;		/* Aufbewahrungszeit ungelesener PMs (Box) */

	long	initials;		/* Quotes mit Initialen oder Vornamen */

	long	keep_filter;	/* Aufbewahrungszeit der Filtereintrge */

	long	browser_cache;	/* Anzahl Cachezeilen im Browser */
	BOOLEAN inhalt;		/* Inhalts- statt Maildarstellung */
	
	char	*username,
			*crunch,
			*xtract,
			*editor,			/* Editor */
			*pager,			/* Anzeige (more, less, etc.) f. Infofiles */
			*print,			/* Druck-Kommando */
			*terminal,		/* Terminalprogramm */
			*termtyp,		/* Terminaltyp = termcap-Eintrag */
			*import,			/* Importpfad */
			*export,			/* Exportpfad */
			*system,			/* Pfad fr Systemdateien */
			*messages,		/* Pfad fr eigene (Infile-)Nachrichten */
			*infofiles,		/* Pfad fr Infofiles */
			*new_gr,			/* Pfad fr neue ff. Gruppen */
			*new_us,			/* Pfad fr neue pers. Gruppen */
			*log,				/* Pfad fr Log-Dateien */
			*diff;			/* diff fr Infofiles */

} CONFIG;
