/* auswahl.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Gruppenauswahl
	(c) 1992-94 bei Frank Baumgart

	begonnen am 12.05.1992
	Version vom 12.08.1994
*/


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <limits.h>

#include "system.h"
#include "struktur.h"
#include "mdb/mdb_intr.h"
#include "frontend/frontend.h"
#include "fehler.h"
#include "mdb_conf.h"
#include "message.h"
#include "screen/io.h"
#include "missing/missing.h"

extern CONFIG config;



static int srt_name(const void *a,const void *b);



/*
	Auswahl, Bestellung und Abbestellung
	von Gruppen anhand der technischen Gruppenliste ITG
*/
void gruppenbestellung(void)
{
	char eingabe[100];
	char temp[PATH_MAX];				/* Pfad fr ITG-Datei */
	char zeile[255];
	FILE *itg_f;						/* ITG-stream */
	size_t gruppen = 0;				/* Anzahl Gruppen */
	SEL_EINTRAG *eintrag = NULL;
	size_t max_zahl = 500;			/* Anzahl mglicher Eintrge, Startwert */
	int nr;

	sprintf(temp,"%s%s",config.infofiles,"ITG.txt");
	/* technische Gruppenliste ffnen */
	if ((itg_f = fopen(temp,BINREAD)) != NULL)
	{
		eintrag = (SEL_EINTRAG *) calloc(max_zahl,sizeof(SEL_EINTRAG));
		if (!eintrag)
		{
			fclose(itg_f);
			fehler(NO_MEMORY);

			return;
		}

		/*
			Zeiger auf die einzelnen Namen aufbauen
		*/
		while (fgets(zeile,MAX_CPG,itg_f))
		{
			char *p;

			if (*zeile != 'G')
				continue;

			if ((p = strpbrk(zeile,"\r\n")) != NULL)
				*p = 0;

			eintrag[gruppen].text = strdup(zeile+1);
			eintrag[gruppen].info = NULL;

			while (fgets(zeile,MAX_CPG,itg_f))
			{
				if (*zeile == 'U')
				{
					if ((p = strpbrk(zeile,"\r\n")) != NULL)
						*p = 0;
					eintrag[gruppen].info = strdup(zeile+1);
					break;
				}
			}
			eintrag[gruppen].fett = group_info(eintrag[gruppen].text,FALSE,NULL);
			gruppen++;

			/* Pufferspeicher dynamisch erweitern, falls ntig */
			if (gruppen > max_zahl)
			{
				eintrag = (SEL_EINTRAG *) realloc(eintrag,(max_zahl + 200)*sizeof(SEL_EINTRAG));
				if (!eintrag)
				{
					fclose(itg_f);
					fehler(NO_MEMORY);

					goto abbruch;
				}
				max_zahl += 200;
			}
		}
		fclose(itg_f);

		/* Sortierung */
		qsort(eintrag,gruppen,sizeof(SEL_EINTRAG),srt_name);
	}

	if (gruppen)
		(void) uni_eingabe("Gruppenbestellung",INPUT_GRUPPE,eintrag,gruppen,0,TRUE,eingabe);
	else
	{
		printf("Gruppe: ");
		*eingabe = 0;
		mgets(eingabe,60);
		if (*eingabe && (*eingabe != '\r'))
			bestelle_gruppe(eingabe,TRUE);
	}

abbruch:
	/* Speicherfreigabe */
	if (eintrag)
	{
		for (nr = 0; nr < gruppen; nr++)
		{
			if (eintrag[nr].info)
				free(eintrag[nr].info);
			free(eintrag[nr].text);
		}
		free(eintrag);
	}

} /* gruppenbestellung */



static int srt_name(const void *a,const void *b)
{
	return stricmp((*(const SEL_EINTRAG *)a).text,(*(const SEL_EINTRAG *)b).text);

} /* srt_name */
