/* bearbeit.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Bearbeitungs-Routinen
	(c) 1992-95 bei Frank Baumgart

	begonnen am 30.03.1992
	Version vom 28.01.1995
*/


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <assert.h>
#include <limits.h>
#include <unistd.h>

#include "system.h"
#include "missing/missing.h"
#include "struktur.h"
#include "mdb_glob.h"
#include "mdb/mdb_intr.h"
#include "message.h"
#ifdef BOX
extern BOOLEAN senden_text(BOOLEAN pm, const char *ref_id,
    const char *p_empfaenger, const char *p_gruppe);
#else
#include "frontend/frontend.h"
#include "frontend/post_fe.h"
#endif
#include "mdb/mt_cmd.h"
#include "io.h"
#include "filter.h"
#include "tool.h"
#include "fehler.h"
#include "mdb_conf.h"				/* nur wg. Optionen */

#include "termcap.h"

#ifdef BOX

#include "terminal.h"

extern void set_scroll_area(WORD mode);
extern BOOLEAN userbreak(void);
extern char *vt_S(int nr);
extern int logout_modus;
extern WORD count_crW;
extern WORD vtmodeW;
extern BOOLEAN mehr_disabled;
static BOOLEAN nonstop;
extern void bef_lesen_status_callback(const char *id,char status);

#endif

extern CONFIG config;

extern int bs_zeilen,bs_spalten;
extern int vt100;						/* Flag, ob Ausgabefenster definierbar */

extern WORK *msg[];					/* Datenstrukturen fr mehrere Gruppen */



static BOOLEAN calc_cursor(int gh,long *top,int *cursor);
static void cursor_update(int gh,int cursor,BOOLEAN show);
static void status_show(int gh,long top,int cursor);
static void status_update(int gh,long top,int cursor);
#ifdef TEXT_FRONTEND
static void optionen(void);
#endif
static void msg_show_header(int gh);
static void msg_index(int gh,MESSAGE top,int cursor);
static void msg_tree(int gh);
static void msg_tree_walk(int gh);
static void msg_show(int gh);

static MESSAGE cp[100];				/* Umrechnung Cursor -> Mail-Nummer */
static int i_anz;						/* Anzahl dargestellter Inhaltszeilen/Bild */
static int key;						/* zurckgestellter Tastendruck, wg. Paging */
static KLEMM klemm;					/* Merker (Thema/Autor) */
static KLEMM sel;						/* Selektion (Thema/Autor) */

static char *vt_fett,*vt_bold,*vt_uset,*vt_uend,*vt_norm;
static char vt_dummy[] = "\0";
/*static char *vt_dummy = "";*/

static const char *lesehilfe[] =
{
	"Tastenbelegung im Message-Browser:",
	"==================================",
	"",
	"(auf dem Ziffernblock gut zu verwenden (NUM LOCK))",
	"(2) zum Kommentar",
	"(4) zum vorangehenden Kommentar",
	"(6) zum nachfolgenden Kommentar",
	"(8) zur kommentierten Nachricht",
	"(0) zur Ursprungsnachricht",
	"(5) zur Wurzel des Kommentarbaumes",
	"(<) zur letzten Nachricht",
	"(>) zur nchsten Nachricht",
	"( ) zur nchsten ungelesenen, ungelschten Nachricht (s. Optionen)",
	"(7) zur ersten Nachricht (Inhaltsbersicht)",
	"(1) zur letzten Nachricht (Inhaltsbersicht)",
	"(9) eine Seite zurck (Inhaltsbersicht)",
	"(3) eine Seite vor (Inhaltsbersicht)",
	"",
#ifndef BOX
	"(f) Nachricht weiterleiten",
#endif
	"(b) Nachricht beantworten",
	"(k) Nachricht kommentieren",
	"(K) Nachricht in anderer Gruppe kommentieren",
	"(m) neue ffentliche Nachricht schreiben",
	"(p) neue persnliche Nachricht schreiben",
	"",
#if 0
	"(M) Marker setzen",
	"(M) Marker anspringen -> goto (m)arker",		s.u. (M)itglied/(M)ember
	"",
#endif
	"(r) aktuelles Thema bzw. Autor merken",
	"(n) nchstes gemerktes Thema bzw. Autor suchen",
	"(v) vorheriges gemerktes Thema bzw. Autor suchen",
	"(/) Text suchen",
	"",
#ifndef BOX
	"(d) Totallschung",
	"(t) Teillschung",
	"(*) Lschsperre setzen/aufheben",
	"(D) Autor/Titel/Verkettung lschen",
	"    Grobuchstabe = komplett, sonst ab aktueller Position",
	"(T) akt. Thema lschen",
	"(F) Autor bzw. Thema in Filterdatei aufnehmen",
	"",
	"(P) Nachricht ausdrucken",
	"(S) Nachricht speichern",
	"(V) aktuelle Gruppe bestellen",
	"(U) aktuelle Gruppe abbestellen",
	"(M) Mitglied ein/austragen",
	"(A) Autor in Adredatei aufnehmen",
	"",
#endif
	"(g) bestimmte Nachricht anspringen",
	"(h) Hilfetext anzeigen",
	"(R) Rot13-Dekodierung",
	"(H) Header der aktuellen Nachricht anzeigen",
#ifndef BOX
	"(o) Optionen",
	"(I) Gruppeninfo",
	"(B) Kommentarbaum",
	"(TAB) Wechsel zwi. Mail- und Inhaltsdarstellung",
#endif
#ifdef BOX
	"(N) Nachrichten nonstop anzeigen (Abbruch mit Escape oder Control-X)",
#endif
	"(Ret) Nachricht (erneut) anzeigen",
	"",
	"Nur fr persnliche Nachrichten:",
	"(z) zurckstellen",
	"(Z) zur nchsten zurckgestellten Mail",
	"",
	"(q) Gruppe verlassen",
	"(Q) Gruppe verlassen und alle Mails auf \"Gelesen\" setzen",
#ifndef BOX
	"(x) Gruppe verlassen und keine weiteren Gruppen durchlaufen",
#endif
	NULL
};

/*
	belegte Tasten:
	Gro : AB D F HI K MN PQRSTUV   Z
	Klein:  b d fgh  k mno qrst v x z
	sonst: *,TAB,Space,Return,01245678,-,+,/,<,>
	       CURSOR UP/DOWN/LEFT/RIGHT,PAGE UP/DOWN
*/



/*
	Terminal-Steuersequenzen ermitteln
*/
static void get_terminal(BOOLEAN get)
{
	if (get)
	{
#ifdef BOX
		vt_fett = vt_S(ATTR_FETT);
#if 0
		vt_bold = vt_S(5);					/* blinkend */
#else
		vt_bold = vt_S(ATTR_FETT);
#endif
		vt_uset = vt_S(ATTR_INVERS);		/* unterstrichen */
		vt_uend = vt_S(ATTR_OFF);
		vt_norm = vt_S(ATTR_OFF);
#else
/*		vt_fett = tgetstr("so",NULL);*/
		vt_fett = tgetstr("md",NULL);
		vt_bold = tgetstr("mb",NULL);
		vt_uset = tgetstr("us",NULL);
		vt_uend = tgetstr("ue",NULL);
		vt_norm = tgetstr("se",NULL);
#endif
		if (!vt_fett)
			vt_fett = vt_dummy;
		if (!vt_bold)
			vt_bold = vt_dummy;
		if (!vt_uset)
			vt_uset = vt_dummy;
		if (!vt_uend)
			vt_uend = vt_dummy;
		if (!vt_norm)
			vt_norm = vt_dummy;
	}
#ifndef BOX
	else
	{
		/* Speicher fr termcap-Eintrge wieder freigeben */
		if (*vt_norm)
			free(vt_norm);
		if (*vt_uend)
			free(vt_uend);
		if (*vt_uset)
			free(vt_uset);
		if (*vt_bold)
			free(vt_bold);
		if (*vt_fett)
			free(vt_fett);
	}
#endif
} /* get_terminal */



/*
	neue Cursorposition und Inhaltsseite berechnen

	nach z.B. Themenlschung mssen die gelschten Nachrichten bersprungen
	werden. Sofern der Cursor dabei die aktuelle Inhalts-Bildschirmseite ver-
	lt, wird eine neue Bildschirmseite berechnet.

	->			gh		:	Gruppenhandle
			<->top	:	Index der obersten Zeile
			<->cursor:	alte und neue Cursorposition (0 bis i_anz-1)

	<-			TRUE	:	Cursor blieb innerhalb derselben Seite
				FALSE	:	Cursor hat aktuelle Seite verlassen, top gendert
*/
static BOOLEAN calc_cursor(int gh,long *top,int *cursor)
{
	BOOLEAN same = TRUE;		/* wird die akt. Seite beibehalten? */
	MESSAGE akt;

	akt = msg_get_nr(gh);

	if (*cursor >= i_anz)
	{
		*cursor -= i_anz;
		same = FALSE;
	}

	if (!akt)
	{
		if (*top + *cursor > i_anz)
			same = FALSE;
		*top = 0;
		*cursor = 0;
	}
	else
	if (akt >= *top + i_anz)
	{
		same = FALSE;
		*top += ((akt - *top) / i_anz +1 -1) * i_anz;
	}
	else
#if 0
	if (akt + *cursor >= *top + i_anz)
	{
	}
	else
#endif
	if (akt < *top)
	{
		same = FALSE;
		*top -= ((*top - akt) / i_anz +1) * i_anz;
		if (akt < *top)
			fprintf(stderr,"akt ist immer noch kleiner als top\r\n");
	}
	else
		same = TRUE;

	/* nur zum debuggen */
	if (akt < *top || akt > *top + i_anz)
	{
		fprintf(stderr,"inkorrekte top/cursor-Position (akt=%d,top=%ld,cursor=%d)",
		       (int)akt,*top,*cursor);
		taste();
	}

	*cursor = akt - *top;

	return same;

} /* calc_cursor */



/*
	stellt die Zeile an der Cursorposition neu dar

	->			gh		:	Gruppenhandle
				cursor:	Cursorposition
				show	:	TRUE = Cursor ein-, FALSE = ausschalten
*/
static void cursor_update(int gh,int cursor,BOOLEAN show)
{
	static char tmp[200];
/*	static MESSAGE last_msgnr = -1;
	static ULONG last_flags = 0;
	static UWORD last_status = 0;*/

	if (!msg[gh]->inhalt)
		return;

	if (show)
		msg_index_string(gh,NULL,bs_spalten,tmp);

	gotoxy(0,cursor+2);

#ifdef TEXT_FRONTEND
	if (show)
	{
		tprint("so");
		mputs(tmp);
		tprint("se");
	}
	else
		mputs(tmp);
#endif
#ifdef BOX
	if (show)
		mprintf("%s%s%s",vt_S(ATTR_INVERS),tmp,vt_norm);
	else
		mputs(tmp);
#endif
} /* cursor_update */



/*
	Statuszeile in Inhaltsdarstellung darstellen
*/
static void status_show(int gh,long top,int cursor)
{
	char trenner[200];
	char name[80];
	WORK *mp = msg[gh];
	size_t max;

	if (!mp->inhalt)
		return;

	max = (bs_spalten >= 200) ? 200-1 : bs_spalten-1;
	memset(trenner,'=',max);
	trenner[max] = 0;

#ifdef TEXT_FRONTEND
	tprint("ho");
#elif defined(BOX)
	gotoxy(0,0);
#endif

	sprintf(name,"%s: %s",(mp->pm) ? "User" : "Gruppe",mp->kennung.name);
#ifdef TEXT_FRONTEND
	mprintf("%-*.*s neue: \r\n",max-38,max-38,name);
#elif defined(BOX)
	mprintf("%-*.*s\r\n",max-38,max-38,name);
#endif

	mputs(trenner);

	status_update(gh,top,cursor);

} /* status_show */



/*
	Statuszeile in Inhaltsdarstellung updaten

	Format: "Gruppe: %-33.33s  neue: %ld  gel.: %ld   %5ld/%ld   "
*/
static void status_update(int gh,long top,int cursor)
{
	WORK *mp = msg[gh];
	int max;

	if (!mp->inhalt)
		return;

	max = (bs_spalten >= 200) ? 200-1 : bs_spalten-1;

#ifdef TEXT_FRONTEND
	gotoxy(max-31,0);
	mprintf("%ld  gel.: %ld   %5ld/%ld   \r\n",
			(long) mp->kennung.neue,
			(long) mp->kennung.putzen,
			(long) (top + cp[cursor] +1),
			(long) mp->kennung.anzahl);
#elif defined(BOX)
	gotoxy(max-13,0);
	mprintf("%5ld/%-5ld ",
			(long) (top + cp[cursor] +1),
			(long) mp->kennung.anzahl);
#endif
	gotoxy(0,bs_zeilen-2);

} /* status_update */



/*
	Meldung (in den unteren 2 Zeilen) lschen
*/
static void clr_meldung(int gh)
{
	if (!msg[gh]->inhalt)
		return;

	gotoxy(0,bs_zeilen-2);
#ifdef TEXT_FRONTEND
	tprint("ce");
	mputs("");
	tprint("ce");
#endif
#ifdef BOX
	mprintf("%s\r\n%s","","");
#endif
	gotoxy(0,bs_zeilen-2);

} /* clr_meldung */



#ifdef TEXT_FRONTEND
/*
	Einstellung der anwenderspezifischen Optionen
*/
static void optionen(void)
{
	tprint("cl");
	puts("berspringen:");
	puts("");
	printf("(1) gelesene          : %s\n",(config.skip_read) ? "ja" : "nein");
	puts("");
	printf("(2) zu lschende      : %s\n",(config.skip_del) ? "ja" : "nein");
	puts("");
	printf("(3) Footer            : %s\n",(config.show_footer) ? "ja" : "nein");

	switch (taste())
	{
		case '1' :	config.skip_read = !config.skip_read;
						break;

		case '2' :	config.skip_del  = !config.skip_del;
						break;

		case '3' :	config.show_footer = !config.show_footer;
						break;
	}

} /* optionen */
#endif



/*
	Anzeigen und Bearbeiten von Datenstzen

	->			gruppenname	:	klar
				pm				:	PM (TRUE) oder OM (FALSE)
				inhalt		:	TRUE = Inhalts-, FALSE = Maildarstellung
				start			:	Nummer der Einstiegsmail
									 0 = zur ersten Nachricht
									>0 = zur angegebenen Nachrichtennummer
									-1 = zur zuletzt gelesenen Nachricht
									-2 = zur nchsten neuen Nachricht
									-3 = zur nchsten ungelesenen Nachricht
				ref			:	Referenzzeitpunkt, falls start = -2

	<-			TRUE			:	ok
				FALSE			:	keine (neue) Nachricht vorhanden
*/
BOOLEAN
msg_browser(const char *gruppenname,BOOLEAN pm,BOOLEAN inhalt,long start,time_t ref)
{
	BOOLEAN weiter = TRUE;
	WORK *mp;
	int gh;								/* vorerst nur eine Gruppe gleichzeitig */
	pid_t pid;
	BOOLEAN abbruch = FALSE;
	BOOLEAN keep;						/* bei aktueller Msg. bleiben ? */
	BOOLEAN keep_bottom = FALSE;	/* Zusatzzeilen am Ende neu aufbauen ? */
	MESSAGE anzahl;					/* Anzahl Msgs. in der Gruppe, aus KENNUNG */
	int wahl;
	long top = 0;						/* Nr. der obersten Msg. in Inhaltsbersicht */
	int cursor = 0;					/* akt. Cursorzeile in Inhaltsdarstellung */
	int old_cursor;					/* letzte dargestellte Cursorposition */

#ifdef BOX
	nonstop = FALSE;
#endif

	pid = getpid();

#ifdef BOX
	/* interaktive Vernderung der DB nur bei PMs erlauben */
	if ((gh = group_open(pid,gruppenname,pm,pm)) < 0)
#else
	if ((gh = group_open(pid,gruppenname,pm,TRUE)) < 0)
#endif
		return FALSE;

	mp = msg[gh];
	anzahl = mp->kennung.anzahl;
	if (!anzahl)
	{
		group_close(gh,pid);
		return FALSE;
	}

	/* zur ersten, zuletzt gelesenen oder angegebenen Nachricht */
	if (start == 0)
		index_goto(gh,0);
	else
	if (start == -1 || (start == -3 && !mp->kennung.neue))
	{
		if (!index_goto(gh,mp->kennung.letzte))
			fputs("kann Index nicht anfahren",stderr);
	}
	else
	if (start == -2)
	{
		if (!index_goto_new(gh,ref))
		{
			group_close(gh,pid);
			return TRUE;
		}
	}
	else
	if (start == -3)
	{
		index_goto(gh,0);
		while (index_read(gh))
		{
			if (!(mp->ix.flags & GELESEN))
				break;
			if (!index_next(gh))
				break;
		}
	}
	else
	if ((start > 0) && (start <= anzahl))
		index_goto(gh,(MESSAGE) start);
	else
	{
		mputs("Keine Nachricht mit dieser Nummer vorhanden\r\n");
		group_close(gh,pid);
		return TRUE;
	}

	/* erste/letztmalige/neue Nachricht anzeigen */
	if (!msg_read(gh))
	{
		fprintf(stderr,"kann Nachricht %ld nicht einlesen\r\n",
				(long)(msg_get_nr(gh)));
		sleep(2);
		return TRUE;
	}

	get_screen();
/*	signal(SIGWINCH,...get_screen);*/
	i_anz = bs_zeilen -7;

	sel.art = SEL_ALL;
	klemm.art = 0;
	mp->ursprung = msg_get_nr(gh);
	mp->inhalt = inhalt;
	keep = FALSE;

	top = msg_get_nr(gh);		/* Nr. der obersten Mail der Bildschirmseite */

	/* Zuordnungstabelle zwi. Cursorposition und Mailnummer */
	for (cursor = 0; cursor < 100; cursor++)
		cp[cursor] = cursor;

	cursor = 0;
	calc_cursor(gh,&top,&cursor);
	old_cursor = cursor;

	get_terminal(TRUE);

	do
	{
		char suchtext[80];

#if defined(BOX)
		if (logout_modus)
			break;
#endif

		/*
			in Inhaltsdarstellung neue Cursorposition berechnen und ggf. 
			Cursorzeile neu darstellen
		*/
		if (mp->inhalt)
		{
			MESSAGE last = 0;
			MESSAGE akt = msg_get_nr(gh);
			INDEX last_ix;

			if (last != akt && keep)
			{
#if 0
				if (last_ix != mp->ix)
				{
					index_goto(gh,last);
					msg_index_string(gh,NULL,bs_spalten,tmp);
					index_goto(gh,akt);
				}
#endif
				cursor_update(gh,old_cursor,FALSE);
			}

			if (keep)
				keep = calc_cursor(gh,&top,&cursor);
			else
				(void) calc_cursor(gh,&top,&cursor);

			if (last != akt)
				cursor_update(gh,cursor,TRUE);

			last_ix = mp->ix;
			last = akt;
		}
		else
			(void) calc_cursor(gh,&top,&cursor);	/* ### vmtl. unntig */

		old_cursor = cursor;


		/* aktuelle Nachricht schon angezeigt ? sonst jetzt anzeigen */
		if (!keep)
		{
			if (mp->inhalt)
				msg_index(gh,top,cursor);
			else
				msg_show(gh);

			/* bei PMs ggf. Statusmeldung erzeugen */
			if (pm && !msg_get_status(gh))
			{
#ifdef BOX
#if 0
				/*
					im Boxbetrieb wird zus. zum Indexeintrag eine Statuszeile 
					erzeugt, damit der Export spter nicht smtliche User-
					Indexdateien durchlaufen mu
				*/
				char status[PATH_MAX];
				FILE *sta_f;

				strcpy(status,config.messages);
				strcat(status,"status");
				if ((sta_f = fopen(status,"a")) != NULL)
				{
					fprintf(sta_f,"#%s\r\nBG\r\n",mp->offset.id);
					fclose(sta_f);
				}
#else
				UWORD status=(msg_get_status(gh) & ~GEAENDERT);
				if (!status||status==ZURUECKGESTELLT)
					bef_lesen_status_callback(mp->offset.id,'G');
#endif
#endif
				msg_set_status(gh,GELESEN);
			}
		}
		else
			if (mp->inhalt)
				status_update(gh,top,cursor);

		if (!mp->inhalt && (!keep_bottom || !keep))
		{
			if (pm)
			{
				switch (msg_get_status(gh) & ~GEAENDERT)
				{
					case	GELESEN :
						mputs("(gelesen)");
						break;
					case	ZURUECKGESTELLT :
						mputs("(zurckgestellt)");
						break;
					case	BEANTWORTET :
						mputs("(beantwortet)");
						break;
					case	WEITERGEGEBEN :
						mputs("(weitergegeben)");
						break;
					case	MAUSNET :
						mputs("(im MausNet)");
						break;
					case	ANGEKOMMEN :
						mputs("(angekommen)");
						break;
					case	GATEWAY :
						mputs("(Gateway)");
						break;
					case	KOPIERT :
						mputs("(kopiert)");
						break;
				}
			}

			if (msg_get_flag(gh) & TOTAL)
				mputs("Totallschung");
			else
			if (msg_get_flag(gh) & TEIL)
				mputs("Teillschung");

			mputs("( )Nchste (<)links (>)rechts (0)Einstieg (h)ilfe");
			mputs("(2,4,6,8)Kommentarverkettung (q)uit");

			keep_bottom = TRUE;
		}

		/* letzte Nachricht normalerweise beibehalten */
		keep = TRUE;


		if (key)
		{
			wahl = key;
			key = 0;
#ifdef BOX
			nonstop = FALSE;
#endif
		}
#ifdef BOX
		else if (!nonstop)
			wahl = taste();
		else
			wahl = '>';
#else
		else
			wahl = taste();
#endif

		/* bestimmte Funktionen schalten Selektion aus */
		if ((sel.art != SEL_ALL) && strchr("\tBDFgntvz 01245678-+<>",wahl))
		{
			sel.art = SEL_ALL;
			keep = FALSE;
		}

		if (mp->inhalt && wahl < 128 && strchr("2468",wahl))
		{
			int konvert[] = { '0','1',C_DOWN,'3',C_LEFT,'5',C_RIGHT,'7',C_UP,'9' };
			wahl = konvert[wahl - '0'];
/*			if (wahl == '2')
				wahl = C_DOWN;
			if (wahl == '4')
				wahl = C_LEFT;
			if (wahl == '6')
				wahl = C_RIGHT;
			if (wahl == '8')
				wahl = C_UP;*/
		}

		switch (wahl)
		{
#ifndef BOX
			case 'Q' :
				while (index_next(gh) && index_read(gh))
				{
					if (!(msg_get_flag(gh) & GELESEN))
						msg_set_flag(gh,GELESEN);
				}
				/* fall through */
#endif

			case 'q' :
				abbruch = TRUE;
				mp->kennung.letzte = msg_get_nr(gh);
				break;

			case 'x' :
				abbruch = TRUE;
				mp->kennung.letzte = msg_get_nr(gh);
				weiter = FALSE;
				break;

			case '\r' :
			case '\n' :
				/* Nachricht (erneut) anzeigen */
				if (mp->inhalt)
				{
					mp->ursprung = msg_get_nr(gh);
					index_goto(gh,top + cp[cursor]);
					msg_read(gh);
					mp->inhalt = FALSE;
					keep = FALSE;
				}
				else
					keep = FALSE;
				break;

			case ' ' :
				/* zur nchsten den Optionen entsprechenden Nachricht */
				{
					ULONG flags = TEIL;

					if (config.skip_read)
						flags |= GELESEN;
					if (config.skip_del)
						flags |= TOTAL;

					if (((flags & GELESEN) && !mp->kennung.neue)
					|| !msg_next_new(gh,flags))
					{
						do_beep();
						mputs("keine weiteren (neuen) Nachrichten");
						if (mp->inhalt)
							sleep(1);
						clr_meldung(gh);
						keep_bottom = FALSE;
					}
					else
					{
						if (!mp->inhalt)
							keep = FALSE;
					}
				}
				break;

			case '<' :
				/* gibt es eine vorangehende Message ? */
				if (index_prev(gh) && msg_read(gh))
					keep = FALSE;
				else
					do_beep();
				break;

			case '>' :
				/* zur nchsten Nachricht */
				/* aktuelle berspringen */
				if (index_next(gh) && msg_read(gh))
					keep = FALSE;
				else
				{
#ifdef BOX
					nonstop = FALSE;
#endif
					do_beep();
				}
				break;

			case 's' :
				/* select ( )alles, (t)hema, (a)utor, (i)nhalt */
				mputs("( )alles, (t)hema, (a)utor, (i)nhalt");
				switch (taste())
				{
					case 't' :
						if (mp->inhalt)
						{
							index_goto(gh,top + cp[cursor]);
							msg_read(gh);
						}
						strncpy(sel.name,mp->offset.topic,79);
						sel.crc = crc32ansi(mp->offset.topic,strlen(mp->offset.topic));
						sel.art = SEL_THEMA;
						cursor = 0;
						break;

					case 'a' :
						if (mp->inhalt)
						{
							index_goto(gh,top + cp[cursor]);
							msg_read(gh);
						}
						strncpy(sel.name,mp->offset.author,79);
						sel.crc = crc32ansi(mp->offset.author,strlen(mp->offset.author));
						sel.art = SEL_AUTOR;
						cursor = 0;
						break;

					default :
						if (sel.art != SEL_ALL)
						{
							int i;

							sel.art = SEL_ALL;
							if (mp->inhalt)
								keep = FALSE;

							index_goto(gh,top + cp[cursor]);
							msg_read(gh);

							for (i = 0; i < 100; i++)
								cp[i] = i;
						}
				}
				if (sel.art != SEL_ALL)
					keep = FALSE;
				break;

			case 'r' :
				/* Merken des aktuellen Themas/Autors (remember) */
				mputs("(A)utor oder (T)hema");
				{
					msg_read_header(gh);
					msg_split_header(gh);
					switch (toupper(taste()))
					{
						case 'A' :
							strncpy(klemm.name,mp->offset.author,80);
							klemm.name[80] = 0;
							klemm.crc = crc32ansi(mp->offset.author,strlen(mp->offset.author));
							klemm.art = AUTOR;
							break;

						case 'T' :
							strncpy(klemm.name,mp->offset.topic,80);
							klemm.name[80] = 0;
							klemm.crc = crc32ansi(mp->offset.topic,strlen(mp->offset.topic));
							klemm.art = TITEL;
							break;

						default :
							klemm.art = 0;
					}
				}	
				clr_meldung(gh);
				break;

			case 'n' :
				/* nchstes Auftauchen dieses Themas/Autors */
				if (msg_suche_merker(gh,&klemm,TRUE))
				{
					msg_read(gh);
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
				{
					do_beep();
					msg_read(gh);
				}
				break;

			case 'v' :
				/* vorheriges Auftauchen dieses Themas/Autors */
				if (msg_suche_merker(gh,&klemm,FALSE))
				{
					msg_read(gh);
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
				{
					do_beep();
					msg_read(gh);
				}
				break;

			case '/' :
				/* Text Nachrichtenbergreifend suchen (vorwrts, inkl. Header) */
				mprintf("Textsuche: ");
				mgets(suchtext,40);
				if (*suchtext)
				{
/*					klemm.art = SEL_TEXT; ### */
					if (msg_suche_string(gh,suchtext,TRUE,TRUE))
					{
						mp->ursprung = msg_get_nr(gh);
						msg_read(gh);
						if (!mp->inhalt)
							keep = FALSE;
					}
					else
						do_beep();
				}
				clr_meldung(gh);
				break;

			case '0' :
				/* Einstiegsmail (in die Verkettung) anspringen */
				if (index_goto(gh,mp->ursprung) && msg_read(gh))
				{
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
					do_beep();
				break;

			case C_DOWN :
				if (mp->inhalt)
				{
					if (cp[cursor+1] < cp[cursor])
						break;
					if (msg_get_nr(gh) +1 >= anzahl)
					{
						do_beep();
						break;
					}
					if (sel.art == SEL_ALL)
					{
						if (!index_next(gh))
							break;
					}
					else
						index_goto(gh,top + cp[cursor+1]);
					index_read(gh);
					if (++cursor >= i_anz)
					{
						cursor = 0;
						if (top + i_anz >= anzahl -1)
							top = anzahl -1;
						else
							top += i_anz;
						index_goto(gh,top);
						keep = FALSE;
					}
					mp->ursprung = msg_get_nr(gh);
					break;
				}
				/* fall through */
			case '2' :
				/* gibt es einen Kommentar ? */
				if (msg_down(gh))
				{
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
					do_beep();
				break;

			case C_UP :
				if (mp->inhalt)
				{
					if (!msg_get_nr(gh))
					{
						do_beep();
						break;
					}
					if (sel.art != SEL_ALL && !cursor)
						break;
					if (sel.art == SEL_ALL)
					{
						if (!index_prev(gh))
							break;
					}
					else
					if (cursor)
						index_goto(gh,top + cp[cursor-1]);
					if (--cursor < 0)
					{
						if (top < i_anz)
						{
							top = 0;
						}
						else
						{
							top -= i_anz;
							cursor = i_anz -1;
						}

						index_goto(gh,top + cp[cursor]);
						msg_read(gh);
						keep = FALSE;
					}
					else
						index_read(gh);
					mp->ursprung = msg_get_nr(gh);
					break;
				}
				/* fall through */
			case '8' :
				/* ist dies ein Kommentar ? */
				if (msg_up(gh))
				{
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
					do_beep();
				break;

			case '4' :
			case C_LEFT :
				/* gibt es einen Vorgnger ? */
				if (msg_prev(gh))
				{
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
					do_beep();
				break;

			case '6' :
			case C_RIGHT :
				/* gibt es einen Nachfolger ? */
				if (msg_next(gh))
				{
					if (!mp->inhalt)
						keep = FALSE;
				}
				else
					do_beep();
				break;

			case '5' :
				/* zur Wurzel eines Kommentarbaumes */
				if (index_goto_top(gh))
				{
					msg_read(gh);
					keep = FALSE;
				}
				else
					do_beep();
				break;

			case C_PGUP :
			case '9' :
				/* in Inhaltsbersicht eine Seite zurck */
				if (!mp->inhalt)
					break;
				if (!top && cp[cursor])
				{
					cursor = 0;
					index_goto(gh,0);
				}
				else
				if (top && top < i_anz)
				{
					top = 0;
					keep = FALSE;
				}
				else
				if (top >= i_anz)
				{
					top -= i_anz;
					keep = FALSE;
				}
				else
					do_beep();
				index_goto(gh,top + cp[cursor]);
				msg_read(gh);
				break;

			case C_PGDN :
			case '3' :
				/* in Inhaltsbersicht eine Seite vor */
				if (!mp->inhalt)
					break;
				if (top + i_anz < anzahl)
				{
					top += i_anz;
					keep = FALSE;
				}
				else
				if (top + i_anz >= anzahl -1)
				{
					if (top + cursor >= anzahl -1)
						do_beep();
					else
						cursor = anzahl -1 - top;
				}
				index_goto(gh,top + cp[cursor]);
				msg_read(gh);
				break;

			case '7' :
				/* in Inhaltsbersicht zum Anfang der Gruppe */
				if (!mp->inhalt)
					break;
				if (top)
				{
					top = 0;
					msg_index(gh,top,cursor);
					index_goto(gh,top + cp[cursor]);
					msg_read(gh);
				}
				else
				if (cp[cursor])
				{
					index_goto(gh,0);
					cursor = 0;
				}
				else
					do_beep();
				break;

			case '1' :
				/* in Inhaltsbersicht zum Ende der Gruppe */
				if (!mp->inhalt)
					break;
				if (top + i_anz < anzahl)
				{
					if (anzahl > i_anz)
						top = anzahl - i_anz;
					else
						top = 0;
					cursor = anzahl - top -1;
					index_goto(gh,top + cp[cursor]);
					msg_read(gh);
					keep = FALSE;
				}
				else
				if (top + cp[cursor] < anzahl -1)
					index_goto(gh,anzahl -1);
				else
					do_beep();
				break;

			case 't' :
				/* Teillschung */
				if (!mp->su)
					break;
				if (msg_get_flag(gh) & TEIL)
					msg_clr_flag(gh,TEIL);
				else
					msg_set_flag(gh,TEIL);
				if (msg_get_flag(gh) & TOTAL)
					msg_clr_flag(gh,TOTAL);
				/* teilgelschte berspringen ? */
				if (msg_get_flag(gh) & TEIL)
					if (msg_next_new(gh,TEIL))
						keep = FALSE;
				break;

			case '*' :
				/* Lschsperre */
				if (!mp->su)
					break;
				if (msg_get_flag(gh) & GESCHUETZT)
					msg_clr_flag(gh,GESCHUETZT);
				else
				if (!(msg_get_flag(gh) & TOTAL))
					msg_set_flag(gh,GESCHUETZT);
				else
					do_beep();
				break;

			case 'd' :
			case '\b' :
			case 127 :
				/* Totallschung */
				if (!mp->su)
					break;
				/* Message geschtzt ? */
				if (msg_get_flag(gh) & GESCHUETZT)
				{
					do_beep();
					break;
				}
				if (msg_get_flag(gh) & TOTAL)
					msg_clr_flag(gh,TOTAL);
				else
					msg_set_flag(gh,TOTAL);
				if (msg_get_flag(gh) & TEIL)
					msg_clr_flag(gh,TEIL);

				/* nun zu lschen oder nicht mehr zu lschen ? */
				if (config.skip_del && (msg_get_flag(gh) & TOTAL))
				{
					/* zu lschende berspringen ? */
					/* nur, wenn nicht gerade innerhalb eines Kommentarbaums */
					if (mp->inhalt)
					{
						if (sel.art != SEL_ALL)
						{
							cursor++;
							index_goto(gh,top + cp[cursor]);
							msg_read(gh);
							break;
						}
						else
						{
							msg_next_new(gh,TOTAL | TEIL);
							mp->ursprung = msg_get_nr(gh);
						}
					}
					else
					if (mp->ursprung == msg_get_nr(gh))
					{
						if (msg_next_new(gh,TOTAL | TEIL))
							keep = keep_bottom = FALSE;
					}
				}
				break;

			case 'T' :
				/* kill Titel */
			case 'D' :
				/* kill/remove Autor, Titel, Verkettung */
				if (!mp->su)
					break;
				if (wahl == 'D')
					mprintf("(A)utor, (T)hema oder (V)erkettung");
				{
					BOOLEAN all = FALSE;
					BOOLEAN valid = TRUE;
					WORD art = 0;					/* keep gcc happy */
					char *cmp = NULL;				/* dito */

					msg_read_header(gh);
					msg_split_header(gh);

					if (wahl == 'T')
					{
						art = TITEL;
						cmp = mp->offset.topic;
					}
					else
					switch (taste())
					{
						case 'A' :
							all = TRUE;
						case 'a' :
							art = AUTOR;
							cmp = mp->offset.author;
							break;

						case 'T' :
							all = TRUE;
						case 't' :
							art = TITEL;
							cmp = mp->offset.topic;
							break;

						case 'V' :
							all = TRUE;
						case 'v' :
							art = VERKETTUNG;
							cmp = NULL;
							break;

						default :
							valid = FALSE;
					}
					if (valid)
					{
						MESSAGE akt = msg_get_nr(gh);

						msg_kill(gh,art,all,cmp);

						if (config.skip_del)
						{
							if (mp->inhalt || (!mp->inhalt && akt == mp->ursprung))
								if (msg_next_new(gh,TOTAL | TEIL) && mp->inhalt)
									mp->ursprung = msg_get_nr(gh);

							keep = FALSE;
						}
					}
				}
				clr_meldung(gh);
				break;

#if !defined(BOX)
			case 'F' :
				/* Autor bzw. Thema in Filter aufnehmen */
				if (!mp->su)
					break;
				mputs("(A)utor oder (T)hema");
				{
					BOOLEAN valid = FALSE;
					WORD art = 0;					/* keep gcc happy */
					char *cmp = NULL;				/* dito */

					msg_read_header(gh);
					msg_split_header(gh);

					switch (toupper(taste()))
					{
						case 'A' :
							/* Autor in den Filter aufnehmen */
							add_filter(AUTOR,mp->offset.author,time(NULL));
							art = AUTOR;
							cmp = mp->offset.author;
							valid = TRUE;
							break;

						case 'T' :
							/* Thema in den Filter aufnehmen */
							add_filter(TITEL,mp->offset.topic,time(NULL));
							art = TITEL;
							cmp = mp->offset.topic;
							valid = TRUE;
							break;
					}
					if (valid)
					{
						msg_kill(gh,art,TRUE,cmp);

						if (config.skip_del)
						{
							if (mp->inhalt)
								keep = FALSE;
							else
							if (mp->ursprung == msg_get_nr(gh))
							{
								if (msg_next_new(gh,TOTAL | TEIL))
									keep = FALSE;
							}
						}
					}
				}
				clr_meldung(gh);
				break;
#endif

#if !defined(BOX)
			case 'P' :
			case C_PRINT :
				/* ### todo: reicht msg_print nicht das handle ? (Umbruch) */
				msg_print(mp->anzeige,mp->ix.len);
				break;

			case 'S' :
				{
					char datei[PATH_MAX];

					mprintf("Dateiname: ");
					*datei = 0;
					mgets(datei,80);
					if (!*datei)
						break;
					msg_write(gh,datei,msg_umbruch(mp->offset.text,mp->anzeige,80));
				}
				clr_meldung(gh);
				break;
#endif

			case '-' :
				/* zur kommentierten Gruppe (gK) */
				if ((mp->ix.flags & GUEK)
				&& !strcmp(mp->anzeige,"Kommentar"))		/* Wildwest ? */
				{
					keep = FALSE;
					mputs("evtl. gK (Taste)");
					taste();
					/* ... */
				}
				else
				{
					do_beep();
					mputs("Dies ist kein gruppenbergreifender Kommentar");
					if (!mp->inhalt)
						sleep(1);
				}
				clr_meldung(gh);
				break;

			case '+' :
				if (mp->ix.zu_msg)
				{
					keep = FALSE;
					/* ... */
				}
				else
				{
					do_beep();
					mputs("Hierzu gibt es keinen gruppenbergreifenden Kommentar");
					if (!mp->inhalt)
						sleep(1);
				}
				clr_meldung(gh);
				break;

			case 'I' :
				/* Gruppeninfo */
				group_flush(gh,pid);
				gruppeninfo(gruppenname,pm);
				keep = FALSE;
				keep_bottom = FALSE;
				break;

#ifndef BOX_WITHOUT_INDEX
			case 'L' :
			case '\t' :
				/* zwi. Inhaltsbersicht- und Msg.Darstellung wechseln */
#ifdef BOX
				if (vtmodeW == T_ASCII)
				{
					do_beep();
					mputs("Inhaltsdarstellung nur mit Terminalemulation mglich");
					break;
				}
#endif
				mp->inhalt = !mp->inhalt;
				if (!mp->inhalt)
					msg_read(gh);
				else
					cursor_update(gh,cursor,TRUE);
				keep = FALSE;
				keep_bottom = FALSE;
				break;

			case 'B' :
				/* Kommentarbaum */
				msg_tree(gh);
				keep = FALSE;
				keep_bottom = FALSE;
				break;
#endif

			case 'H' :
				/* Mailheader */
				if (mp->inhalt)
					msg_read(gh);
				msg_show_header(gh);
				keep = FALSE;
				keep_bottom = FALSE;
				break;

			case 'g' :
				/* goto Message */
				mputs("(a)nfang, (e)nde, (s)tart, (d)atum, (n)ummer, (i)d");
				switch (toupper(taste()))
				{
					case 'S' :
						if (mp->kennung.letzte != LEER)
						{
							if (index_goto(gh,mp->kennung.letzte) && msg_read(gh))
								keep = FALSE;
							else
								fputs("Fehler beim Anfahren der letzten Msg.\r\n",stderr);
						}
						break;

					case 'A' :
						if (msg_get_nr(gh) != 0)
						{
							index_goto(gh,0);
							msg_read(gh);
							top = cursor = 0;
							keep = FALSE;
						}
						break;

					case 'E' :
						if (index_goto(gh,anzahl -1))
						{
							msg_read(gh);
							keep = FALSE;
						}
						break;

					case 'D' :
						/* ... */
						break;

					case 'N' :
						{
							char neu[8];
							MESSAGE neu_nr;

							*neu = 0;
							mprintf("Nummer: ");
							mgets(neu,6);
							if (!*neu)
								break;
							neu_nr = (MESSAGE) atol(neu);
							if (neu_nr  &&  (neu_nr <= anzahl))
							{
								neu_nr--;

								index_goto(gh,neu_nr);
								msg_read(gh);
								mp->ursprung = neu_nr;

								if (!mp->inhalt)
									keep = FALSE;
							}
							else
								do_beep();
						}
						break;

					case 'I' :
						/* ID-Suche ber Textsuche mglich */
						break;

					default	 :
						do_beep();
				}
				clr_meldung(gh);
				break;

#ifdef BOX
#if 1
			case 'f' : /* forward */
				do_beep(); /* sorry */
				break;
			case 'b' : /* persnliche beantworten */
			case 'k' : /* ffentlich kommentieren */
			case 'm' : /* neue AM */
			case 'p' : /* neue PM */
				{
					MESSAGE akt = msg_get_nr(gh);
					char *id;

					msg_split_header(gh);
					inhalt = mp->inhalt;

					/*
						alle fr ein Posting relevanten Daten merken, da diese 
						danach nicht mehr zur Verfgung stehen
					*/
					id    = strdup(mp->offset.id);

					/*
						Gruppe erst schlieen, damit der Import einwandfrei 
						arbeiten kann. _eigentlich_ sollte das Schlieen 
						unntig sein, solange im Boxmodus niemals Indexdaten 
						verndert werden. Das mu aber noch in index_write() 
						verankert werden.
					*/
					group_close(gh,pid);

					if (wahl=='m') /* neue AM */
						senden_text(FALSE, NULL, NULL, NULL);
					else if (wahl=='p')
						senden_text(FALSE, NULL, NULL, NULL);
					else if (pm || wahl=='b') /* ja, *so* */
						senden_text(TRUE, id, NULL, NULL); 
					else
						senden_text(FALSE, id, NULL, NULL);

					free(id);

					/*
						Hack: rekursive Rckkehr in den Browser, 
						kostet aber nur ein paar Bytes auf dem Stack
					*/
					return msg_browser(gruppenname,pm,inhalt,akt,0);
				}
#else
			case 'f' :
			case 'b' :
			case 'k' :
			case 'm' :
			case 'p' :
				{
					MESSAGE akt = msg_get_nr(gh);
					char *autor,*thema,*id;

					msg_split_header(gh);
					inhalt = mp->inhalt;

					/*
						alle fr ein Posting relevanten Daten merken, da diese 
						danach nicht mehr zur Verfgung stehen
					*/
					autor = strdup(mp->offset.author);
					thema = strdup(mp->offset.topic);
					id    = strdup(mp->offset.id);

					/*
						Gruppe erst schlieen, damit der Import einwandfrei 
						arbeiten kann. _eigentlich_ sollte das Schlieen 
						unntig sein, solange im Boxmodus niemals Indexdaten 
						verndert werden. Das mu aber noch in index_write() 
						verankert werden.
					*/
					group_close(gh,pid);

					(void) message(wahl,gruppenname,id,thema,autor);

					free(id);
					free(thema);
					free(autor);

					/*
						Hack: rekursive Rckkehr in den Browser, 
						kostet aber nur ein paar Bytes auf dem Stack
					*/
					return msg_browser(gruppenname,pm,inhalt,akt,0);
				}
#endif
#else
			case 'f' :
				/* forward */
				mputs("forward to:");
				{
					char betreff[MAX_CPG];
					char empfaenger[MAX_CPG] = "";
					OFFSET neu;

					msg_split_header(gh);
					neu = mp->offset;

					mprintf("Empfnger: ");
					mgets(empfaenger,MAX_CPG);
					if (!*empfaenger)
						break;
					neu.author = empfaenger;
					neu.name = empfaenger;
					mputs("");

					/* alten Betreff als Voreinstellung bernehmen */
					strcpy(betreff,neu.topic);
					strcat(betreff,"(fwd)");
					mprintf("Betreff: ");
					mgets(betreff,MAX_CPG);
					if (!*betreff)
						break;
					neu.topic = betreff;

					message(gh,FWD_PM,&neu);
					keep = FALSE;
				}
				clr_meldung(gh);
				break;

			case 'b' :
				/* beantworten */
				if (mp->ix.flags & YOURMAIL)
				{
					mputs("Selbstgesprche sind langweilig");
					do_beep();
					if (!mp->inhalt)
						sleep(1);
					clr_meldung(gh);
					break;
				}
				mputs("beantworten");
				/* ### Hack, Msg. wg. Init von offset->name neu einlesen */
				msg_read(gh);
				msg_split_header(gh);
				/* Antwort bzw. Kommentar-PM */
				if (message(gh,(pm) ? ANTWORT : KOMM_PM,&mp->offset) && pm)
				{
#ifdef BOX
					UWORD status=(msg_get_status(gh) & ~GEAENDERT);
					if (!status||status==ZURUECKGESTELLT||status==GELESEN)
						bef_lesen_status_callback(mp->offset.id,'B');
#endif
					msg_set_status(gh,BEANTWORTET);
				}
				keep = FALSE;
				keep_bottom = FALSE;
				break;

			case 'k' :
				/* kommentieren */
				if (!pm)
				{
					mputs("kommentieren");
					msg_split_header(gh);
					message(gh,KOMMENTAR,&mp->offset);
					keep = FALSE;
					keep_bottom = FALSE;
				}
				else
					do_beep();
				break;

			case 'K' :
				/* gruppenbergreifend kommentieren */
				if (!pm)
				{
					char gruppe[MAX_CPG] = "";
					OFFSET neu;

					msg_split_header(gh);
					neu = mp->offset;

					mputs("In welche Gruppe kommentieren: ");
					mgets(gruppe,MAX_CPG);
					if (!*gruppe)
						break;
					neu.group = gruppe;
					mputs("");
					/* ### evtl. zustzlich Wildwest-Zeile erzeugen */
					message(gh,KOMMENTAR,&neu);
					keep = FALSE;
					keep_bottom = FALSE;
				}
				else
					do_beep();
				break;

			case 'm' :
				/* neue ffentliche Message */
				mputs("neue Message");
				{
					char betreff[MAX_CPG] = "";
					OFFSET neu;

					msg_split_header(gh);
					neu = mp->offset;
					
					mprintf("Betreff: ");
					mgets(betreff,MAX_CPG);
					if (!*betreff)
						break;
					neu.topic = betreff;
					mputs("");
					message(gh,NEUE_MSG,&neu);
					keep = FALSE;
					keep_bottom = FALSE;
				}
				clr_meldung(gh);
				break;

			case 'p' :
				/* neue persnliche Message */
				mputs("neue PM");
				{
					char betreff[MAX_CPG] = "";
					char empfaenger[MAX_CPG] = "";
					OFFSET neu;

					msg_split_header(gh);
					neu = mp->offset;

					mprintf("Empfnger: ");
					mgets(empfaenger,MAX_CPG);
					if (!*empfaenger)
						break;
					neu.author = empfaenger;
					neu.name = empfaenger;
					mputs("");

					mprintf("Betreff: ");
					mgets(betreff,MAX_CPG);
					if (!*betreff)
						break;
					neu.topic = betreff;
					mputs("");

					message(gh,NEUE_PM,&neu);
					keep = FALSE;
					keep_bottom = FALSE;
				}
				clr_meldung(gh);
				break;
#endif

			case 'z' :
				/* PM zurckstellen */
				if (!pm)
					break;
				/* Messagestatus erzeugen */
#ifdef BOX
				{
					UWORD status=(msg_get_status(gh) & ~GEAENDERT);
					if (!status||status==GELESEN)
						bef_lesen_status_callback(mp->offset.id,'Z');
				}
#endif
				msg_set_status(gh,ZURUECKGESTELLT);
				if (msg_next_new(gh,TOTAL | GELESEN | TEIL))
				{
					if (mp->inhalt)
						keep = keep_bottom = FALSE;
				}
				else
					abbruch = TRUE;
				break;

			case 'Z' :
				/* zur nchsten zurckgestellten Mail */
				if (!pm)
					break;
				index_push(gh);
				{
					BOOLEAN found = FALSE;

					while (index_next(gh) && index_read(gh))
						if (msg_get_status(gh) & ZURUECKGESTELLT)
						{
							found = TRUE;
							if (!mp->inhalt)
								keep = keep_bottom = FALSE;
							break;
						}
					if (!found)
						index_pop(gh);
					msg_read(gh);
				}
				break;

			case 'V' :
				/* Gruppe bestellen */
				if (pm)
					break;
#ifdef BOX
				/* tausch.gruppe = AN; */
				/* ... */
/*				tausch_add(gruppenname);*/
#else
				bestelle_gruppe(gruppenname,TRUE);
#endif
				mputs("Gruppe bestellt");
				if (!mp->inhalt)
					sleep(1);
				clr_meldung(gh);
				break;

			case 'U' :
				/* Gruppe abbestellen */
				if (pm)
				{
					do_beep();
					break;
				}
#ifdef BOX
/*				tausch_del(gruppenname);*/
#else
				bestelle_gruppe(gruppenname,FALSE);
#endif
				mputs("Gruppe abbestellt");
				if (!mp->inhalt)
					sleep(1);
				clr_meldung(gh);
				break;

#ifndef BOX
			case 'M' :
				/* Mitglied ein- bzw. austragen */
				if (pm)
				{
					do_beep();
					break;
				}
				/* ggf. Hinweis geben, ob die Gruppe auf Mitgliedschaft steht */
#if 0
				if (!itg_flag(gruppenname,'M'))
				{
					mputs("[lt. ITG steht die Gruppe nicht auf Mitgliedschaft]");
					do_beep();
					sleep(1);
					clr_meldung(gh);
				}
#endif
				mputs("Mitglied (e)in- oder (a)ustragen ?");
				{
					int c = toupper(taste());
					if (c != 'E' && c != 'A')
						do_beep();
					else
					{
						char name[80] = { 0 };
						clr_meldung(gh);
						mprintf("Name: ");
						mgets(name,80);
						if (*name)
							mitglied(gruppenname,name,(c == 'E'));
					}
				}
				clr_meldung(gh);
				break;

			case 'A' :
				/* Autor in Adredatei eintragen */
				if (mp->ix.flags & YOURMAIL)
				{
					mputs("Sie selbst sind der Absender");
					do_beep();
				}
				else
				{
					insert_adress(mp->offset.author);
					mputs("Autor in Adredatei eingetragen");
				}
				sleep(1);
				clr_meldung(gh);
				break;
#endif

#ifdef TEXT_FRONTEND
			case 'o' :
				optionen();
				keep = FALSE;
				break;
#endif

			case 12 :
				/* Ctrl-L, Bildneuaufbau */
				get_screen();
				i_anz = bs_zeilen -5;
				keep = FALSE;
				break;

			case 'R' :
				if (!mp->inhalt)
				{
					msg_rot13(gh);
					keep = FALSE;
				}
				break;

#ifdef BOX
			case 'N' : 
				nonstop = TRUE;
				break;
#endif

			case 'h' :
			case '?' :
			case C_HELP :
				/* Hilfstext anzeigen */
				{
					int zeile = 0;
					int i = 0;
					while (1)
					{
#ifdef TEXT_FRONTEND
						if (!zeile)
							tprint("cl");
#endif
						if (!lesehilfe[i])
							break;
						mputs(lesehilfe[i]);
						zeile++;
						if (zeile == bs_zeilen-1)
						{
							if (taste() == 'q')
								break;
							zeile = 0;
						}
						i++;
					}
				}
				taste();
				keep = keep_bottom = FALSE;
				break;
		}
	}
	while (!abbruch);

	get_terminal(FALSE);

	group_close(gh,pid);

	return weiter;

} /* msg_browser */



/*
	Headereintrge der aktuellen Nachricht anzeigen
*/
static void msg_show_header(int gh)
{
	WORK *mp = msg[gh];
	char *p;

#ifdef TEXT_FRONTEND
	tprint("cl");
#endif

	p = mp->puffer;

	while ((p - mp->puffer) < mp->ix.t_text)
	{
		int len;

		len = (int) strcspn(p+1,"\r\n");
		switch (*p)
		{
			case '#' :	mprintf("ID           : %.*s\r\n",len,p+1);
							break;
			case 'V' :	mprintf("Absender     : %.*s\r\n",len,p+1);
							break;
			case 'S' :	mprintf("Sender       : %.*s\r\n",len,p+1);
							break;
			case 'T' :	mprintf("Reply-To     : %.*s\r\n",len,p+1);
							break;
			case 'O' :	mprintf("Organisation : %.*s\r\n",len,p+1);
							break;
			case 'W' :	mprintf("Betreff      : %.*s\r\n",len,p+1);
							break;
			case 'E' :	mprintf("Eingabe am/um: %.*s\r\n",len,p+1);
							break;
			case '-' :	mprintf("Referenz-ID  : %.*s\r\n",len,p+1);
							break;
			case 'G' :	mprintf("Gruppe       : %.*s\r\n",len,p+1);
							break;
			case 'F' :	mprintf("Followup-To  : %.*s\r\n",len,p+1);
							break;
			case 'I' :	mprintf("orig. ID     : %.*s\r\n",len,p+1);
							break;
			case 'R' :	mprintf("orig. Ref.-ID: %.*s\r\n",len,p+1);
							break;
			case 'D' :	mprintf("Distribution : %.*s\r\n",len,p+1);
							break;
			case 'A' :	mprintf("An           : %.*s\r\n",len,p+1);
							break;
			case 'N' :	mprintf("Name         : %.*s\r\n",len,p+1);
							break;
			case 'B' :	mprintf("beantwortet  : %.*s\r\n",len,p+1);
							break;
			case 'Y' :	mprintf("Gateway      : %.*s\r\n",len,p+1);
							break;
			case 'p' :	mprintf("Path         : %.*s\r\n",len,p+1);
							break;

			default :	mprintf("unbekannt    : %.*s\r\n",len+1,p);
		}
		p += len+1;
		while (!*p || *p=='\r' || *p=='\n')
			p++;
	}

	(void) taste();

} /* msg_show_header */



/*
	Stichwortanzeige

	->			gh		:	Gruppenhandle
				top	:	Nr. der obersten Nachricht
*/
static void msg_index(int gh,MESSAGE top,int cursor)
{
	MESSAGE nr;					/* aktuelle Messagenummer */
	WORK *mp;
	UWORD printed;				/* Anzahl ausgegebener Stichwortzeilen */
	char zeile[200];			/* einzelne Stichwortzeile */
	size_t zeichen = 0;		/* zu vergleichende Zeichen */

/*	if (sel.art == SEL_TEXT && !*suchtext)
		return;*/

#ifdef TEXT_FRONTEND
	tprint("cl");
#elif defined(BOX)
	gotoxy(0,0);
	mprintf("%s",vt_S(DEL_SCR));
	gotoxy(0,0);
#endif

	status_show(gh,top,cursor);
	gotoxy(0,2);

	if (sel.art != SEL_ALL)
		zeichen = strlen(sel.name);

	mp = msg[gh];
	index_push(gh);
	nr = top;

	get_screen();
	i_anz = bs_zeilen -4;

	printed = 0;
	while ((printed < i_anz) && (nr < mp->kennung.anzahl))
	{
		int abbruch;

		if (!index_goto(gh,nr) || !index_read(gh))
			break;
#if 0
		/* gelschte Messages berspringen ? */
		if ((mp->ix.flags & TOTAL)  && config.skip_del)
			goto next;
#endif
		/* Themen und Autoren sind bereits via CRC erkennbar */
		if ((sel.art == SEL_THEMA && mp->ix.topic_crc  != sel.crc)
		||  (sel.art == SEL_AUTOR && mp->ix.author_crc != sel.crc))
			goto next;

		msg_index_string(gh,NULL,bs_spalten,zeile);

		switch (sel.art)
		{
			case SEL_THEMA :
				if (strncmp(zeile+50,sel.name,(zeichen <= 29) ? zeichen : 29))
					goto next;
				break;

			case SEL_AUTOR :
				if (strncmp(zeile+20,sel.name,(zeichen <= 23) ? zeichen : 23))
					goto next;
				break;

			case SEL_TEXT :
/*				if (!strstr(zeile,suchtext))*/
					goto next;
				break;
		}

		if (printed == cursor)
#if defined(TEXT_FRONTEND)
			tprint("so");
#elif defined(BOX)
			mprintf("%s",vt_S(ATTR_INVERS));
#else
			;
#endif
		abbruch = (mputs(zeile) < 0);
		if (printed == cursor)
#if defined(TEXT_FRONTEND)
			tprint("se");
#elif defined(BOX)
			mprintf("%s",vt_norm);
#else
			;
#endif

		/* Zuordnungstabelle, wichtig bei sel.* */
		cp[printed] = nr - top;

		if (abbruch)
			break;

		printed++;

next:
		if (!index_next(gh))
			break;
		nr++;
	}

	/* alte Message wieder einlesen */
	index_pop(gh);
	msg_read(gh);

} /* msg_index */



static int indent_level;

static void msg_tree(int gh)
{
	MESSAGE start;

	indent_level = 0;
#ifdef TEXT_FRONTEND
	tprint("cl");
#endif
	mputs("Kommentarbaum");
	get_screen();
	i_anz = bs_zeilen -4;

	start = msg_get_nr(gh);

	msg_tree_walk(gh);
	taste();

	/* alte Message wieder einlesen */
	index_goto(gh,start);
	msg_read(gh);

} /* msg_tree */



/*
	Kommentarbaum anzeigen

	Verfahren: Tiefensuche
*/
static void msg_tree_walk(int gh)
{
#define INDENT_LEVEL		2

	static char status[] = " GZBWMAGK";
	char datum[10];			/* dd.mm.yy */
	WORK *mp = msg[gh];
	char zeile[200];			/* einzelne Stichwortzeile */
	char author[100],topic[100];

	if (!index_read(gh))
		return;

	/* gelschte Messages berspringen ? */
	if ((mp->ix.flags & TOTAL) && config.skip_del)
		return;

	/* Messageheader einlesen */
	msg_read_header(gh);
	msg_split_header(gh);

	strftime(datum,11,"%d.%m.%y",localtime(&mp->ix.eingabe));

	strncpy(author,mp->offset.author,100);
	author[99] = 0;
	strncpy(topic,mp->offset.topic,100);
	topic[99] = 0;

	sprintf(zeile," %c%c %8s %*s %-26.26s (%3u) %-.31s",
	(mp->ix.oben  != LEER || mp->ix.links  != LEER) ? '<' : ' ',
	(mp->ix.unten != LEER || mp->ix.rechts != LEER) ? '>' : ' ',
	datum,
	indent_level * INDENT_LEVEL,"",
	author,mp->ix.zeilen,topic);

	zeile[1] = (mp->pm) ? status[mp->ix.status & 0x7fff] : ' ';
	zeile[2] = (mp->ix.flags & TOTAL ) ? 'D' : ' ';
/*	zeile[3] = (mp->ix.flags & TEIL  ) ? 'T' : ' ';*/
	zeile[3] = (mp->ix.flags & URGENT) ? 'U' : ' ';

	if (mputs(zeile) < 0)
		return;

	/* Tiefensuche, also erst die Nachfolger */
	if (mp->ix.unten != LEER)
	{
		MESSAGE save_pos;

		save_pos = msg_get_nr(gh);
		index_goto(gh,mp->ix.unten);
		indent_level++;
		msg_tree_walk(gh);
		indent_level--;
		index_goto(gh,save_pos);
		index_read(gh);
	}

	/* jetzt die Nachrichten derselben Ebene */
	if (mp->ix.rechts != LEER)
	{
		MESSAGE save_pos;

		save_pos = msg_get_nr(gh);
		index_goto(gh,mp->ix.rechts);
		msg_tree_walk(gh);
		index_goto(gh,save_pos);
		index_read(gh);
	}

} /* msg_tree_walk */



#if defined(BOX) || defined(TEXT_FRONTEND)

#define TEXT_ATTRIBUTE
#define ATTRIBUTE				"*/_"
#define PRE_ATTR1				" :>([{\"'"
#define POST_ATTR1			"abcdefghijklmnopqrstuvwxyz" \
									"ABCDEFGHIJKLMNOPQRSTUVWXYZ" \
									"" \
									"01234567890" \
									"\"'"
#define POST_ATTR2			"\r\n .,;!-?:"

/*
	einzelne Zeile ausgeben

	->			text	:	Textzeile

	- Attribute (italic, fett, unterstrichen) werden ausgewertet
	- Quote-Krzel werden farbig dargestellt
	- eine simple uu-Heuristik verhindert meist Effekte in diesen

	bug:
	- in UUs ausnutzen, da wenige, oft keine Leerzeichen vorhanden sind
*/
static int msg_show_line(const char *text)
{
	char *att_anf = NULL;
	char *att_end = NULL;
	int len;
	int quotelevel = 0;

	if (!config.text_effects)
		return mputs(text);

	/* primitive uu-Erkennung, lieber kein Effekt als ein falscher */
	len = strlen(text);
	if ((len == 62) && (*text == 'M') && isalpha(text[61]))
		return mputs(text);

	while (((att_anf = strchr(text,'>')) != NULL)
	&& (att_anf - text < 10))
	{
		int i;
		int quote = TRUE;
		char vt_color[20];

		len = att_anf+1 - text;
		for (i = 0; (i < len-1) && quote; i++)
			if (!isalpha(text[i]))
				quote = FALSE;

		if (quote)
		{
			if (vt100)
				sprintf(vt_color,"\033[3%dm",(quotelevel+1) % 8);
			else
				strcpy(vt_color,vt_fett);
			mprintf("%s%*.*s%s",
			       (config.color_quotes) ? vt_color : vt_fett,
			       len,len,text,vt_norm);

			text = att_anf +1;
			quotelevel++;
		}
		else
		{
			mprintf("%*.*s",len,len,text);
			text = att_anf +1;
			break;
		}
	}

	while (*text)
	{
		if (((att_anf = strpbrk(text,ATTRIBUTE)) != NULL)
		&& ((att_anf == text) || strchr(PRE_ATTR1,*(att_anf-1)))
		&& strchr(POST_ATTR1,att_anf[1])
		&& ((att_end = strpbrk(att_anf+1,ATTRIBUTE)) != NULL)
		&& ((*(att_end+1) == 0) || strchr(POST_ATTR2,*(att_end+1))))
		{
			len = att_anf - text;
			if (len)
				mprintf("%*.*s",len,len,text);
			/* Bereich zwi. att_anf und att_end attributiert darstellen */
			len = att_end - (att_anf+1);
			if (len)
			{
				char *vt_on;
				char *vt_off = vt_norm;

				if (*att_anf == '*')
					vt_on = vt_bold;
				else
				if (*att_anf == '/')
					vt_on = vt_fett;
				else
				if (*att_anf == '_')
					vt_on = vt_uset , vt_off = vt_uend;
				else
					vt_on = vt_dummy;

				mprintf("%s%*.*s%s",vt_on,len,len,att_anf+1,vt_off);
			}
			text = att_end+1;
		}
		else
		{
			mprintf("%s",text);
			break;
		}
	}

	return mputs("");

} /* msg_show_line */



/*
	Message anzeigen

	->			gh	:	Gruppen-Handle

	Hier erfolgt auch der Umbruch gem. akt. Spaltenanzahl ($COLUMNS)
*/
static void msg_show(int gh)
{
	WORK *mp = msg[gh];
	int anzahl = 0;
	long zeilen;
	char *pos;
	char status[5];
	char nummer[8];
	char datum[12];
	int zps;					/* Zeilen/Seite, die IMMER ohne Scrolling passen */
	size_t max;				/* max. Spaltenzahl (-200) */
	char trenner[200];

#ifdef BOX
	count_crW = 0;
	/* ### CLEAR SCREEN: s.terminal.h und data.c von tom */
	set_scroll_area(0);
	mprintf(vt_S(DEL_SCR));
	gotoxy(0,0);
#else
	tprint("cl");
#endif

	max = (bs_spalten >= 200) ? 200-1 : bs_spalten-1;
	memset(trenner,'-',max);
	trenner[max] = 0;

	msg_split_header(gh);	/* ### */
	zeilen = msg_umbruch(mp->offset.text,mp->anzeige,bs_spalten);

	if (mp->pm)
		mprintf("%sUser    %s",vt_fett,vt_norm);
	else
		mprintf("%sGruppe  %s",vt_fett,vt_norm);
	mprintf(": %s\r\n",mp->kennung.name);

	if (mp->pm && (mp->ix.flags & YOURMAIL))
		mprintf("%sAn      %s",vt_fett,vt_norm);
	else
		mprintf("%sAbsender%s",vt_fett,vt_norm);

	sprintf(nummer,"(%ld)",(long) (msg_get_nr(gh) +1));
	mprintf(": %-*.*s %8s\r\n",bs_spalten-20,bs_spalten-20,
	       (mp->offset.name) ? mp->offset.name : mp->offset.author,nummer);
	strftime(datum,11,"%d.%m.%y",localtime(&mp->ix.eingabe));
	mprintf("%sBetreff %s",vt_fett,vt_norm);
	mprintf(": %-*.*s %s\r\n",bs_spalten-20,bs_spalten-20,mp->offset.topic,datum);
	mputs(trenner);

#ifdef BOX
	set_scroll_area(2);
#else
	if (vt100)
	{
		mprintf("\033[5;%dr",bs_zeilen);
		gotoxy(0,4);
	}
#endif

	/* Anzahl darstellbarer Zeilen/Seite ohne Gefahr von Scrolling */
	zps = i_anz -1;
	if (mp->ix.flags & (GESCHUETZT | TOTAL | TEIL))
		zps--;
	if (mp->ix.kommentare > 1)
		zps--;
	if (mp->pm)			/* Mailstatus */
		zps--;

	key = 0;

	pos = mp->anzeige;
	while (zeilen--)
	{
		if (msg_show_line(pos) < 0)
			break;

		pos += strlen(pos) + 1;
		if (*pos == '\r' || *pos == '\n')
			pos++;

		anzahl++;
#ifdef BOX
		if (nonstop)
		{
			if (userbreak())
				nonstop = FALSE;
		}
		else
		if (!mehr_disabled)
#endif
		if (anzahl % zps == 0)
		{
			int c;

			mprintf("%s<<MEHR>>%s",vt_fett,vt_norm);
/*			anzahl = 0;*/
			c = taste();
			mprintf("\r        \r");
			if (c == 'q' || c == '\33' || c == 24)
				break;
			if (strchr("\t<>?/*-+024568ABDFGHINPRSTUZbdfghkmnorstvxz",c))
			{
				key = c;
				break;
			}
			anzahl = 0;
#ifndef BOX
			if (!vt100)
				tprint("cl");
#endif
		}
	}

	if (mp->ix.flags & GESCHUETZT)
		mputs("Message ist geschtzt");

	if (mp->ix.kommentare > 1)
		mprintf("Hierzu gibt es %u %s\r\n",
		       mp->ix.kommentare,
		       (mp->pm) ? "Antworten" : "Kommentare");

	status[0] = (mp->ix.links != LEER) ? '<' : '.';
	status[1] = (mp->ix.oben  != LEER) ? '^' : '.';
	status[2] = (mp->ix.unten != LEER) ? 'v' : '.';
	status[3] = (mp->ix.rechts!= LEER) ? '>' : '.';
	status[4] = 0;
	mputs(status);

#ifdef BOX
	set_scroll_area(0);
#else
	if (vt100)
	{
		gotoxy(0,0);
		mprintf("\033[0;%dr",bs_zeilen);
	}
#endif
	gotoxy(0,bs_zeilen-3);

} /* msg_show */
#endif
