/* prototyp.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef PROTOTYP_H
#define PROTOTYP_H

#ifndef TOM_SYSDEP_H
#include "tomsysdep.h"
#endif
#include "libquark.h"
#include "uostr.h"

#include <time.h>			/* wg. time_t */
#include <stdio.h>		/* wg. FILE */

#include "brett.h"		/* wg. befehl_check_befehl() */

/* allgemeine Makros */
#if !defined(Min)
#define Min(a,b)			(((a) > (b)) ? (b) : (a))
#define Max(a,b)			(((a) < (b)) ? (b) : (a))
#define Abs(i)				(((i) >= 0) ? (i) : -(i))
#endif

	/* viele kleine Minuszeichen */
extern const char *trennzeile;

/* Globale externe Prozeduren/Funktionen */

long len_datei(const char *datei);
BOOLEAN fileexist(const char *name);
long filesize(FILE *stream);
char *tom_fgetline(char *buf,FILE *stream);
BOOLEAN do_configure(const char *cnf_name);
void dump_configuration(void);
BOOLEAN dump_shell_vars(FILE *outf);


void set_vtmode(WORD neu);

void dateifehler(const char *fname) TOM_ATTRIB_NORET;
void speicherproblem(BOOLEAN fatal, const char *wo);

void make_port_sys_path(void);



/* Globale modulinterne Prozeduren/Funktionen */

void init_menue(void);
void update_menue(void);

int select_menu(void);
int rsmtp(void);
int sym_junk_function(void);

void impressum(
	BOOLEAN *tauschlogin, BOOLEAN *multitausch, BOOLEAN *ist_gast,
	BOOLEAN *sysop_schutzzeichen, const char *force_user, 
	const char *hint_user, const char *fake_prompt, char **cmd);
BOOLEAN login(char *force_username, const char *hint_user, 
	BOOLEAN tauschlogin, BOOLEAN *ist_gast, BOOLEAN sysop_schutzzeichen);
void communication(BOOLEAN tauschlogin, BOOLEAN ist_gast);

char *befehl_eingabe(const char *prompt);

void get_auslastung(int *);
void put_auslastung(time_t startzeit, long sekunden);

void login_protokoll_daten(void);
void login_protokoll_create(void);
void login_protokoll_write(void);
void login_protokoll_close(void);

void msglog (const char *format,...) TOM_ATTRIB_PRINTF(1,2);
void msglog_end (void);

long anzahl_dateien(const char *pfad,const char *maske);

void chat_modus(void);
void check_timeout(void);
void check_part_free(BOOLEAN automode);
BOOLEAN check_user_data(USERNR unr);

BOOLEAN file_copy(const char *src,const char *dst);
BOOLEAN file_move(const char *src,const char *dst);
void display_status(const char *text);
BOOLEAN dateiauswahl(const char *info,const char *extT,char *path,char *datei);
void handle_error(void);

void rm_dir_content(const char *pfad);
void mistuser_routine(const char *name);
void online_zeit(void);
void ordner_daten(const char *pfad,BOOLEAN anzeige,long *anzahl,long *summe);
void parameter_falsch(const char *befe,const char *para);
void set_vtprefs(void);
void set_status_line(const char *line);
void redraw_status(void);
void update_statistik(void);
BOOLEAN zeige_datei(const char *name);
BOOLEAN zeige_interpret_datei(const char *name);
WORD auslastung(void);

BOOLEAN befehl_bezahlt(int iW);
char *befehl_dollar_S(int iW);

BOOLEAN mistuser(const char *username,BOOLEAN gross_klein);

const char *vt_S(int nr);
const char *vt_pos_S(int y,int x);
BOOLEAN wildcard(const char *vstring,const char *pattern);
const char *wochentagS(void);
BOOLEAN anrufe_annehmen(void);

WORD befehl_brettverwalter(int iW,long nrW);
BOOLEAN befehl_check_befehl(BRETT *for_group,const char *cmd,const char *para);

/* prft ob der Carrier weg ist und beendet das Programm,
 * falls das der Fall ist und der Parameter TRUE ist.
 */
void carrier_checkpoint(BOOLEAN leave_if_carrier_lost);
BOOLEAN carrier_still_up(void);

const char *make_connect(int fd,const char *nummer);
char *check_empfaenger_S(char *name);
void capitalize_words(char *name);

struct mbselect_t {
	unsigned char key;
	const char *output;
};
	/* erhlt ein Array bergeben, dessen letztes Element als key \0
	 * enthalten mu. Das output-Element darf berall leer sein, in
	 * dem Fall wird keine Ausgabe am Ende (fr die entsprechende
	 * Taste) gemacht.
	 */
WORD mbselect(const struct mbselect_t *auswahl);

BOOLEAN JAnein(const char *titel_oder_null);

WORD mbdecide(const char *auswahlT,const char *antwort);
time_t mb_read_date(time_t vgl);

WORD tausch_auto(void);
long get_new_id_nr(BOOLEAN binaer);
const char *download_time_S(BRETTNR bnr, long msgnr);
time_t download_time(ULONG bytes);
void befehl_ausfuehrung(char *cmd);
void batch_ausfuehrung(const char *file);
void automatic_batch(const char *filename);
void handle_events(void);
extern void cmdline_evaluation(int argc, char **argv, BOOLEAN is_setuid);

BOOLEAN passwort_aenderung(USER *work, BOOLEAN *ist_leer);

int
call_extern(const char *command,
    const char *workdir, time_t killzeit, 
    BOOLEAN ignore_exitcode, BOOLEAN as_user);
int call_system_prg(const char *prg,const char *cmd);
int call_editor(const char *datei, BOOLEAN do_backup);
int call_piped(const char *cmd, BOOLEAN interpret);
int output_file (FILE *f, BOOLEAN interpret);
BOOLEAN interpret_file_to_file (FILE *fin,FILE *fout);


BOOLEAN packer_kennung(int modus,const char *datei,char *endung);

void make_msg_id(char *id,BOOLEAN pm, const char *mtzeit, time_t *tt_zeit);

int set_scroll_area(int mode);
long gebuehren(time_t von,unsigned int zone,char *zeit_drinS);

void msleep(long msec);

BOOLEAN define_itoken(const char *varname, const char *value);
BOOLEAN do_interpret(const char *format, char *to, size_t max);

void bretteditor(const char *);
BOOLEAN lock_tom(int max_tries);


	/* from wird entumlautet nach to geschrieben. to muss mindestens
	 * die doppelte gre von "from" haben.
	 */
void entumlauten(const char *from, char *to);
	/* 20% Zeitersparnis :-) */
void entumlauten_fast(const char *from, char *to,size_t inputlen);
	/* Rckgabestring ist malloced. */
char * entumlauten1(const char *from);


char *datum_zeit_string(time_t *zeit);
char *datum_zeit_string_y2k(time_t *zeit);
char *zeige_datum_S(time_t zeit);
BOOLEAN zerlege_datum(const char *das_datum,int *t,int *m,int *j);
BOOLEAN zerlege_datum_2_time_t(const char *das_datum,time_t *tim);
LONG sek_time(const char *zeit);
char *prepare_prompt(void);
char *do_readline(const char *prompt, const char hint);

/*
 * Transfer-Protokolle
 * 0: OK
 * 1: User-Abbruch
 * 2: Fehler
 */
int transfer_send (char *art, const char *name);
int transfer_receive (char *art, char *name, long *laenge);
char transfer_protokollauswahl (BOOLEAN all, BOOLEAN space_zum_loeschen);
char transfer_protokollcheck (char);



	/* secure fopen, liefert niemals NULL zurck */
FILE *xfopen(const char *path, const char *mode);

#if 0
	/*
	 * Ob Frank das mgen wird? Aber es macht so vieles schner ...
	 */
void *xmalloc(size_t size, const char *fname, ULONG line);
#define XMALLOC(x) xmalloc(x,__FILE__,__LINE__)

char * xstrdup(const char *s, const char *fname, ULONG line);
#define XSTRDUP(x) xstrdup(x,__FILE__,__LINE__)

void * xrealloc(void *p, size_t size, const char *fname, ULONG line);
#define XREALLOC(x,y) xrealloc(x,y,__FILE__,__LINE__)

void * xcalloc(size_t nmemb, size_t size, const char *fname, ULONG line);
#define XCALLOC(x,y) xcalloc(x,y,__FILE__,__LINE__)

char * concat(const char *first,...);
#endif

enum tomexitcodes 
{
	LEAVE_OK,
	LEAVE_ERROR,
	LEAVE_PARA,
	LEAVE_RESTART,
	LEAVE_EVENT,
	LEAVE_FAX,
	LEAVE_LOGIN        /* Zwischenzustand, gelangt nie an exit() */
};

void tom_leave(enum tomexitcodes, const char *eventid) TOM_ATTRIB_NORET;
void tom_leave_after_error(int exitcode) TOM_ATTRIB_NORET;

	/* Access control check */
BOOLEAN acl_check(const char *filename, const char *username,
    UWORD userlevel, char typechar, const char **errortext);
void acl_invalidate_cachefile(const char *filename);

char * GetModeratorAddress(const char *group);

BOOLEAN senden_text(BOOLEAN pm, const char *ref_id,
    const char *p_empfaenger, const char *p_gruppe);

	/*
	 * Zurck zur uid der Quark.
	 */
void set_box_ids(void);
	/*
	 * und zur Benutzerkennung des aufrufenden Benutzers wechseln.
	 */
void set_user_ids(void);

int lock_loop(time_t timeout, time_t sleeptime, int sleepmode,
    const char *filename, int *fatal);
int lock_dev(const char *device, int unlock);

/* Versionsnummern ausgeben */
BOOLEAN print_version(int (*out_func)(const char *, ... ));



#endif
