#line 1 "quark-cnf.c4"
/* quark-cnf.c4 : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#line 34

#line 38
/* Diese Datei ist automatisch erzeugt. nderungen an confvars.m4 
 * und configfile.c4 vornehmen. */

/*
 * quark.cnf-Handling fr TOM.
 */

#include "portab.h"
#include "config.h" /* DEFAULT_QUARK_DIR */

#include <stdlib.h>
#include <stddef.h>
#include <limits.h>
#include <unistd.h>
#include <syslog.h>
#include <string.h>
#include <stdio.h>
#include <sys/stat.h>
#include <errno.h>

#include "conflib.h"
#include "box_conf.h"
#include "libquark.h"
#include "tompaths.h"
#include "argument.h"
#include "error.h"

static BOOLEAN check_config(void);
static void do_configure_defaults(void);

TOM_CONFIG box_conf;
const char *tom_info_net_dir = NULL;
const char *tom_info_lokal_dir = NULL;
const char *tom_tmp_dir = NULL;
const char *tom_utmp_dir = NULL;


/*
 * Configtabelle.
 */

static cl_var_t quarkconftab[]=
{
#line 61 "confvars.m4"
	{ 	"MausNetKennung", NULL, CL_STRING, &box_conf.mausnet_kennung, 0 , NULL},
#line 66
	{ 	"systemname", NULL, CL_STRING, &box_conf.systemname, 0 , NULL},
#line 71
	{ 	"DomainName", NULL, CL_STRING, &box_conf.domainname, 0 , NULL},
#line 76
	{ 	"MessageIdDomain", NULL, CL_STRING, &box_conf.msgid_domain, 0 , NULL},
#line 86
	{ 	"user-dir", NULL, CL_DIRNAME, &box_conf.user_dir, 0 , NULL},
#line 91
	{ 	"batch-dir", NULL, CL_DIRNAME, &box_conf.batch_dir, 0 , NULL},
#line 96
	{ 	"bin-dir", NULL, CL_DIRNAME, &box_conf.bin_dir, 0 , NULL},
#line 101
	{ 	"binbrett-dir", NULL, CL_DIRNAME, &box_conf.binbrett_dir, 0 , NULL},
#line 106
	{ 	"bretter-dir", NULL, CL_DIRNAME, &box_conf.bretter_dir, 0 , NULL},
#line 111
	{ 	"config-dir", NULL, CL_DIRNAME, &box_conf.config_dir, 0 , NULL},
#line 116
	{ 	"hilfe-dir", NULL, CL_DIRNAME, &box_conf.hilfe_dir, 0 , NULL},
#line 121
	{ 	"infofile-dir", NULL, CL_DIRNAME, &box_conf.infofile_dir, 0 , NULL},
#line 126
	{ 	"log-dir", NULL, CL_DIRNAME, &box_conf.log_dir, 0 , NULL},
#line 131
	{ 	"modules-dir", NULL, CL_DIRNAME, &box_conf.modules_dir, 0 , NULL},
#line 136
	{ 	"spool-dir", NULL, CL_DIRNAME, &box_conf.spool_dir, 0 , NULL},
#line 141
	{ 	"tausch-dir", NULL, CL_DIRNAME, &box_conf.tausch_dir, 0 , NULL},
#line 146
	{ 	"texte-dir", NULL, CL_DIRNAME, &box_conf.texte_dir, 0 , NULL},
#line 151
	{ 	"tmp-dir", NULL, CL_DIRNAME, &box_conf.tmp_dir, 0 , NULL},
#line 156
	{ 	"tcl-dir", NULL, CL_DIRNAME, &box_conf.tcl_dir, 0 , NULL},
#line 161
	{ 	"var-dir", NULL, CL_DIRNAME, &box_conf.var_dir, 0 , NULL},
#line 169
	{ 	"onlinefrom", NULL, CL_STRING, &box_conf.online_from, 0 , NULL},
#line 174
	{ "onlineto", NULL, CL_STRING, &box_conf.online_to, 0 , NULL},
#line 179
	{ "Level0Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[0], 0 , NULL},
#line 182
	{ "Level1Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[1], 0 , NULL},
#line 185
	{ "Level2Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[2], 0 , NULL},
#line 188
	{ "Level3Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[3], 0 , NULL},
#line 191
	{ "Level4Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[4], 0 , NULL},
#line 194
	{ "Level5Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[5], 0 , NULL},
#line 197
	{ "Level6Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[6], 0 , NULL},
#line 200
	{ "Level7Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[7], 0 , NULL},
#line 203
	{ "Level8Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[8], 0 , NULL},
#line 206
	{ "Level9Time", NULL, CL_NUMSHORT, &box_conf.onlinezeit[9], 0 , NULL},
#line 211
	{ "PaidAlwaysFulltime", NULL, CL_BOOLEAN, &box_conf.paid_fulltime, 0 , NULL},
#line 216
	{ "AnyBodyAlwaysFulltime", NULL, CL_BOOLEAN, &box_conf.anybody_fulltime, 0 , NULL},
#line 221
	{ "PaidExtraTime", NULL, CL_NUM, &box_conf.paid_extratime, 0 , NULL},
#line 226
	{ "PaidDownloadUnlimited", NULL, CL_BOOLEAN, &box_conf.paid_download_unlimited, 0 , NULL},
#line 231
	{ "nologin-device-file", NULL, CL_STRING, &box_conf.nologin_device_file, 0 , NULL},
#line 236
	{ "nologin-global-file", NULL, CL_STRING, &box_conf.nologin_global_file, 0 , NULL},
#line 244
	{ "cnf-file-name", NULL, CL_STRING, &box_conf.cnf_file_name, 0 , NULL},
#line 249
	{ "quark-dir", NULL, CL_DIRNAME, &box_conf.quark_dir, 0 , NULL},
#line 252
	{ "quarkdir", "quark-dir", CL_ALIAS, NULL, 0 , NULL},
#line 257
	{ "offline.cnf", NULL, CL_STRING, &box_conf.offline_cnf, 0 , NULL},
#line 262
	{ "system-user-name", NULL, CL_STRING, &box_conf.system_user_name, 0 , NULL},
#line 271
	{ "bad-password-prg", NULL, CL_STRING, &box_conf.bad_password_prg, 0 , NULL},
#line 276
	{ "SysStatSystemCmd", NULL, CL_STRING, &box_conf.sys_stat_system_cmd, 0 , NULL},
#line 281
	{ "BannerFile", NULL, CL_STRING, &box_conf.banner_file, 0 , NULL},
#line 286
	{ "Mailer-Daemon", NULL, CL_STRING, &box_conf.mailer_daemon, 0 , NULL},
#line 291
	{ "ViewUser", NULL, CL_BOOLEAN, &box_conf.view_user, 0 , NULL},
#line 296
	{ "LoginProtection", NULL, CL_STRING, &box_conf.login_protection, 0 , NULL},
#line 301
	{ "LoginTries", NULL, CL_NUM, &box_conf.login_tries, 0 , NULL},
#line 309
	{ "modemport", NULL, CL_STRING, &box_conf.modem_portname, 0 , NULL},
#line 314
	{ "modemspeed", NULL, CL_NUM, &box_conf.modem_speed, 0 , NULL},
#line 319
	{ "modemxonxoff", NULL, CL_BOOLEAN, &box_conf.modem_xonxoff, 0 , NULL},
#line 324
	{ "lockdir", NULL, CL_DIRNAME, &box_conf.lockdir, 0 , NULL},
#line 329
	{ "drainLines", NULL, CL_NUM, &box_conf.drain_lines, 0 , NULL},
#line 334
	{ "ModemInit", NULL, CL_STRING, &box_conf.modem_init, 0 , NULL},
#line 339
	{ "ModemRing", NULL, CL_STRING, &box_conf.modem_ring, 0 , NULL},
#line 344
	{ "ModemAnswer", NULL, CL_STRING, &box_conf.modem_answer, 0 , NULL},
#line 349
	{ "ModemHangup", NULL, CL_STRING, &box_conf.modem_hangup, 0 , NULL},
#line 354
	{ "ModemReset", NULL, CL_STRING, &box_conf.modem_reset, 0 , NULL},
#line 359
	{ "ModemActive", NULL, CL_STRING, &box_conf.modem_active, 0 , NULL},
#line 364
	{ "ModemDial", NULL, CL_STRING, &box_conf.modem_dial, 0 , NULL},
#line 369
	{ "ModemNoCar", NULL, CL_STRING, &box_conf.modem_nocarrier, 0 , NULL},
#line 374
	{ "ModemBusy", NULL, CL_STRING, &box_conf.modem_busy, 0 , NULL},
#line 379
	{ "ModemTakeoff", NULL, CL_STRING, &box_conf.modem_takeoff, 0 , NULL},
#line 384
	{ "ModemTstSnd", NULL, CL_STRING, &box_conf.modem_tst_snd, 0 , NULL},
#line 389
	{ "ModemTstRcv", NULL, CL_STRING, &box_conf.modem_tst_rcv, 0 , NULL},
#line 394
	{ "ModemSetBaud", NULL, CL_BOOLEAN, &box_conf.modem_set_baud, 0 , NULL},
#line 399
	{ "ModemDropDtr", NULL, CL_BOOLEAN, &box_conf.modem_drop_dtr, 0 , NULL},
#line 404
	{ "WaitConnect", NULL, CL_NUM, &box_conf.modem_connect_wartezeit, 0 , NULL},
#line 409
	{ "ModemSendsEcho", NULL, CL_BOOLEAN, &box_conf.modem_sends_echo, 0 , NULL},
#line 414
	{ "ModemGetCLID", NULL, CL_STRING, &box_conf.modem_get_clid, 0 , NULL},
#line 422
	{ "ASCIIEditor", NULL, CL_STRING, &box_conf.ascii_edit, 0 , NULL},
#line 427
	{ "ANSIEditor", NULL, CL_STRING, &box_conf.ansi_edit, 0 , NULL},
#line 432
	{ "VT52Editor", NULL, CL_STRING, &box_conf.vt52_edit, 0 , NULL},
#line 437
	{ "VT100Editor", NULL, CL_STRING, &box_conf.vt100_edit, 0 , NULL},
#line 442
	{ "LocalEditor", NULL, CL_STRING, &box_conf.cons_edit, 0 , NULL},
#line 447
	{ "TauschEditor", NULL, CL_STRING, &box_conf.tausch_editor, 0 , NULL},
#line 452
	{ "ColorChat", NULL, CL_BOOLEAN, &box_conf.color_chat, 0 , NULL},
#line 457
	{ "SysopCall", NULL, CL_STRING, &box_conf.sysop_call, 0 , NULL},
#line 462
	{ "ConsoleBesetzt", NULL, CL_BOOLEAN, &box_conf.console_besetzt, 0 , NULL},
#line 470
	{ "TauschDebugLevel", NULL, CL_NUM, &box_conf.tausch_debug_level, 0 , NULL},
#line 475
	{ "NewsAgeLimit", NULL, CL_NUM, &box_conf.news_age_limit, 0 , NULL},
#line 480
	{ "NewsYouthLimit", NULL, CL_NUM, &box_conf.news_youth_limit, 0 , NULL},
#line 485
	{ "AutoTauschAll", NULL, CL_BOOLEAN, &box_conf.auto_tausch_all, 0 , NULL},
#line 490
	{ "TauschMaxZahl", NULL, CL_NUM, &box_conf.tausch_max_zahl, 0 , NULL},
#line 495
	{ "TauschMaxKB", NULL, CL_NUM, &box_conf.tausch_max_kb, 0 , NULL},
#line 500
	{ "tausch-in-user-preprozessor", NULL, CL_STRING, &box_conf.tausch_in_user_preprozessor, 0 , NULL},
#line 505
	{ "tausch-out-user-postprozessor", NULL, CL_STRING, &box_conf.tausch_out_user_postprozessor, 0 , NULL},
#line 510
	{ "tausch-in-gate-preprozessor", NULL, CL_STRING, &box_conf.tausch_in_gate_preprozessor, 0 , NULL},
#line 515
	{ "tausch-out-gate-postprozessor", NULL, CL_STRING, &box_conf.tausch_out_gate_postprozessor, 0 , NULL},
#line 520
	{ "tausch-in-box-preprozessor", NULL, CL_STRING, &box_conf.tausch_in_box_preprozessor, 0 , NULL},
#line 525
	{ "tausch-out-box-postprozessor", NULL, CL_STRING, &box_conf.tausch_out_box_postprozessor, 0 , NULL},
#line 530
	{ "Async-Max-Spool", NULL, CL_NUM, &box_conf.async_max_spool, 0 , NULL},
#line 535
	{ "badmailfrom", NULL, CL_STRING, &box_conf.badmailfrom, 0 , NULL},
#line 543
	{ "KillInactiveDays", NULL, CL_NUM, &box_conf.kill_inactive_days, 0 , NULL},
#line 546
	{ "KillInactiveCalls", NULL, CL_NUM, &box_conf.kill_inactive_calls, 0 , NULL},
#line 551
	{ "GastFlashbackTime", NULL, CL_NUM, &box_conf.gast_flashback, 0 , NULL},
#line 556
	{ "DefaultGruppenChef", NULL, CL_STRING, &box_conf.default_chef, 0 , NULL},
#line 561
	{ "EinTeilUserNamen", NULL, CL_BOOLEAN, &box_conf.allow_one_part_usernames, 0 , NULL},
#line 566
	{ "OnePartUserNames", "EinTeilUserNamen", CL_ALIAS, NULL, 0 , NULL},
#line 571
	{ "Username-Extrachars", NULL, CL_STRING, &box_conf.username_extrachars, 0 , NULL},
#line 576
	{ "Username-Keepcase", NULL, CL_BOOLEAN, &box_conf.username_keepcase, 0 , NULL},
#line 581
	{ "ReloginForRelogins", NULL, CL_BOOLEAN, &box_conf.relogin_for_relogins, 0 , NULL},
#line 586
	{ "UploadTimeFree", NULL, CL_BOOLEAN, &box_conf.upload_free, 0 , NULL},
#line 591
	{ "ask-gast-antrag", NULL, CL_BOOLEAN, &box_conf.ask_newuser_userantrag, 0 , NULL},
#line 596
	{ "neuuser-protokoll", NULL, CL_BOOLEAN, &box_conf.neuuser_protokoll, 0 , NULL},
#line 601
	{ "catch-signals", NULL, CL_BOOLEAN, &box_conf.catch_signals, 0 , NULL},
#line 606
	{ "log-quality-level", NULL, CL_NUM, &box_conf.log_quality_level, 0 , NULL},
#line 611
	{ "log-quality-command", NULL, CL_STRING, &box_conf.log_quality_command, 0 , NULL},
#line 616
	{ "LoginTimeout", NULL, CL_NUM, &box_conf.login_timeout, 0 , NULL},
#line 621
	{ "UserTimeout", NULL, CL_NUM, &box_conf.user_timeout, 0 , NULL},
#line 626
	{ "WarnDiskSpace", NULL, CL_NUM, &box_conf.warn_diskspace, 0 , NULL},
#line 631
	{ "JunkGroup", NULL, CL_STRING, &box_conf.junk_group, 0 , NULL},
#line 636
	{ "default-moderator", NULL, CL_STRING, &box_conf.default_moderator, 0 , NULL},
#line 644
	{ "ascii-termcap", NULL, CL_STRING, &box_conf.ascii_termcap, 0 , NULL},
#line 649
	{ "vt52-termcap", NULL, CL_STRING, &box_conf.vt52_termcap, 0 , NULL},
#line 654
	{ "ansi-termcap", NULL, CL_STRING, &box_conf.ansi_termcap, 0 , NULL},
#line 659
	{ "vt100-termcap", NULL, CL_STRING, &box_conf.vt100_termcap, 0 , NULL},
#line 664
	{ "rsmtp-username", NULL, CL_STRING, &box_conf.rsmtp_username, 0 , NULL},
#line 669
	{ "rsmtp-spooler", NULL, CL_STRING, &box_conf.rsmtp_spooler, 0 , NULL},
#line 674
	{ "rsmtp-allow-vrfy", NULL, CL_BOOLEAN, &box_conf.rsmtp_allow_vrfy, 0 , NULL},
#line 679
	{ "rsmtp-allow-expn", NULL, CL_BOOLEAN, &box_conf.rsmtp_allow_expn, 0 , NULL},
#line 684
	{ "rsmtp-normal-timeout", NULL, CL_NUM, &box_conf.rsmtp_normal_timeout, 0 , NULL},
#line 689
	{ "rsmtp-data-timeout", NULL, CL_NUM, &box_conf.rsmtp_data_timeout, 0 , NULL},
#line 694
	{ "rsmtp-max-size", NULL, CL_NUM, &box_conf.rsmtp_max_size, 0 , NULL},
#line 699
	{ "default-brett", NULL, CL_STRING, &box_conf.default_brett, 0 , NULL},
#line 704
	{ "console-wildcard", NULL, CL_STRING, &box_conf.console_wildcard, 0 , NULL},
#line 709
	{ "modem-wildcard", NULL, CL_STRING, &box_conf.modem_wildcard, 0 , NULL},
#line 714
	{ "mmapMax", NULL, CL_NUM, &box_conf.mmap_max, 0 , NULL},
#line 719
	{ "console-init-prg", NULL, CL_STRING, &box_conf.console_init_prg, 0 , NULL},
#line 726
	{ "ti", NULL, CL_BOOLEAN, &box_conf.ti, 0 , NULL},
#line 85 "quark-cnf.c4"
	{ NULL, NULL, 0, NULL, 0, NULL}
};

void dump_quark_configuration(FILE *f)
{
	cl_writeconf(f,quarkconftab);
}

static void
do_configure_defaults(void)
{
#line 61 "confvars.m4"
	box_conf.mausnet_kennung="DEMO" ;
#line 66
	box_conf.systemname="quark.cnf: systemname fehlt" ;
#line 71
	box_conf.domainname="none.somewhere.earth.milkyway" ;
#line 76
	box_conf.msgid_domain="none.somewhere.earth.milkyway" ;
#line 86
	box_conf.user_dir=NULL ;
#line 91
	box_conf.batch_dir=NULL ;
#line 96
	box_conf.bin_dir=NULL ;
#line 101
	box_conf.binbrett_dir=NULL ;
#line 106
	box_conf.bretter_dir=NULL ;
#line 111
	box_conf.config_dir=NULL ;
#line 116
	box_conf.hilfe_dir=NULL ;
#line 121
	box_conf.infofile_dir=NULL ;
#line 126
	box_conf.log_dir=NULL ;
#line 131
	box_conf.modules_dir=NULL ;
#line 136
	box_conf.spool_dir=NULL ;
#line 141
	box_conf.tausch_dir=NULL ;
#line 146
	box_conf.texte_dir=NULL ;
#line 151
	box_conf.tmp_dir=NULL ;
#line 156
	box_conf.tcl_dir=NULL ;
#line 161
	box_conf.var_dir=NULL ;
#line 169
	box_conf.online_from="00:00" ;
#line 174
	box_conf.online_to="23:59";
#line 179
	box_conf.onlinezeit[0]=30 ;
#line 182
	box_conf.onlinezeit[1]=30 ;
#line 185
	box_conf.onlinezeit[2]=30 ;
#line 188
	box_conf.onlinezeit[3]=30 ;
#line 191
	box_conf.onlinezeit[4]=30 ;
#line 194
	box_conf.onlinezeit[5]=30 ;
#line 197
	box_conf.onlinezeit[6]=30 ;
#line 200
	box_conf.onlinezeit[7]=60 ;
#line 203
	box_conf.onlinezeit[8]=60 ;
#line 206
	box_conf.onlinezeit[9]=120 ;
#line 226
	box_conf.paid_download_unlimited=FALSE ;
#line 231
	box_conf.nologin_device_file=NULL ;
#line 236
	box_conf.nologin_global_file=NULL ;
#line 262
	box_conf.system_user_name="quark";
#line 286
	box_conf.mailer_daemon="MAILER-DAEMON";
#line 291
	box_conf.view_user=FALSE;
#line 296
	box_conf.login_protection="!";
#line 301
	box_conf.login_tries=3;
#line 314
	box_conf.modem_speed=19200;
#line 319
	box_conf.modem_xonxoff=FALSE;
#line 329
	box_conf.drain_lines=1;
#line 334
	box_conf.modem_init="ATZ";
#line 339
	box_conf.modem_ring="RING" ;
#line 344
	box_conf.modem_answer="ATA" ;
#line 349
	box_conf.modem_hangup="ATH0" ;
#line 354
	box_conf.modem_reset="ATZ" ;
#line 359
	box_conf.modem_active="+++";
#line 364
	box_conf.modem_dial="ATD";
#line 369
	box_conf.modem_nocarrier="NO CARRIER";
#line 374
	box_conf.modem_busy="BUSY" ;
#line 379
	box_conf.modem_takeoff="ATH1" ;
#line 384
	box_conf.modem_tst_snd="AT" ;
#line 389
	box_conf.modem_tst_rcv="OK" ;
#line 394
	box_conf.modem_set_baud=FALSE;
#line 399
	box_conf.modem_drop_dtr=TRUE;
#line 404
	box_conf.modem_connect_wartezeit=60 ;
#line 409
	box_conf.modem_sends_echo=TRUE;
#line 414
	box_conf.modem_get_clid=NULL;
#line 422
	box_conf.ascii_edit="lineedit" ;
#line 452
	box_conf.color_chat=TRUE;
#line 457
	box_conf.sysop_call=NULL;
#line 462
	box_conf.console_besetzt=TRUE;
#line 475
	box_conf.news_age_limit=21;
#line 480
	box_conf.news_youth_limit=12;
#line 485
	box_conf.auto_tausch_all=TRUE ;
#line 490
	box_conf.tausch_max_zahl=50 ;
#line 495
	box_conf.tausch_max_kb=100 ;
#line 500
	box_conf.tausch_in_user_preprozessor=NULL ;
#line 505
	box_conf.tausch_out_user_postprozessor=NULL ;
#line 510
	box_conf.tausch_in_gate_preprozessor=NULL ;
#line 515
	box_conf.tausch_out_gate_postprozessor=NULL ;
#line 520
	box_conf.tausch_in_box_preprozessor=NULL ;
#line 525
	box_conf.tausch_out_box_postprozessor=NULL ;
#line 530
	box_conf.async_max_spool=10000000;
#line 535
	box_conf.badmailfrom=NULL ;
#line 543
	box_conf.kill_inactive_days=90 ;
#line 546
	box_conf.kill_inactive_calls=30 ;
#line 551
	box_conf.gast_flashback=14;
#line 561
	box_conf.allow_one_part_usernames=FALSE ;
#line 576
	box_conf.username_keepcase=FALSE ;
#line 581
	box_conf.relogin_for_relogins=TRUE;
#line 586
	box_conf.upload_free=TRUE;
#line 591
	box_conf.ask_newuser_userantrag=TRUE;
#line 596
	box_conf.neuuser_protokoll=TRUE;
#line 601
	box_conf.catch_signals=TRUE;
#line 606
	box_conf.log_quality_level=1;
#line 611
	box_conf.log_quality_command=NULL;
#line 616
	box_conf.login_timeout=60 ;
#line 621
	box_conf.user_timeout=300 ;
#line 626
	box_conf.warn_diskspace=10*1024*1024L;
#line 644
	box_conf.ascii_termcap="dumb" ;
#line 649
	box_conf.vt52_termcap="vt52" ;
#line 654
	box_conf.ansi_termcap="ansi" ;
#line 659
	box_conf.vt100_termcap="vt100" ;
#line 674
	box_conf.rsmtp_allow_vrfy=TRUE;
#line 679
	box_conf.rsmtp_allow_expn=TRUE;
#line 684
	box_conf.rsmtp_normal_timeout=300 ;
#line 689
	box_conf.rsmtp_data_timeout=3600 ;
#line 694
	box_conf.rsmtp_max_size=1000000 ;
#line 714
	box_conf.mmap_max=1024*1024L;
#line 726
	box_conf.ti=TRUE ;
#line 99 "quark-cnf.c4"
}

BOOLEAN 
read_quark_configuration(const char *cnf_name)
{
	static BOOLEAN defaults_gesetzt=FALSE;
	cl_file_t *f;
	int ret;

	if (!defaults_gesetzt) {
		defaults_gesetzt=TRUE;
		do_configure_defaults();
	}

	f=cl_openconf(cnf_name, "r");
	if (!f) {
		syslog(LOG_ERR,"kann %s nicht lesen", cnf_name);
		return FALSE;
	}
	if (argument_check_configuration)
		f->report_unknown=TRUE;
	ret = cl_getstanza(f,quarkconftab,"quark", 0, NULL);
	if (!ret && argument_port) {
		const char *port;
		port=strrchr(argument_port,'/');
		if (port)
			port++;
		else
			port=argument_port;
		ret = cl_getstanza(f,quarkconftab,port, 0, NULL);
	}
	cl_closeconf(f);
	if (ret) {
		syslog(LOG_ERR,"kann Boxkonfiguration nicht lesen aus %s",cnf_name);
		return FALSE;
	}

	if (!check_config() && argument_check_configuration) {
		return FALSE;
	}
	if (*cnf_name!='/') {
		char tmp[PATH_MAX];
		getcwd(tmp,sizeof(tmp));
		strcat(tmp,"/");
		strcat(tmp,cnf_name);
		box_conf.cnf_file_name=XSTRDUP(tmp);
	}
	else
		box_conf.cnf_file_name=XSTRDUP(cnf_name);
	return TRUE;
}

#define SCHECK2(name,meckern,confvar,default) \
	if (!box_conf.name || !*box_conf.name) \
	{ \
		if (meckern) { meldungen++; \
			fprintf(stderr,"%s fehlt! Schlechter Default eingesetzt!\n",confvar); \
		} box_conf.name=default; \
	}

#define DIR_CHECK(name,default) \
	if (!box_conf.name || !*box_conf.name) {box_conf.name=XSTRDUP(default); \
		fprintf(stderr,"%s fehlt! Auf Default %s gesetzt!\n",#name,default); \
		meldungen++;}

#define CHECK_EXISTANCE(dir,name) \
	{ struct stat st; char *fi=concat(box_conf.dir,name,NULL); XNULLCHECK(fi);\
	  if (stat(fi,&st)==-1) {error(0,errno,"%s",fi); meldungen++;} \
	}

static BOOLEAN
check_config(void)
{
	int meldungen=0;
	if (!box_conf.quark_dir)
	{
		const char *p;
		fprintf(stderr,
			"Variable quark-dir nicht gesetzt. Auf Default gesetzt:\n"
			"%s\n", QUARKDIR);
		meldungen++;
		p=strrchr(QUARKDIR,'/');
		if (p && !p[1])
			box_conf.quark_dir=QUARKDIR;
		else
		{
			box_conf.quark_dir=concat(QUARKDIR,"/",NULL);
			XNULLCHECK(box_conf.quark_dir);
		}
	}
	SCHECK2(systemname,TRUE,"SystemName","kein name");
	SCHECK2(lockdir,TRUE,"LockDir",".");
	SCHECK2(domainname,TRUE,"DomainName","poor.configured.site");
	SCHECK2(ascii_termcap,argument_check_configuration,"ascii-termcap","dumb");
	SCHECK2(vt52_termcap,argument_check_configuration,"vt52-termcap","vt52");
	SCHECK2(vt100_termcap,argument_check_configuration,"vt100-termcap","vt100");
	SCHECK2(ansi_termcap,argument_check_configuration,"ansi-termcap","ansi");
	SCHECK2(default_chef,argument_check_configuration,
		"DefaultGruppenChef","Sysop");
	if (!box_conf.msgid_domain || !*box_conf.msgid_domain)
	{
		box_conf.msgid_domain=XSTRDUP(box_conf.domainname);
	}
#ifdef ALTE_VERZEICHNISSTRUKTUR
	DIR_CHECK(batch_dir,"tom/batch/");
	DIR_CHECK(bin_dir,"tom/bin/");
	DIR_CHECK(binbrett_dir,"tom/db/binaer/");
	DIR_CHECK(bretter_dir,"tom/db/text/");
	DIR_CHECK(config_dir,"tom/system/");
	DIR_CHECK(hilfe_dir,"tom/hilfe/");
	DIR_CHECK(infofile_dir,"tom/info/");
	DIR_CHECK(log_dir,"tom/log/");
	DIR_CHECK(modules_dir,"modules/");
	DIR_CHECK(spool_dir,"tom/spool/");
	DIR_CHECK(tausch_dir,"tom/tausch/");
	DIR_CHECK(texte_dir,"tom/text/");
	DIR_CHECK(tmp_dir,"tom/tmp/");
	DIR_CHECK(tcl_dir,"tom/bin/tcl/");
	DIR_CHECK(var_dir,"tom/system/");
	DIR_CHECK(user_dir,"tom/user/");
#else
	DIR_CHECK(batch_dir,"batch/");
	DIR_CHECK(bin_dir,"bin/");
	DIR_CHECK(binbrett_dir,"binaerbretter/");
	DIR_CHECK(bretter_dir,"bretter/");
	DIR_CHECK(config_dir,"config/");
	DIR_CHECK(hilfe_dir,"hilfe/");
	DIR_CHECK(infofile_dir,"infofile/");
	DIR_CHECK(log_dir,"log/");
	DIR_CHECK(modules_dir,"modules/");
	DIR_CHECK(spool_dir,"spool/");
	DIR_CHECK(tausch_dir,"tausch/");
	DIR_CHECK(texte_dir,"texte/");
	DIR_CHECK(tmp_dir,"tmp/");
	DIR_CHECK(tcl_dir,"tcl/");
	DIR_CHECK(var_dir,"var/");
	DIR_CHECK(user_dir,"user/");
#endif
	tom_info_net_dir=concat(box_conf.infofile_dir,"net/",NULL);
	tom_info_lokal_dir=concat(box_conf.infofile_dir,"lokal/",NULL);

	CHECK_EXISTANCE(var_dir,"user_2.dat");
	CHECK_EXISTANCE(var_dir,"brett.dat");
	CHECK_EXISTANCE(config_dir,"befehle.cnf");
	CHECK_EXISTANCE(config_dir,"infofile.cnf");
	CHECK_EXISTANCE(config_dir,"packer.cnf");
	CHECK_EXISTANCE(config_dir,"transfer.cnf");
	if (meldungen)
		return FALSE;
	return TRUE;
}

