/* set_vtmode.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "prototyp.h"
#include "modem.h"
#include "io.h"
#include "terminal.h"
#include "aktdata.h"
#include "box_conf.h"

extern WORD vtmodeW;


/*
 * vtmodeW setzen, Die Environmentvariable TERM mit vtmodeW abgleichen.
 */
void
set_vtmode(WORD neu)
{
	vtmodeW=neu;
	if (!akt_connection.is_console)
	{
		static char *s=NULL;
		const char *t;
		char *old;

		old=s;

		switch(vtmodeW)
		{
		case T_ASCII: t=box_conf.ascii_termcap; break;
		case T_VT100: t=box_conf.vt100_termcap; break;
		case T_ANSI:  t=box_conf.ansi_termcap; break;
		case T_VT52:  t=box_conf.vt52_termcap; break;
		default:
			error(0,0,"vtmodeW out of range in set_vtmode(): %d",
				(int) vtmodeW);
			return;
			break;
		}
		if (asprintf(&s,"TERM=%s",t)<=0) {
			error(0,0,"out of memory in set_vtmode() trying to set TERM=%s",t);
			return;
		}
		if (0==putenv(s)) {
			if (old)
				free(old);
		} else {
			error(0,0,"putenv(%s) failed",s);
			free(s);
		}
	}
}
