/* str2bflags.c: convert a string into brettflags.
    Copyright (C) 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>

#include "config.h"
#include "libquark.h"

#include "brett_db.h"


/*
BB_FUNCTION(Funktion,BOOLEAN,string_to_brettflags,
[[(const char *@var{string}, ULONG *@var{flags})]],[[
    Setzt fr jedes Zeichen in @var{s} das entsprechende Flag in
    @var{flags}. Liefert FALSE, wenn auch nur ein Zeichen unbekannt
    war (die anderen Zeichen werden aber trotzdem verarbeitet), 
    sonst TRUE.
]])
*/
BOOLEAN string_to_brettflags(const char *s, ULONG *flags)
{
	ULONG new=0;
	BOOLEAN ret=TRUE;
	while (s && *s)
	{
		switch(*s)
		{
		case 'A': new |= B_ANONYM; break;
		case 'G': new |= B_GEHEIM; break;
		case 'M': new |= B_MITGLIED; break;
		case 'P': new |= B_PASSWORT; break;
		case 'Z': new |= B_ZWANG; break;
		case 'D': new |= B_DEFAULT; break;
		case '$': new |= B_ZAHLER; break;
		case 'O': new |= B_MODERIERT; break;
		case 'C': new |= B_ACL; break;
		case 'E': new |= B_LESMITGLIED; break;
		case 'Y': new |= B_PAYWRITE; break;
		default:
			ret=FALSE;
			break;
		}
		s++;
	}
	if (flags)
		*flags=new;
	return ret;
}
