/* system.c : systemabhngige Funktionen, hier fehlplaziert da nicht
 * im sysdep/ verzeichnis
 */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de,  Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/


#include <portab.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>

#include "tomsysdep.h"
#include "prototyp.h"

#ifdef __TOS__
#include <tos.h>
#endif
#ifdef HAVE_SYS_STATFS_H
#include <sys/statfs.h>
#elif defined(HAVE_SYS_VFS_H)
#include <sys/vfs.h>
#elif defined(HAVE_SYS_MOUNT_H)
#include <sys/param.h>
#include <sys/mount.h>
#endif



/*
	CPU fr msec Millisekunden abgeben

	Wg. Seiteneffekten zwi. alarm() auf der einen und usleep/sleep auf 
	der anderen Seite mu hier unbedingt select() statt usleep() verwendet 
	werden. FB 18.1.97
	Auerdem ist select im Ggs. zu usleep multithreading-tauglich
	(mind. unter Solaris)
	Andererseits: "unter HP-UX 10.[12]0 fhrt der select-code zum Absturz"
	  (laut Frank)
*/
void msleep(long msec)
{
#ifdef hpux
	if (!msec)
		return;
	usleep(msec*1000);
#else
	struct timeval t;

	if (!msec)
		return;

	t.tv_sec = 0;
	t.tv_usec = msec * 1000L;
	select(0,NULL,NULL,NULL,&t);
#endif

} /* msleep */


#ifdef HAVE_DOSDRIVES
/*
	installierte Laufwerke eintragen
*/
void get_drives(char *drives)
{
#ifdef __TOS__
	long old_super_stack;
	int nr;

	old_super_stack = Super(NULL);

	*drives = 0;
	if (*(WORD *) 0x4A6 & 1)
		strcpy(drives,"A");
	else
	if (*(WORD *) 0x4A6 & 2)
		strcpy(drives,"AB");

	for(nr=2;nr<16;nr++)
		if (*(long *)0x4C2 & (1 << nr))
		{
			size_t len = strlen(drives);
			drives[len++] = 'A'+nr;
			drives[len]   = 0;
		}

	Super((void *) old_super_stack );
#endif
} /* get_drives */
#endif /* HAVE_DOSDRIVES */


#ifdef HAVE_DOSDRIVES
/*
	freien Speicher auf Laufwerk <nr> ermitteln

	25.02.93 Frank, neu

	Funktion mu auf OS/2 angepat werden.
*/
long bytes_free(int nr)
{
#ifdef __TOS__
	_DISKINFO diskinfo;

	Dfree(&diskinfo,nr);

	return diskinfo.b_free * diskinfo.b_clsiz * diskinfo.b_secsiz;
#endif /* __TOS__ */
} /* bytes_free */

#else /* !def HAVE_DOSDRIVES */
/*
	freien Speicher auf dem Pfad ermitteln 
	29.12.93, uwe, neu
*/
PATH_BYTES_FREE_TYPE 
path_bytes_free(const char *path)
{
	struct statfs buf;

	if (statfs(path,&buf))
	{
		/* Fehler aufgetreten - 0 zurckliefern */
		return 0L; /* XXX sloopy interface */
	}
#ifdef HAVE_STATFS_BAVAIL
		/* Erst die fr normaluser verfgbaren Bytes */
	if (buf.f_bavail != (long) -1)
		return ((PATH_BYTES_FREE_TYPE)buf.f_bavail) * buf.f_bsize;
#endif
		/* zur Not die fr alle freien Bytes */
	if (buf.f_bfree != (long) -1)
		return ((PATH_BYTES_FREE_TYPE)buf.f_bfree) * buf.f_bsize;
	return 0;
}
#endif /* HAVE_DOSDRIVES */



#if defined(__TOS__) && defined(__MINT__)
/* zeitaufwendige time zone Auswertung in Schleifen vermeiden */
void tzset(void)
{}
#endif
