/* ta_info_itk.c : generate ITK */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/

#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <syslog.h>
#include <ctype.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "aktdata.h"
#include "user.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"
#include "ta_cmd.h"

ULONG ta_info_itk (const char *fname, const char *dummy1, long dummy2)
{
	ULONG crc=0;
	FILE *f;
	ta_command_t *c;
	char *buf=XMALLOC(2048);
	size_t buflen=2048;

	if (!ta_cmd_init_done)
	{
		ta_cmd_init ();
		ta_cmd_init_done = TRUE;
	}

	f = xfopen (fname, BINWRITE);
	c = kommandos;

	while (c)
	{
		if (c->id != 0 && level() >= c->minlevel)
		{
			const char *s;

			fprintf(f,":#%d" LINEEND, c->id);
			crc+=c->id;
			fprintf(f,":V%d" LINEEND, c->version);
			crc+=c->version;
			fprintf(f,":T%s" LINEEND, c->typ);
			crc+=line_checksum(c->typ);
			fprintf(f,":N%s" LINEEND, c->name);
			crc+=line_checksum(c->name);
			fprintf(f,":H%s" LINEEND, c->kurzbeschreibung);
			crc+=line_checksum(c->kurzbeschreibung);
			fprintf(f,":G%s" LINEEND, c->kommandogruppe);
			crc+=line_checksum(c->kommandogruppe);

			s=buf;
			if (!do_interpret(c->definition, buf, buflen))
			{
				buflen*=2;
				buf=XREALLOC(buf,buflen);
				s=buf;
				if (!do_interpret(c->definition, buf, buflen))
					s=c->definition;
			}
			crc+=line_checksum(s);
			fprintf(f,"%s",s);
		}
		c=c->next;
	}
	fclose(f);
	free(buf);
	return crc &0x7fff;
}

