/* ta_trans.c : transfer-handling */
/*
    Copyright (C) 1993 1994 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
*/
#include "tomsysdep.h"

#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>

#include "prototyp.h"
#include "user.h"
#include "brett.h"
#include "modem.h"

#include "routing.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"

BOOLEAN
ta_infile_empfangen (char *infilename)
{
	struct dirent *dp;
	DIR *dir;
	long found;
	char c='\0';

	if (transfer_receive(&c,NULL,NULL))
	{
mbprintf("Protokoll %c beendet mit Fehler/Abbruch\r\n",ta_passinfo.protokoll);
		return FALSE;
	}
	ta_passinfo.protokoll=c;
mbprintf("Protokoll %c beendet\r\n",ta_passinfo.protokoll);

	/* Jetzt sollte irgendetwas im tmp-Ordner liegen */
	found = 0;
	dir = opendir (tom_utmp_dir);
	for (dp = readdir (dir); dp != NULL; dp = readdir (dir))
	{
		if (dp->d_name[0] == '.')
			continue;
		/* 
		   die folgenden als Infile erkennen
		   - infile (ohne ext.), infile.*
		   - tomaus, tomaus.*
		 */
		if (!strnicmp (dp->d_name, "infile.", 7)
			|| !strnicmp (dp->d_name, "anmaus.", 7))
		{
			/* Archiv mit Endung */
			found++;
			sprintf (infilename, "%s%s", tom_utmp_dir, dp->d_name);
		}
		if (!strnicmp (dp->d_name, "asi", 3))
		{
			/* Archiv mit Endung */
			found++;
			sprintf (infilename, "%s%s", tom_utmp_dir, dp->d_name);
		}
		if (!stricmp (dp->d_name, "infile")
			|| !stricmp (dp->d_name, "anmaus"))
		{
			/* Keine Endung, ->Textfile */
			found++;
			sprintf (infilename, "%s%s", tom_utmp_dir, dp->d_name);
		}
	}
	closedir (dir);

	if (!found)
	{
		mboutput ("\r\n Abbruch, da kein Infile upgeloaded wurde\r\n\n");
		return FALSE;
	}
	else if (found > 1)
	{
		mboutput ("\r\n Abbruch, da zu viele Dateien gefunden wurden\r\n\n");
		return FALSE;
	}
	return TRUE;

}								/* ta_infile_empfangen */
