/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <portab.h>
#include <errno.h>
#include <unistd.h>
#include <ctype.h>

#include "box_conf.h"
#include "prototyp.h" /* entumlauten */
#include "userbase.h"
#include "modem.h"

/*
 * Usernamen entumlauten, nach lowercase und "_" in Space wandeln, sowie
 * doppelte Spaces wandeln
 */
void
ub_canonical(const char *from, char *to)
{
	char *p,*q;
	char c;
	entumlauten(from,to);

	for (p=to,q=to; *p; p++)
	{
		c=*p;
		if (c=='_' || c=='\t')
			c=' ';
		else
			c=tolower(c);
		switch(c)
		{
		case ' ':
			if (q==to)
				continue; /* direkt am Anfang kein Space erlaubt */
			if (q[-1]==' ')
				continue; /* keine doppelten Spaces */
			*q++=' ';
			break;
		default:
			*q++=c;
			break;
		}
	}
	q--;  /* nun auf dem letzten Zeichen */
	while (q>=to && *q==' ')
		q--;
	q[1]='\0';
}
