/* usercl.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <portab.h>
#include <errno.h>
#include <unistd.h>
#include <ctype.h>

#include "box_conf.h"
#include "prototyp.h" /* entumlauten */
#include "user.h"
#include "modem.h"

BOOLEAN
check_username_syntax(const char *uname, BOOLEAN meckern)
{
	char work[UDAT_NAME_LEN*2];
	char *p;
	ub_canonical(uname,work);
	for (p=work;*p;p++)
	{
		/* Buchstaben und Zahlen sind erlaubt */
		if (isalnum(*p))
			continue; 
		switch(*p)
		{
		case '/': /* ? */
		case '+': /* ? */
		case '-': /* Bindestrich in Wrtern */
		case '_': /* Unterstrich in Wrtern */
		case ' ': /* Worttrenner */
			continue;
		default: 
			break;
		}
		if (box_conf.username_extrachars
			&& strchr(box_conf.username_extrachars,*p)
			&& !strchr("%@!:.",*p))
			continue;

		/* Niemals erlauben:
		 * % - wegen "%"-Hack im Router/Internet
		 * @ - Teilt Adresse in Localpart und Domain
		 @ ! - Bang-Adressierung im Internet.
		 * " - Soetwas gehrt eigentlich nicht in Usernamen.
		 * \ - Soetwas gehrt eigentlich nicht in Usernamen.
		 * | - Macht bestimmt irgendwo im Unixbereich rger.
		 * : - RFC-822(?) Sourceadressierung (@do.main:user@kiste.other.domain)
		 * . - macht ub_find_username nicht mit.
		 */
		if (meckern)
			mbprintf(" '%c'-Zeichen in Benutzernamen nicht erlaubt\r\n",*p);
		return FALSE;
	}
	return TRUE;
}
