/* userbase.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef USERBASE_H
#define USERBASE_H

#include <portab.h>
#ifndef __C2MAN__
#include <time.h>
#else
typedef int time_t;
#endif

	/* USERNR 0 ist illegal! */
#ifndef USERNR_TYPEDEF
#define USERNR_TYPEDEF
typedef LONG USERNR;
#endif

	/* NEUTRUM == Fremdbox, Gateway o.a. */
typedef enum {UTYP_USER,UTYP_GATE,UTYP_BOX} USERTYP;

	/* NEUTRUM == Fremdbox, Gateway o.a. */
typedef enum {NEUTRUM,MAENNLICH,WEIBLICH} GESCHLECHT;

	/* Was soll die Uhr anzeigen? Restzeit/vergangene Zeit/nichts? */
typedef enum {UHR_AUS,UHR_REST,UHR_NORMAL, UHR_ZEIT} UHRMODUS;

	/* Quark- oder Mausoberflaeche */
typedef enum {QUARK_STYLE,MAUS_STYLE,DIALOG_STYLE} BOXSTYLE;

typedef enum {PW_UNENCODED, PW_MD5} PW_ENCODING;

#define ULV_MIN		0
#define ULV_MAX		9
#define ULV_GAST		ULV_MIN
#define ULV_NEU		1
#define ULV_SYSOP		ULV_MAX

/********************************************************************
 * Globale Variablen
  ********************************************************************/

extern ULONG ub_userzahl;   /* Anzahl Userdatensaetze in der Datenbank */

/********************************************************************
 * Struktur USER
 ********************************************************************/

typedef struct
{
	UWORD fg_col;
	UWORD dummy1; /* bg_col */
	UWORD dummy2;

} TERM_COLATT; /* Colors & Attributes */


#define UDAT_NAME_LEN	64
#define UDAT_PW_LEN		20
#define UDAT_ANS_LEN		70
#define UDAT_COMP_LEN	20
#define UDAT_TEL_LEN		20
#define UDAT_STRA_LEN	40
#define UDAT_PLZ_LEN		10
#define UDAT_ORT_LEN		40

#define UB_FLAG_AUTO_RESIZE    0x01
#define UB_FLAG_READLINE       0x02
#define UB_FLAG_PROMI          0x04
#define UB_FLAG_IMMER_AEXPIRE  0x08 /* immer zeitlich beschrnkt gltige Adressen erzeugen */

	/* Strings sind als char-Arrays abgelegt.
	 * maximale Laenge ist UDAT_*_LEN inkl. abschliessendem '\0'
	 */
typedef struct
{
	/* Verwaltungstechnischer Kram */
	USERNR nummer;             /* Auf ewig eindeutige ID-Nummer */
	ULONG magic;               /* war: Index der Userdaten in der DB */
	char name[UDAT_NAME_LEN];  /* Der Name des Benutzers */

	LONG obsolete3;            /* war: Vertreter */
	long obsolete8;            /* war: Index fuer Gates/Boxen (s. route.cnf) */
	BOOLEAN geloescht;         /* Flag, ob User geloescht. Internal use only */

	BOOLEAN bezahlt;           /* TRUE -> bezahlt. Wird beim Laden aus dem
	                            * bezahlt_bis-Datum gesetzt.
	                            */
	time_t bezahlt_bis;        /* Zeitpunkt, an dem Zahlerstatus ablaeuft */
	long obsolete4;            /* war: Kontostand in Pfennigen */
	long obsolete5;            /* war: max. Onlinezeit pro Tag in SEKUNDEN */
	long restzeit;             /* und heute nur noch ... Sekunden */
	UWORD obsolete13;          /* war: Zone, Ort, Nah, Fern ... 0-3 */
	UWORD level;               /* 0..9 */
	time_t letzter_login;      /* Datum/Uhrzeit letzter Login */
	time_t letzter_login2;     /* Und vorletzter Login */
	time_t letzter_login3;     /* Und vorvorletzter Login */
	BOOLEAN auto_status;       /* autom. Gelesen+Zurueckgest. generieren ? */

	/* persoenlicher Kram */
	char passwort[UDAT_PW_LEN];/* _noch_ unverschluesselt */
	time_t passwortdatum;      /* 0 -> nicht kontrollieren */
	UWORD geburtsjahr;         /* ### Warum nicht struct tm */
	UWORD geburtsmonat;
	UWORD geburtstag;
	GESCHLECHT geschlecht;
	char ansage[UDAT_ANS_LEN]; /* Ansagetext des Benutzers */
	char telefon[UDAT_TEL_LEN];/* Telefonnummer */
	char plz[UDAT_PLZ_LEN];    /* Postleitzahl */
	char ort[UDAT_ORT_LEN];    /* Land und Ort */
	char strasse[UDAT_STRA_LEN];/* Strasse inclusive Hausnummer */

	/* technischer Kram - Bildschirm und Heimatrechner */	
	UWORD mehr;                /* Zeilen bis mehr, 0 -> kein "mehr" */
	UWORD bs_zeilen;           /* Zeilen auf Bildschirm */
	UWORD bs_spalten;          /* Zeichen pro Zeile ONLINE, nicht Tausch! */
	UWORD terminal_typ;        /* Der Terminaltyp, siehe defines */
	TERM_COLATT colatt[16];    /* Farb- und Attributeinstellungen */
	char computer[UDAT_COMP_LEN]; /* texttuelle Beschreibung des Computers */
	UWORD computertyp;         /* und Kategorie */

	WORD obsolete1;            /* war: "umlaute" */
	UBYTE obsolete2[8];	       /* war: Umlautstring */

	/* Statistikdaten */
	time_t erster_login;       /* Solange weilt er schon bei uns */
	ULONG anrufe;              /* Anzahl der Anrufe */
	ULONG geschriebene_mails;  /* Anzahl der geschriebenen Mails */
	ULONG obsolete9;           /* war: Anzahl der gelesenen Mails */
	ULONG uploads;             /* Anzahl der Uploads */
	ULONG ul_bytes;            /* Anzahl der Bytes dabei */
	ULONG downloads;           /* Anzahl der Downloads */
	ULONG dl_bytes;            /* Anzahl der gesaugten Bytes */
	ULONG txt_bytes;           /* Bytes an geschriebener Mail */
	ULONG obsolete10;          /* war: baudrate letzter Login, ungenutzt */

	/* Flags */
	UHRMODUS uhrmodus;         /* UHR_AUS, UHR_REST, UHR_NORMAL */
	BOOLEAN obsolete7;         /* war: 0 -> Box-Neutext nicht gelesen */
	BOXSTYLE box_stil;         /* QUARK_STYLE oder MAUS_STYLE */
	UWORD menue_stil;          /* FALSE -> kurz, 1-> lang */
	BOOLEAN glocke;            /* FALSE -> keine Glocke */
	UWORD adresse_frei;        /* Adressedaten fuer die Allgemeinheit frei? */
	BOOLEAN gast_upload;       /* Gastupload in den pers. Progteil erlaubt? */
	UWORD auflisten;           /* Soll der Benutzer in Listen auftauchen? */
	UWORD obsolete11;          /* war: erstes_rundschreiben */
	BOOLEAN autohilfe;         /* automatisch Hilfe bei Fehlern anzeigen? */
	BOOLEAN autobefehl;        /* Befehlsvervollstaendigung aktiv? */
	BOOLEAN protokoll;         /* Eingaben protokollieren? */
	int zeichensatz;           /* ID des Zeichensatzes oder 0 */
	int obsolete6;             /* war "int zeichensatzwandlung */
	BOOLEAN obsolete12;        /* war zeichensatzwandlung aktiv */
	BOOLEAN pflicht_befreit;   /* Pflichtgruppen abbestellbar? */
	
	char vertreter[UDAT_NAME_LEN];/* Der Name des Vertreters */
	USERTYP typ;                  /* User, Gate, Box */

	PW_ENCODING pw_encoding;   /* Art der Kodierung */
	char default_protokoll;    /* Dumme Idee, die viele nhnger hat. */
	BOOLEAN auto_grp_create;   /* neue Gruppen automatisch anlegen */
	long assigned_uid;         /* uid in Passwd - fr Shelluser */
	long flags; /* diverse Flags */

	ULONG async_max_spool;     /* maximalgroesse der vorgespoolten Nachrichten */
	ULONG address_hash_secret; /* Spamschutz */
	ULONG address_hash_expire; /* Spamschutz: Wieviele Tage ist eine Adresse gltig */

/* 512 Bytes sollten ausreichen, 1024 werden benutzt. */

} USER;


/********************************************************************
 * Bei Programmstart geladene Liste aller User (nur fuer interne Zwecke !)
 ********************************************************************/

typedef struct LISTUSERstruct
{
	USERNR nummer;			/* eindeutig! */
	char *name;				/* Was wohl? */
	struct LISTUSERstruct *next;
} LISTUSER;

/********************************************************************
 * Globale Funktionen
 ********************************************************************/

/* ub_init: Initialisiert die Userdatenbank.
 * Return: FALSE -> Konnte nichts laden (-> Programm beenden)
 */
BOOLEAN ub_init(
	const char *path /* Verzeichnis, in dem user.dat steht */ );

	/* aufraeumen, derzeit dummy */
BOOLEAN ub_exit(void);

/*
 * Userliste Client/Server-tauglich durchlaufen
 * 07.10.93 Frank
 * ->		<-	next	:	Puffer fuer Userstruktur
 *
 *	<-			TRUE	:	weiterer User in <next>
 *				FALSE	:	Ende der Userliste erreicht
 *
 * Der Aufrufer initialisiert nur die Usernummer der Struktur und bekommt 
 * dann die Userstruktur der naechsthoeheren Usernummer zurueck.
 * Durch die Uebertragung der gesamten Struktur anstelle der Nummern kann 
 * ein nachfolgendes ub_read_user vom Anforderer aus eingespart werden.
 *
 * Diese Funktion ist im Multiportbetrieb garantiert langsam.
 */
BOOLEAN ub_walk_user(
	USER *next /* Puffer fuer die Userstruktur, Usernummer initialisiert */);

/* Liefert einen Zeiger auf den Kopf der internen Liste zurueck. 
 * Diese Liste ist die Userliste des Clients, und moeglicherweise
 * eine ganz andere als die des Servers (damit kann man aber leben, 
 * alles ist besser als ub_walk_user staendig zu benutzen).
 */
LISTUSER *ub_get_first(void);

/* Liefert einen Zeiger auf das Listenelement zurueck. Darf benutzt 
 * werden, um schnell an den Namen eines Users zu kommen.
 */
LISTUSER *ub_find_usernummer(
	USERNR nr /* Nummer des gewuenschten Users */ );

/*
 * User anlegen
 *
 *	->			new	:	komplett initialisierte Userdatenstruktur
 *							(Usernummer MUSS 0 sein)
 *
 *	<-			TRUE	:	User wurde angelegt
 *				FALSE	:	Speichermangel oder User bereits vorhanden
 *
 *	Die Usernummer wird von dieser Funktion vergeben und zurueckgeliefert
 * Der Server prueft, ob der Username nicht doch schon existiert.
 */
BOOLEAN ub_create_user(USER *new /* Daten des neuen Users */ );

/*
 * User loeschen
 * 13.10.1993 Frank
 *
 *	->			nr		:	interne Usernummer
 *
 *	<-			TRUE	:	Erfolg
 *				FALSE	:	User existiert nicht oder ist gelockt
 *
 */
BOOLEAN ub_remove_user(USERNR nr /* Nummer des zu loeschenden Users */ );

/*
	Usernummer zu einem Usernamen ermitteln. Username kann auch irgendeine
	Abkuerzung sein. Dies ist die Funktion, die alle Abkuerzungen aufloest!
	Vom Benutzer eingegebene Namen sollten daher durch diese Funktion
	aufgeloest werden und dann der wirkliche Name des Users ueber 
	ub_find_usernummer oder ub_read_user geholt und weiterverwendet 
	werden.
	Return:   TRUE	:	User vorhanden
	          FALSE	:	User nicht vorhanden
*/
BOOLEAN ub_find_username(
	USERNR *nr,     /* darin wird die Nummer des Users zurueckgeliefert */
	const char *s   /* zu suchender Username */ );

/*
 * Ermittelt alle Usernummern, die zu einem Namen (Wildcardausdruck,
 * Abkrzung passen. Ist only_one TRUE, wird nur der erste gefundene
 * Name zurckgeliefert (dieser Modus ist zum Gebrauch durch 
 * ub_find_username bestimmt).
 * ist only_one FALSE, wird ein Array zurckgeliefert. Das letzte Element
 * ist eine 0. Das Array ist dynamisch alloziert und mu von der 
 * aufrufenden Funktion gefree()d werden.
 */
USERNR *ub_find_username_multi(
	const char *s   /* zu suchender Username */,
	BOOLEAN only_one /* Flag */ );

/*
 * Einen Benutzernamen in die canonische Form bringen, d.h.:
 * - Tabs und _ durch Spaces ersetzen.
 * - keine Spaces am Anfang und Ende
 * - entumlauten
 * - doppelte Spaces killen.
 * Sinn und Zweck ist, strcmp anwenden zu koennen.
 */
void ub_canonical(
	const char *from,  /* umzuwandelnder Name */
	char *to           /* Ergebnis, nun canonischer Name */ );

/*
 * Einen Benutzernamen in die canonische Form fr Dateisysteme 
 * bringen, d.h.:
 * - Spaces und Tabs durch _ ersetzen.
 * - keine _ am Anfang und Ende
 * - entumlauten
 * - doppelte _ killen.
 * Sinn und Zweck ist, Dateinamen bilden zu knnen.
 */
void ub_canonical_underscore(
	const char *from,  /* umzuwandelnder Name */
	char *to           /* Ergebnis, nun canonischer Name */ );


/* Legt eine neue Userdatei ohne Ruecksicht auf Verluste an.
 * Achtung: Um das sinnvoll durchfuehren zu koennen, muss
 * ub_init(path) schon aufgerufen worden sein
 */
BOOLEAN ub_create_user_dat(void);

/*
 * User <nr> einlesen und ggf. fuer weitere Zugriffe sperren
 * 
 * ->   nr    : Usernummer
 * <-   new   : initialisierte Userstruktur
 *      lock  : Zugriffssperre (bei TRUE)
 *
 * <-   TRUE  : Userstruktur konnte initialisiert werden
 *      FALSE : Fehler (z.B. ungueltige Usernummer)
 */
BOOLEAN ub_read_user(USERNR nr,USER *new,BOOLEAN lock);

/*
 * Userdatensatz schreiben und optional Schreibsperre aufheben
 *
 *	->			u			:	Userstruktur
 *				unlock	:	Schreibsperre aufheben
 *
 *	<-			TRUE		:	Erfolg
 *				FALSE		:	Fehler (z.B. keine Schreibberechtigung)
 */
BOOLEAN ub_write_user(USER *u,BOOLEAN unlock);
BOOLEAN ub_unlock_user(USERNR nr);

    /*
     * Die Eingabe vergleichen, ob sie mit dem Passwort uebereinstimmt.
     * Return: TRUE  -> Passwoerter sind gleich
     *         FALSE -> Sie sind es nicht,
     */
BOOLEAN passwort_vergleich(USER *work, const char *eingabe);

	/*
	 * Die eigentliche Verschlsselungsroutine. Steht hier, weil der
	 * Tausch sie braucht.
	 */
void passwort_crypt(char *crypted, const char *uncrypted,
    USERNR unr, PW_ENCODING pw_encoding);


#endif
