/* version.c : print out version numbers */
/*
    Copyright (C) 1997 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"
#include <portab.h>
#include <stdio.h>
#include <conflib.h>
#include "prototyp.h"
#include "modem.h"
#include "offline/mdb_glob.h"

#include "patches.h"

BOOLEAN
print_version(int (*out_func)(const char *, ... )) 
{
	int i;

	out_func("TOM %s (#%s) %s %s\r\n", VERSION,
		vstr_compileversion, vstr_date,vstr_time);
	out_func("offline %d, conflib %d\r\n",mdb_version(), cl_getversion());

	if(sizeof(patches)) {
		int numpatches=sizeof(patches)/sizeof(char *);
		out_func("*** Installierte Patches:\r\n");

		for(i=0; i < numpatches; i++)
			out_func("%s\r\n", patches[i]);

		out_func("*** Ende der Patches\r\n");
	}
	return TRUE;
}

