/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include "config.h"

#ifdef HAVE_UNISTD_H
#  include <unistd.h>
#endif
#ifdef STDC_HEADERS
#  include <stddef.h>
#endif
#include <errno.h>

#include "libquark.h"

ssize_t
xread(int fd, void *data, size_t bytes)
{
	int    count;
	ssize_t total=(ssize_t) bytes;
	char *pos=data;

	while (bytes) {
		count=read(fd,pos,(size_t) bytes);
		if (count<=0) {
			if (count==0)
				return (pos- (char *)data);
#ifdef EINTR
			if (errno!=EINTR)
#endif
				return -1;
		} else {
			pos+=count;
			bytes-=count;
		}
	}
	return total;
}

